AchievementShowWindow = class(Turbine.UI.Window)
function AchievementShowWindow:Constructor()
    Turbine.UI.Window.Constructor(self)
    self:SetBackColor(Turbine.UI.Color(0, 0, 0))
    self:SetVisible(true)

    self.widthMidPanes = 7
    self.heightMidPanes = 4

    self.width = 113 + 122 + self.widthMidPanes * 74
    self.height = 43 + 51 + 95 * self.heightMidPanes

    self:SetPosition(Turbine.UI.Display.GetWidth() / 2 - self.width / 2, Turbine.UI.Display.GetHeight() / 2 - self.height / 2)

    self:SetSize(self.width, self.height)

    self.currentMode = "Recent"

    self.achievementScore = {
		Novice = 10,
		Intermediate = 20,
		Experienced = 30,
		Master = 40,
		Grandmaster = 50,
	}

    self.MouseDown = function(sender,args)
        self.MoveX = args.X
        self.MoveY = args.Y
        self.Moving = true
    end
  
    self.MouseUp = function()
        self.Moving = false
    end
  
    self.MouseMove = function(sender,args)
        if self.Moving then
          local newLeft = self:GetLeft() - (self.MoveX - args.X)
          local newTop = self:GetTop() - (self.MoveY - args.Y)
          self:SetPosition(newLeft,newTop)
        end
    end

    -- wing circle 0x410F83CC; Size: 54 × 62;
    -- twirly 0x410FF0D2; Size: 50 × 72;
    -- twirly  0x410FF0D3; Size: 50 × 72;

    -- left 0x410FB1A7 113 × 43;
    -- mid  0x410FB1A8 74 × 43;
    -- right 0x410FB1A9 122 × 43;

    -- mleft 0x410FB1AA; Size: 113 × 95;
    -- mmid 0x410FB1AB; Size: 74 × 95;
    -- mright 0x410FB1AC; Size: 122 × 95;

    -- bleft 0x410FB1AD; Size: 113 × 51;
    -- bmid 0x410FB1AE; Size: 74 × 52;
    -- bright 0x410FB1AF; Size: 122 × 51;

    -- left 0x410FB1A7 113 × 43;
    self.topLeft = Turbine.UI.Control()
    self.topLeft:SetParent(self)
    self.topLeft:SetMouseVisible(false)
    self.topLeft:SetSize(113, 43)
    self.topLeft:SetBackground(0x410FB1A7)
    self.topLeft:SetPosition(0, 0)

    -- mid  0x410FB1A8 74 × 43;
    self.topmid = Turbine.UI.Control()
    self.topmid:SetParent(self)
    self.topmid:SetMouseVisible(false)
    self.topmid:SetSize(74 * self.widthMidPanes, 43)
    self.topmid:SetBackground(0x410FB1A8)
    self.topmid:SetPosition(113, 0)

    -- right 0x410FB1A9 122 × 43;
    self.topright = Turbine.UI.Control()
    self.topright:SetParent(self)
    self.topright:SetMouseVisible(false)
    self.topright:SetSize(122, 43)
    self.topright:SetBackground(0x410FB1A9)
    self.topright:SetPosition(113 + 74 * self.widthMidPanes, 0)

    -- mleft 0x410FB1AA; Size: 113 × 95;
    self.topLeft = Turbine.UI.Control()
    self.topLeft:SetParent(self)
    self.topLeft:SetMouseVisible(false)
    self.topLeft:SetSize(113, 95 * self.heightMidPanes)
    self.topLeft:SetBackground(0x410FB1AA)
    self.topLeft:SetPosition(0, 43)

    -- mmid 0x410FB1AB; Size: 74 × 95;
    self.topLeft = Turbine.UI.Control()
    self.topLeft:SetParent(self)
    self.topLeft:SetMouseVisible(false)
    self.topLeft:SetSize(74 * self.widthMidPanes, 95 * self.heightMidPanes)
    self.topLeft:SetBackground(0x410FB1AB)
    self.topLeft:SetPosition(113, 43)

    -- mright 0x410FB1AC; Size: 122 × 95;
    self.topLeft = Turbine.UI.Control()
    self.topLeft:SetParent(self)
    self.topLeft:SetMouseVisible(false)
    self.topLeft:SetSize(122, 95 * self.heightMidPanes)
    self.topLeft:SetBackground(0x410FB1AC)
    self.topLeft:SetPosition(113 + 74 * self.widthMidPanes, 43)

    -- bleft 0x410FB1AD; Size: 113 × 51;
    self.bottomLeft = Turbine.UI.Control()
    self.bottomLeft:SetParent(self)
    self.bottomLeft:SetMouseVisible(false)
    self.bottomLeft:SetSize(113, 51)
    self.bottomLeft:SetBackground(0x410FB1AD)
    self.bottomLeft:SetPosition(0, 43 + 95 * self.heightMidPanes)

    -- bmid 0x410FB1AE; Size: 74 × 52;
    self.bottomMid = Turbine.UI.Control()
    self.bottomMid:SetParent(self)
    self.bottomMid:SetMouseVisible(false)
    self.bottomMid:SetSize(74 * self.widthMidPanes, 52)
    self.bottomMid:SetBackground(0x410FB1AE)
    self.bottomMid:SetPosition(113, 43 + 95 * self.heightMidPanes)

    -- bright 0x410FB1AF; Size: 122 × 51;
    self.bottomRight = Turbine.UI.Control()
    self.bottomRight:SetParent(self)
    self.bottomRight:SetMouseVisible(false)
    self.bottomRight:SetSize(122, 51)
    self.bottomRight:SetBackground(0x410FB1AF)
    self.bottomRight:SetPosition(113 + 74 * self.widthMidPanes, 43 + 95 * self.heightMidPanes)

    -- lheader 0x410DDF16; Size: 76 × 39;
    -- mheader 0x410DDF17; Size: 66 × 39;
    -- rheader 0x410DDF18; Size: 77 × 39;

    self.lheader = Turbine.UI.Window()
    self.lheader:SetParent(self)
    self.lheader:SetVisible(true)
    self.lheader:SetMouseVisible(false)
    self.lheader:SetSize(76, 39)
    self.lheader:SetBackground(0x410DDF16)
    self.lheader:SetPosition(self.width / 2 - 351/2, 25)

    self.mheader = Turbine.UI.Window()
    self.mheader:SetParent(self)
    self.mheader:SetVisible(true)
    self.mheader:SetMouseVisible(false)
    self.mheader:SetSize(66 * 3, 39)
    self.mheader:SetBackground(0x410DDF17)
    self.mheader:SetPosition(self.width / 2 - 351/2 + 76, 25)

    self.mcheader = Turbine.UI.Label()
    self.mcheader:SetParent(self.mheader)
    self.mcheader:SetVisible(true)
    self.mcheader:SetMouseVisible(false)
    self.mcheader:SetSize(66 * 3, 33)
    self.mcheader:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.mcheader:SetFont(Turbine.UI.Lotro.Font.TrajanProBold24)
    self.mcheader:SetOutlineColor(Turbine.UI.Color.Black)
    self.mcheader:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.mcheader:SetForeColor(Turbine.UI.Color(0.73,0.68,0.36))
    self.mcheader:SetText("Achievements")

    self.rheader = Turbine.UI.Window()
    self.rheader:SetParent(self)
    self.rheader:SetVisible(true)
    self.rheader:SetMouseVisible(false)
    self.rheader:SetSize(77, 39)
    self.rheader:SetBackground(0x410DDF18)
    self.rheader:SetPosition(self.width / 2 - 351/2 + 66 + 66 + 66 + 76, 25)


    self.achievementListBoxBackground = AchievementListBox(64 * 4 - 6, 300)
    self.achievementListBoxBackground:SetParent(self)
    self.achievementListBoxBackground:SetPosition(42, 130)

    self.achievHeader = AchievementHeader3("Categories", 64 * 4)
    self.achievHeader:SetParent(self)
    self.achievHeader:SetPosition(40, 100)

    self.categoryListbox = Turbine.UI.ListBox()
    self.categoryListbox:SetParent(self)
    self.categoryListbox:SetSize(64 * 4 - 6, 300 - 10)
    self.categoryListbox:SetPosition(42, 140)

    self.scoreHeader1 = AchievementScoreHeader("Achievement Score: 100", 170)
    self.scoreHeader1:SetParent(self)
    self.scoreHeader1:SetPosition(90, 60)

    self.scoreHeader2 = AchievementScoreHeader("Achievement Score: 100", 170)
    self.scoreHeader2:SetParent(self)
    self.scoreHeader2:SetPosition(self.width - 90 - 170, 60)

    self.categories = {"Recent", "Colour Game", "Deaths", "Misadventure", "Creep", "Freep" }

    for key, value in pairs(self.categories) do
        local header = AchievementListBoxHeader2(value, function()
            self.currentMode = value
            self:FillAchievements()
        end)

        self.categoryListbox:AddItem(header)
    end

    --self.achievementsBoxBackground = AchievementListBox(400 - 8, 300)
    --self.achievementsBoxBackground:SetParent(self)
    --self.achievementsBoxBackground:SetPosition(302, 130)

    self.achievHeader = AchievementHeader3(self.currentMode, 400)
    self.achievHeader:SetParent(self)
    self.achievHeader:SetPosition(300, 100)

    self.achievementListbox = Turbine.UI.ListBox()
    self.achievementListbox:SetParent(self)
    self.achievementListbox:SetSize(400 - 10, 300 - 9)
    self.achievementListbox:SetPosition(305, 140 - 3)



    self.achievementScrollbar = Turbine.UI.Lotro.ScrollBar()
    self.achievementScrollbar:SetParent(self)
    self.achievementScrollbar:SetPosition(1000 + 305 + 390, 140)
    self.achievementScrollbar:SetSize(10, 300)
    self.achievementScrollbar:SetOrientation(Turbine.UI.Orientation.Vertical)
    self.achievementListbox:SetVerticalScrollBar(self.achievementScrollbar)

    --0x41164700; Size: 16 × 16;
    self.closeButton = Turbine.UI.Button()
    self.closeButton:SetParent(self)
    self.closeButton:SetVisible(true)
    self.closeButton:SetSize(16, 16)
    self.closeButton:SetBackground(0x41164700)
    self.closeButton:SetPosition(self.width - 55, 30)

    self.closeButton.Click = function()
        self:SetVisible(false)
    end

    self:FillAchievements()

    self.VisibleChanged = function()
        if self:IsVisible() then
            self:FillAchievements()
        end

    end
end

function AchievementShowWindow:FillAchievements()
    self.achievementListbox:ClearItems()

    local achievmeentData = AchievementHandler:GetAchievementsDone()
    local achievementInfo = AchievementHandler:GetAchievementData()

    self.achievHeader.mcheader:SetText(self.currentMode)

    if achievmeentData then

        local score = 0
        for key, value in pairs(achievmeentData) do
            score = score + self.achievementScore[value.Difficulty]
        end

        self.scoreHeader1.label:SetText(string.format("Achievements Completed: %s", Tablelength(achievmeentData)))
        self.scoreHeader2.label:SetText(string.format("Achievement Score: %s", score))

        if self.currentMode == "Recent" then
            local number = 0
            for key, value in spairs(achievmeentData, function(t, a, b) return self:CompareDates(t[a].CompletionData, t[b].CompletionData) end) do
                if number < 3 then
                    self.achievementListbox:AddItem(AchievementItem(key, value, achievementInfo[key], self.achievementListbox:GetWidth()- 5, 100))
                    number = number + 1
                end
            end 
        else
            for key, value in pairs(achievmeentData) do
                if value.Category == self.currentMode then
                    self.achievementListbox:AddItem(AchievementItem(key, value, achievementInfo[key], self.achievementListbox:GetWidth()- 5, 100))
                end
            end 
        end
    end
end

function AchievementShowWindow:CompareDates(date1, date2)
    return
        tonumber(date1.Year) < tonumber(date2.Year) or
        tonumber(date1.Year) < tonumber(date2.Year) and tonumber(date1.Month) < tonumber(date2.Month) or
        tonumber(date1.Year) < tonumber(date2.Year) and tonumber(date1.Month) < tonumber(date2.Month) and tonumber(date1.Day) < tonumber(date2.Day) or
        tonumber(date1.Year) < tonumber(date2.Year) and tonumber(date1.Month) < tonumber(date2.Month) and tonumber(date1.Day) < tonumber(date2.Day) and tonumber(date1.Hour) < tonumber(date2.Hour) or
        tonumber(date1.Year) < tonumber(date2.Year) and tonumber(date1.Month) < tonumber(date2.Month) and tonumber(date1.Day) < tonumber(date2.Day) and tonumber(date1.Hour) < tonumber(date2.Hour) and tonumber(date1.Minute) < tonumber(date2.Minute) or
        tonumber(date1.Year) < tonumber(date2.Year) and tonumber(date1.Month) < tonumber(date2.Month) and tonumber(date1.Day) < tonumber(date2.Day) and tonumber(date1.Hour) < tonumber(date2.Hour) and tonumber(date1.Minute) < tonumber(date2.Minute) and tonumber(date1.Second) < tonumber(date2.Second)
end

AchievementHeader = class(Turbine.UI.Window)
---@param text string
function AchievementHeader:Constructor(text)
    Turbine.UI.Window.Constructor(self)
    self:SetVisible(true)
    -- lcheader  0x4110A0DF; Size: 34 × 30;
    -- mcheader 0x4110A0DD; Size: 94 × 30;
    -- rcheader 0x4110A0DE; Size: 34 × 30;

    self:SetSize(256, 30)

    self.lcheader = Turbine.UI.Window()
    self.lcheader:SetParent(self)
    self.lcheader:SetVisible(true)
    self.lcheader:SetMouseVisible(false)
    self.lcheader:SetSize(34, 30)
    self.lcheader:SetBackground(0x4110A0DF)
    self.lcheader:SetPosition(0, 0)

    self.mcheader = Turbine.UI.Label()
    self.mcheader:SetParent(self)
    self.mcheader:SetVisible(true)
    self.mcheader:SetMouseVisible(false)
    self.mcheader:SetSize(94 * 2, 30)
    self.mcheader:SetBackground(0x4110A0DD)
    self.mcheader:SetPosition(34, 0)
    self.mcheader:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.mcheader:SetFont(Turbine.UI.Lotro.Font.TrajanProBold24)
    self.mcheader:SetOutlineColor(Turbine.UI.Color.Black)
    self.mcheader:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.mcheader:SetForeColor(Turbine.UI.Color(0.73,0.68,0.36))
    self.mcheader:SetText(text)

    self.rcheader = Turbine.UI.Window()
    self.rcheader:SetParent(self)
    self.rcheader:SetVisible(true)
    self.rcheader:SetMouseVisible(false)
    self.rcheader:SetSize(34, 30)
    self.rcheader:SetBackground(0x4110A0DE)
    self.rcheader:SetPosition(34 + 94 * 2, 0)
end

AchievementHeader2 = class(Turbine.UI.Window)
---@param text string
function AchievementHeader2:Constructor(text)
    Turbine.UI.Window.Constructor(self)
    self:SetVisible(true)
    -- lcheader  0x4110AE64; Size: 57 × 32;
    -- rcheader 0x4111219F; Size: 169 × 32;
    --0x4110AE67; Size: 60 × 32;
    self:SetSize(287 - 14, 32)

    self.mcheader = Turbine.UI.Label()
    self.mcheader:SetParent(self)
    self.mcheader:SetVisible(true)
    self.mcheader:SetMouseVisible(false)
    self.mcheader:SetSize(169, 30)
    self.mcheader:SetBackground(0x4110A0DD)
    self.mcheader:SetPosition(57, 1)
    self.mcheader:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.mcheader:SetFont(Turbine.UI.Lotro.Font.TrajanProBold24)
    self.mcheader:SetOutlineColor(Turbine.UI.Color.Black)
    self.mcheader:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.mcheader:SetForeColor(Turbine.UI.Color(0.73,0.68,0.36))
    self.mcheader:SetText(text)

    self.lcheader = Turbine.UI.Window()
    self.lcheader:SetParent(self)
    self.lcheader:SetVisible(true)
    self.lcheader:SetMouseVisible(false)
    self.lcheader:SetSize(57, 32)
    self.lcheader:SetBackground(0x4110AE64)
    self.lcheader:SetPosition(0, 0)



    self.rcheader = Turbine.UI.Window()
    self.rcheader:SetParent(self)
    self.rcheader:SetVisible(true)
    self.rcheader:SetMouseVisible(false)
    self.rcheader:SetSize(60, 32)
    self.rcheader:SetBackground(0x4110AE67)
    self.rcheader:SetPosition(169 + 57, 0)
end

AchievementHeader3 = class(Turbine.UI.Window)
---@param text string
function AchievementHeader3:Constructor(text, width)
    Turbine.UI.Window.Constructor(self)
    self:SetVisible(true)
    -- lcheader  0x41108D0E; Size: 64 × 40;
    -- mcheader 0x41108D0F; Size: 64 × 40;
    -- rcheader 0x41108D10; Size: 64 × 40;

    self:SetSize(width, 40)

    self.lcheader = Turbine.UI.Window()
    self.lcheader:SetParent(self)
    self.lcheader:SetVisible(true)
    self.lcheader:SetMouseVisible(false)
    self.lcheader:SetSize(64, 40)
    self.lcheader:SetBackground(0x41108D0E)
    self.lcheader:SetPosition(0, 0)

    self.mcheader = Turbine.UI.Label()
    self.mcheader:SetParent(self)
    self.mcheader:SetVisible(true)
    self.mcheader:SetMouseVisible(false)
    self.mcheader:SetSize(width - 64 - 64, 40)
    self.mcheader:SetBackground(0x41108D0F)
    self.mcheader:SetPosition(64, 0)
    self.mcheader:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.mcheader:SetFont(Turbine.UI.Lotro.Font.TrajanProBold24)
    self.mcheader:SetOutlineColor(Turbine.UI.Color.Black)
    self.mcheader:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.mcheader:SetForeColor(Turbine.UI.Color(0.73,0.68,0.36))
    self.mcheader:SetText(text)

    self.rcheader = Turbine.UI.Window()
    self.rcheader:SetParent(self)
    self.rcheader:SetVisible(true)
    self.rcheader:SetMouseVisible(false)
    self.rcheader:SetSize(64, 40)
    self.rcheader:SetBackground(0x41108D10)
    self.rcheader:SetPosition(width - 64, 0)
end

AchievementScoreHeader = class(Turbine.UI.Window)
---@param text string
function AchievementScoreHeader:Constructor(text, width)
    Turbine.UI.Window.Constructor(self)
    self:SetVisible(true)
    self:SetMouseVisible(false)
    -- lcheader  0x410FD9F5; Size: 38 × 34;
    -- mcheader 0x410FD9F6; Size: 25 × 22;
    -- rcheader 0x410FD9F0; Size: 39 × 34;

    self:SetSize(width, 34)

    self.lcheader = Turbine.UI.Control()
    self.lcheader:SetParent(self)
    self.lcheader:SetVisible(true)
    self.lcheader:SetMouseVisible(false)
    self.lcheader:SetSize(38, 34)
    self.lcheader:SetBackground(0x410FD9F5)
    self.lcheader:SetPosition(0, 0)

    self.mcheader = Turbine.UI.Label()
    self.mcheader:SetParent(self)
    self.mcheader:SetVisible(true)
    self.mcheader:SetMouseVisible(false)
    self.mcheader:SetSize(width - 38 - 39, 22)
    self.mcheader:SetBackground(0x410FD9F6)
    self.mcheader:SetPosition(38, 12)


    self.rcheader = Turbine.UI.Control()
    self.rcheader:SetParent(self)
    self.rcheader:SetVisible(true)
    self.rcheader:SetMouseVisible(false)
    self.rcheader:SetSize(39, 34)
    self.rcheader:SetBackground(0x410FD9F0)
    self.rcheader:SetPosition(width - 39, 0)

    self.label = Turbine.UI.Label()
    self.label:SetParent(self)
    self.label:SetVisible(true)
    self.label:SetMouseVisible(false)
    self.label:SetSize(width, 22)
    self.label:SetPosition(0, 12)
    self.label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.label:SetFont(Turbine.UI.Lotro.Font.TrajanPro13)
    self.label:SetOutlineColor(Turbine.UI.Color.Black)
    self.label:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.label:SetForeColor(Turbine.UI.Color.Gold)
    self.label:SetText(text)
end

AchievementListBoxHeader = class(Turbine.UI.Window)
---@param text string
function AchievementListBoxHeader:Constructor(text)
    Turbine.UI.Window.Constructor(self)
    self:SetVisible(true)
    -- lcheader  0x4110AE64; Size: 57 × 32;
    -- rcheader 0x4111219F; Size: 169 × 32;
    --0x41108DCD; Size: 176 × 31;
    self:SetSize(287 - 14, 32)



    self.mcheader = Turbine.UI.Label()
    self.mcheader:SetParent(self)
    self.mcheader:SetVisible(true)
    self.mcheader:SetMouseVisible(false)
    self.mcheader:SetSize(176, 30)
    self.mcheader:SetBackground(0x41108DCD)
    self.mcheader:SetPosition(57 - 3, 1)
    self.mcheader:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.mcheader:SetFont(Turbine.UI.Lotro.Font.TrajanProBold24)
    self.mcheader:SetOutlineColor(Turbine.UI.Color.Black)
    self.mcheader:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.mcheader:SetForeColor(Turbine.UI.Color(0.73,0.68,0.36))
    self.mcheader:SetText(text)

    self.lcheader = Turbine.UI.Window()
    self.lcheader:SetParent(self)
    self.lcheader:SetVisible(true)
    self.lcheader:SetMouseVisible(false)
    self.lcheader:SetSize(57, 32)
    self.lcheader:SetBackground(0x4110AE64)
    self.lcheader:SetPosition(10, 0)

    --0x410FB4CE; Size: 56 × 25;
    self.iconHeader = Turbine.UI.Window()
    self.iconHeader:SetParent(self)
    self.iconHeader:SetVisible(true)
    self.iconHeader:SetMouseVisible(false)
    self.iconHeader:SetSize(56, 25)
    self.iconHeader:SetBackground(0x410FB4CE)
    self.iconHeader:SetPosition(0, 0)
end

AchievementListBoxHeader2 = class(Turbine.UI.Window)
---@param text string
function AchievementListBoxHeader2:Constructor(text, clickFunction)
    Turbine.UI.Window.Constructor(self)
    self:SetVisible(true)
    -- 0x411BCBAC; Size: 63 × 32;
    -- 0x411BCBB2; Size: 64 × 32;
    self:SetSize(287 - 14, 36)

    self.mcheader1 = Turbine.UI.Control()
    self.mcheader1:SetParent(self)
    self.mcheader1:SetVisible(true)
    self.mcheader1:SetMouseVisible(false)
    self.mcheader1:SetSize(63, 32)
    self.mcheader1:SetBackground(0x411BCBA9)
    self.mcheader1:SetPosition(76, 2)

    self.mcheader2 = Turbine.UI.Control()
    self.mcheader2:SetParent(self)
    self.mcheader2:SetVisible(true)
    self.mcheader2:SetMouseVisible(false)
    self.mcheader2:SetSize(63, 32)
    self.mcheader2:SetBackground(0x411BCBA9)
    self.mcheader2:SetPosition(76 + 63 - 5, 2)

    self.mcheader3 = Turbine.UI.Control()
    self.mcheader3:SetParent(self)
    self.mcheader3:SetVisible(true)
    self.mcheader3:SetMouseVisible(false)
    self.mcheader3:SetSize(63, 32)
    self.mcheader3:SetBackground(0x411BCBA9)
    self.mcheader3:SetPosition(76 + 63 + 63 - 24, 2)

    self.lcheader = Turbine.UI.Window()
    self.lcheader:SetParent(self)
    self.lcheader:SetVisible(true)
    self.lcheader:SetMouseVisible(false)
    self.lcheader:SetSize(63, 32)
    self.lcheader:SetBackground(0x411BCBAC)
    self.lcheader:SetPosition(13, 2)

    --0x410FB4CE; Size: 56 × 25;
    self.iconHeader = Turbine.UI.Window()
    self.iconHeader:SetParent(self)
    self.iconHeader:SetVisible(true)
    self.iconHeader:SetMouseVisible(false)
    self.iconHeader:SetSize(56, 25)
    self.iconHeader:SetBackground(0x410FB4CE)
    self.iconHeader:SetPosition(0, 2)

    self.mcLabel = Turbine.UI.Label()
    self.mcLabel:SetParent(self)
    self.mcLabel:SetVisible(true)
    self.mcLabel:SetMouseVisible(false)
    self.mcLabel:SetSize(176, 32)
    self.mcLabel:SetPosition(57 - 3, 2)
    self.mcLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.mcLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold16)
    self.mcLabel:SetOutlineColor(Turbine.UI.Color.Black)
    self.mcLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.mcLabel:SetForeColor(Turbine.UI.Color(0.73,0.68,0.36))
    self.mcLabel:SetText(text)

    self.MouseEnter = function()
        self.mcheader1:SetBackground(0x411BCBAF)
        self.mcheader2:SetBackground(0x411BCBAF)
        self.mcheader3:SetBackground(0x411BCBAF)
        self.lcheader:SetBackground( 0x411BCBAE)
    end

    self.MouseLeave = function()
        self.mcheader1:SetBackground(0x411BCBA9)
        self.mcheader2:SetBackground(0x411BCBA9)
        self.mcheader3:SetBackground(0x411BCBA9)
        self.lcheader:SetBackground(0x411BCBAC)
    end


    self.MouseClick = function()
        self.mcheader1:SetBackground(0x411BCBB2)
        self.mcheader2:SetBackground(0x411BCBB2)
        self.mcheader3:SetBackground(0x411BCBB2)
        self.lcheader:SetBackground(0x411BCBB3)
        clickFunction()
    end

    
end

AchievementListBox = class(Turbine.UI.Window)
function AchievementListBox:Constructor(width, height)
    Turbine.UI.Window.Constructor(self)
    self:SetVisible(true)
    self:SetMouseVisible(false)
    -- lcheader  0x4110AE64; Size: 57 × 32;
    -- rcheader 0x4111219F; Size: 169 × 32;
    --0x41108DCD; Size: 176 × 31;
    self:SetSize(width, height)

    --0x41000147; Size: 36 × 105;
    self.leftbar = Turbine.UI.Window()
    self.leftbar:SetParent(self)
    self.leftbar:SetVisible(true)
    self.leftbar:SetMouseVisible(false)
    self.leftbar:SetSize(36, height - 36)
    self.leftbar:SetBackground(0x41000147)
    self.leftbar:SetPosition(0, 0)

    --0x4100013F; Size: 128 × 128;
    self.middle = Turbine.UI.Window()
    self.middle:SetParent(self)
    self.middle:SetVisible(true)
    self.middle:SetMouseVisible(false)
    self.middle:SetSize(width - 36 - 36, height - 36)
    self.middle:SetBackground( 0x4100014C)
    self.middle:SetPosition(36, 0)

    self.rightbar = Turbine.UI.Window()
    self.rightbar:SetParent(self)
    self.rightbar:SetVisible(true)
    self.rightbar:SetMouseVisible(false)
    self.rightbar:SetSize(36, height - 36)
    self.rightbar:SetBackground(0x41000147)
    self.rightbar:SetPosition(width - 36, 0)
    self.rightbar:SetRotation({x=0,y=0,z=180})


    -- bottom 0x41000148; Size: 36 × 36;
    self.lcheader = Turbine.UI.Window()
    self.lcheader:SetParent(self)
    self.lcheader:SetVisible(true)
    self.lcheader:SetMouseVisible(false)
    self.lcheader:SetSize(36, 36)
    self.lcheader:SetBackground(0x41000148)
    self.lcheader:SetPosition(0, height - 36)

    -- 0x41000149; Size: 103 × 36;
    self.mcheader = Turbine.UI.Label()
    self.mcheader:SetParent(self)
    self.mcheader:SetVisible(true)
    self.mcheader:SetMouseVisible(false)
    self.mcheader:SetSize(width - 36 - 36, 36)
    self.mcheader:SetBackground(0x41000149)
    self.mcheader:SetPosition(36, height - 36)

    -- 0x4100014A; Size: 36 × 36;
    self.rcheader = Turbine.UI.Window()
    self.rcheader:SetParent(self)
    self.rcheader:SetVisible(true)
    self.rcheader:SetMouseVisible(false)
    self.rcheader:SetSize(36, 36)
    self.rcheader:SetBackground(0x4100014A)
    self.rcheader:SetPosition(width - 36, height - 36)
end

AchievementItem = class(Turbine.UI.Control)
---@param text string
function AchievementItem:Constructor(title, data, extraData, width, height)
    Turbine.UI.Control.Constructor(self)
    --self:SetVisible(true)
    -- topR 0x410FF0D4; Size: 45 × 45;
    -- bottomL 0x410FF0D5; Size: 45 × 45;
    -- icon 0x410FF0F5; Size: 48 × 48; 0x4112E6CF; Size: 57 × 56; 0x410EA716; Size: 76 × 79;
    -- goldborder 0x4112E6CE; Size: 40 × 39;
    self:SetSize(width, height)
    self:SetMouseVisible(false)
    self:SetBackColor(Turbine.UI.Color(0.3,0,0,0))
    self:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
    self:SetBackColorBlendMode(Turbine.UI.BlendMode.AlphaBlend)

    self.lcheader = Turbine.UI.Control()
    self.lcheader:SetParent(self)
    self.lcheader:SetVisible(true)
    self.lcheader:SetMouseVisible(false)
    self.lcheader:SetSize(45, 45)
    self.lcheader:SetBackground(0x410FF0D4)
    self.lcheader:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
    self.lcheader:SetPosition(0, 0)

    self.rcheader = Turbine.UI.Control()
    self.rcheader:SetParent(self)
    self.rcheader:SetVisible(true)
    self.rcheader:SetMouseVisible(false)
    self.rcheader:SetSize(45, 45)
    self.rcheader:SetBackground(0x410FF0D5)
    self.rcheader:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
    self.rcheader:SetPosition(width - 45, height - 45)

    self.iconHolder = Turbine.UI.Control()
    self.iconHolder:SetParent(self)
    self.iconHolder:SetVisible(true)
    self.iconHolder:SetMouseVisible(false)
    self.iconHolder:SetSize(76, 79)
    self.iconHolder:SetBackground(0x410EA716)
    self.iconHolder:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
    self.iconHolder:SetPosition(0, 0)

    self.iconControl = Turbine.UI.Control()
    self.iconControl:SetParent(self.iconHolder)
    self.iconControl:SetVisible(true)
    self.iconControl:SetMouseVisible(false)
    self.iconControl:SetSize(32, 32)
    self.iconControl:SetBackground(extraData.Icon)
    self.iconControl:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
    self.iconControl:SetPosition(8 + 14, 8 + 16)

    self.dateLabel = Turbine.UI.Label()
    self.dateLabel:SetParent(self)
    self.dateLabel:SetVisible(true)
    self.dateLabel:SetMouseVisible(false)
    self.dateLabel:SetSize(100, 20)
    --self.dateLabel:SetBackground(0x41108DCD)
    self.dateLabel:SetPosition(1, 70)
    self.dateLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.dateLabel:SetFont(Turbine.UI.Lotro.Font.Verdana10)
    self.dateLabel:SetOutlineColor(Turbine.UI.Color.Black)
    self.dateLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.dateLabel:SetForeColor(Turbine.UI.Color.Silver)
    self.dateLabel:SetText(string.format("%s/%s/%s %s:%s:%s", data.CompletionData.Day, data.CompletionData.Month, data.CompletionData.Year, data.CompletionData.Hour, data.CompletionData.Minute, data.CompletionData.Second))

    self.mcheader = Turbine.UI.Label()
    self.mcheader:SetParent(self)
    self.mcheader:SetVisible(true)
    self.mcheader:SetMouseVisible(false)
    self.mcheader:SetSize(250, 30)
    --self.mcheader:SetBackground(0x41108DCD)
    self.mcheader:SetPosition(105, 1)
    self.mcheader:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.mcheader:SetFont(Turbine.UI.Lotro.Font.TrajanProBold16)
    self.mcheader:SetOutlineColor(Turbine.UI.Color.Black)
    self.mcheader:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.mcheader:SetForeColor(Turbine.UI.Color.Silver)
    self.mcheader:SetText(title)

    self.descrip = Turbine.UI.Label()
    self.descrip:SetParent(self)
    self.descrip:SetVisible(true)
    self.descrip:SetMouseVisible(false)
    self.descrip:SetSize(250, 60)
    --self.descrip:SetBackground(0x41108DCD)
    self.descrip:SetPosition(105, 40)
    self.descrip:SetTextAlignment(Turbine.UI.ContentAlignment.TopCenter)
    self.descrip:SetFont(Turbine.UI.Lotro.Font.Verdana14)
    self.descrip:SetOutlineColor(Turbine.UI.Color.Black)
    self.descrip:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.descrip:SetForeColor(Turbine.UI.Color.White)
    self.descrip:SetText(extraData.Description)

        -- twirly 0x410FF0D2; Size: 50 × 72;
    -- twirly  0x410FF0D3; Size: 50 × 72;

    self.twirlyLeft = Turbine.UI.Control()
    self.twirlyLeft:SetParent(self)
    self.twirlyLeft:SetVisible(true)
    self.twirlyLeft:SetMouseVisible(false)
    self.twirlyLeft:SetSize(50, 72)
    self.twirlyLeft:SetBackground(0x410FF0D2)
    self.twirlyLeft:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
    self.twirlyLeft:SetPosition(70, 0)

    self.twirlyRight = Turbine.UI.Control()
    self.twirlyRight:SetParent(self)
    self.twirlyRight:SetVisible(true)
    self.twirlyRight:SetMouseVisible(false)
    self.twirlyRight:SetSize(50, 72)
    self.twirlyRight:SetBackground(0x410FF0D3)
    self.twirlyRight:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
    self.twirlyRight:SetPosition(width - 50, 0)

    self.difficultyLabel = Turbine.UI.Label()
    self.difficultyLabel:SetParent(self)
    self.difficultyLabel:SetVisible(true)
    self.difficultyLabel:SetMouseVisible(false)
    self.difficultyLabel:SetSize(100, 20)
    --self.dateLabel:SetBackground(0x41108DCD)
    self.difficultyLabel:SetPosition(180, 20)
    self.difficultyLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.difficultyLabel:SetFont(Turbine.UI.Lotro.Font.Verdana10)
    self.difficultyLabel:SetOutlineColor(Turbine.UI.Color.Black)
    self.difficultyLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.difficultyLabel:SetForeColor(Turbine.UI.Color.Silver)
    self.difficultyLabel:SetText(string.format("%s", data.Difficulty))

    self.progressLabel = Turbine.UI.Label()
    self.progressLabel:SetParent(self)
    self.progressLabel:SetVisible(true)
    self.progressLabel:SetMouseVisible(false)
    self.progressLabel:SetSize(100, 20)
    --self.progressLabel:SetBackground(0x41108DCD)
    self.progressLabel:SetPosition(180, 80)
    self.progressLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.progressLabel:SetFont(Turbine.UI.Lotro.Font.Verdana10)
    self.progressLabel:SetOutlineColor(Turbine.UI.Color.Black)
    self.progressLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.progressLabel:SetForeColor(Turbine.UI.Color.Silver)
    self.progressLabel:SetText(string.format("%s %s", extraData.Goal, extraData.GoalType or ""))

end
