function PrimeUI:SetupSkillBar2(data, parent)
    -- Determine bar height
    local barHeight = 0
    self.skills = true

    -- Bar -> Bar name
    -- Bar data
    -- Skills
    -- Scale

    --args (parent, x, y, width, height, labelSize, sortMethod, hide)
    local x = 0
    local y = self.currentHeight
    if self.groupMode then
        x = data.X
        y = data.Y
    end

	
    local skillbar = SkillBar(parent, x, y, data.Skill_Alignment, data.Use_Priority_As_Index, data.Scale, data.Event_List, data.Offset)
    self.lookup[data.NickName or ""] = skillbar

	local eventTable = {
		
	}
    -- Skill data
    -- Name
    -- ID
    -- X prio
    -- Y prio
    -- Special triggers?
    local count = 0
    local height = 1

    --[[
        Event list:
            highlight
            opacity
            visible
            cooldown

            			duration font
			duration alignment
			show quickslot
			decimal
			decimal threshold
			abbreviation > 60
    ]]

	for key, value in pairs(data.Slots) do
        if not(value.Skill_Check) or value.Skill_Check and SkillEventHandler:SkillExists(SkillEventHandler:CheckSkillCode(value.Data)) then
            local layoutTable = {
                ["scale"] = data.Scale or 1,
                ["visibitilityThreshold"] = value.visibitilityThreshold or 9999,
                ["borderSize"] = data.borderSize or 0,
                ["borderColour"] = self:ColourTupleToTurbineColour(data.BorderColour) or Turbine.UI.Color(0,0,0),
                ["locked"] = data.Lock_Quickslot,
                ["Hide_While_Timer_Active"] = value.Hide_While_Timer_Active,
                ["Hide_While_Timer_Inactive"] = value.Hide_While_Timer_Inactive,
                ["Opacity_While_Timer_Inactive"] = value.Opacity_While_Timer_Inactive or 1,
                ["Opacity_While_Timer_Active"] = value.Opacity_While_Timer_Active or 1,
                ["highlightOnReady"] = value.highlightOnReady or 0,
                ["HighlightColour"] = self:ColourTupleToTurbineColour(data.HighlightColour) or Turbine.UI.Color(0, 0, 0),
                ["higlightSize"] = data.higlightSize or 1,
                ["Keybind_Font"] = Turbine.UI.Lotro.Font[value.Keybind_Font] or Turbine.UI.Lotro.Font.FixedSys15,
                ["Show_Keybind"] = value.Show_Keybind,
                ["Keybind_Alignment"] = Turbine.UI.ContentAlignment[value.Keybind_Alignment],
                ["Keybind_Text"] = value.Keybind_Text or "",

                ["Duration_Font"] = Turbine.UI.Lotro.Font[value.Duration_Font],
                ["Duration_Alignment"] = Turbine.UI.ContentAlignment[value.Duration_Alignment],
                ["ShowDuration"] = value.Show_Duration,
                ["Decimal_Threshold"] = value.Decimal_Threshold,
                ["Use_Units"] = value.Use_Units,
                ["Hide_Quickslot"] = value.Hide_Quickslot,

                ["BorderSize"] = data.BorderSize
            }

            local quickslot = SkillBarQuickslot(skillbar, {["Type"] = value.Type, ["Data"] =  value.Data, ["Item"] =  value.Item}, layoutTable, value.Events, self.player:GetBackpack(), value.Event_Keyword and function() self:FireTrigger(value["Event_Keyword"]) end)

            skillbar:AddQuickslot(key, quickslot, value.XPrio, value.YPrio)

            -- Add the callback for this skill slot if we have a value for the time otherwise time has to be set through an event
            if value.Data and value.Time and value.Time == true or type(value.Time) == "number" then
                local skillName = SkillEventHandler:CheckSkillCode(value.Data)
                if skillName then
                    if not(self.skillCallbacks[skillName]) then self.skillCallbacks[skillName] = {} end
                    table.insert(self.skillCallbacks[skillName], AddCallback(SkillEventHandler, skillName, function(skill) 
                        local time = skill:GetResetTime() - Turbine.Engine.GetGameTime()
                        if time + 1 > skill:GetCooldown() then
                            
                            if IsNumber(value["Time"]) then
                                time = value["Time"]
                            end
                        end
                        skillbar:SetTimer(key, math.max(0.1, time), skill:GetCooldown())
                    end))

                    local tempSkill = SkillEventHandler:GetSkill(skillName)
                    if tempSkill then
                        local time = tempSkill:GetResetTime() - Turbine.Engine.GetGameTime()
                        if time > 0 then
                            
                            if IsNumber(value["Time"]) then
                                time = value["Time"]
                            end
                            skillbar:SetTimer(key, math.max(0.1, time), tempSkill:GetCooldown())
                        end
                    end
                end
            end

            -- Update max bar height
            barHeight = math.max(barHeight, value["YPrio"] or 1)

        end
	end

    skillbar:PerformLayout()

    if tablelength(data["Event_List"]) > 0 then
        table.insert(self.eventTriggerCallbacks, AddCallback(self, "EventTrigger", 
        function(event)
            skillbar:FireEvent(event)
        end))
    end

    data["Width"] = skillbar:GetWidth()
    
    if self.groupMode then
        skillbar.moveBox = MoveBox(skillbar, (35 + (data["Offset"] or 1)) * count + 50, barHeight * 34 * data["Scale"] + 50, data["NickName"] or "Skill bar")
        skillbar.savePosition = function()
            data["X"], data["Y"] = skillbar:GetPosition()
        end
    else
        if self.width > skillbar:GetWidth() then
            skillbar:SetLeft((self.width - skillbar:GetWidth()) / 2)
        end
    end

    table.insert(self.tools, skillbar)

    -- Update height
    self.currentHeight = self.currentHeight + barHeight * 34 * data["Scale"] + barHeight * (data["BorderSize"] or 0)
    self.heightSize = self.heightSize + barHeight * 34 * data["Scale"] + barHeight * (data["BorderSize"] or 0)
end