function PrimeUI:SetupTimerIcon(data, parent)
    local valuebar = Turbine.UI.Control()
    valuebar:SetParent(parent)

    local layoutTable = {
        Scale = data.Scale or 1,
        BorderSize = data.BorderSize or 0,
        Normal_Opacity  = data.Opacity,
        Always_Visible = data.Always_Visible,
        Icon = data.Icon,
    
        Timer_Font = Turbine.UI.Lotro.Font[data.Timer_Font],
        Text_Font = Turbine.UI.Lotro.Font[data.Text_Font],
        Timer_Font_Colour = self:ColourTupleToTurbineColour(data.Timer_Font_Colour),
        Text_Font_Colour = self:ColourTupleToTurbineColour(data.Text_Font_Colour),
    
        Border_Colour = self:ColourTupleToTurbineColour(data.BorderColour),
        Shadow_timer = data.Shadow_timer,
        Increasing_Shadow = data.Increasing_Shadow,
    
        Timer_Alignment = Turbine.UI.ContentAlignment[data.Timer_Alignment],
        Text_Alignment = Turbine.UI.ContentAlignment[data.Text_Alignment],

        Invisible_While_Timer_Active = data.Invisible_While_Timer_Active,
        Invisible_While_Timer_Inactive = data.Invisible_While_Timer_Inactive,

        Show_Duration = data.Show_Duration,
        Text = data.Text,

        Alignment = data["Alignment"],
        UIWidth = self.width,
        X = data.X,
        Y = data.Y,
        Advanced = self.groupMode,
    }

    local valuebar = TimerLabel(parent, 0, self.currentHeight, layoutTable)

    --innerbar:SetPosition(data["BorderSize"] * data["Scale"], data["BorderSize"] * data["Scale"])

    if self.groupMode then
        valuebar:SetPosition(data["X"], data["Y"])
        valuebar.moveBox = MoveBox(valuebar, data["Width"] + 2 * data["BorderSize"], data["Height"] + 2 * data["BorderSize"], data["NickName"] or "Timer Icon")
        valuebar.savePosition = function()
            data["X"], data["Y"] = valuebar:GetPosition()
        end
    else
        --valuebar:SetPosition(self:ContentAlignement(data["Alignment"], (data["Width"] + 2 * data["BorderSize"]) * data["Scale"]), self.currentHeight)
    end

    if Tablelength(data.Triggers) > 0 then
        table.insert(self.eventTriggerCallbacks, AddCallback(self, "EventTrigger", 
        function(event)
            local value = data["Triggers"][event]
            if value then
                valuebar:Trigger(value, self.args[event] or {})
            end
        end))
    end

    self.lookup[data.NickName or ""] = valuebar

    
    self.currentHeight = self.currentHeight + (data["Height"] + data["BorderSize"] * 2) * data["Scale"]
    self.heightSize = self.heightSize + (data["Height"] + data["BorderSize"] * 2) * data["Scale"]
    table.insert(self.UI, valuebar)
end