function CreateTriggerListBoxOptions(width, triggerType, listboxItems, UIType, func, optionPage)
    local headerNode = Turbine.UI.TreeNode()
    headerNode:SetMouseVisible(false)
    headerNode:SetSize(width, 20)

    -- The header label with the trigger name
    headerNode.label = Turbine.UI.Label()
    headerNode.label:SetParent(headerNode)
    headerNode.label:SetSize(width, 20)
    headerNode.label:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    headerNode.label:SetPosition(0, 0)
    headerNode.label:SetText(string.format("%s (%s)", triggerType, tostring(tablelength(listboxItems))))
    headerNode.label:SetBackColor(Turbine.UI.Color.Black)

    local optionsTreeNode = headerNode:GetChildNodes()

    local valuebar = Turbine.UI.TreeNode()
    valuebar:SetPosition(0, 0)
    valuebar:SetMouseVisible(false)
   --valuebar:SetBackColor(GetRandomColour())

   local optionsHeight = 10
   local listboxHeight = 700

    valuebar.optionsControl = Turbine.UI.Control()
	valuebar.optionsControl:SetParent(valuebar)
    valuebar.optionsControl:SetPosition(0, 0)
    valuebar.optionsControl:SetBackColor(Turbine.UI.Color.DarkSlateGray)

    valuebar.options = {}

    valuebar.TriggerBox = OptionsControl(valuebar.optionsControl, width - 20, optionsHeight, {
        [1] = {
            ["Type"] = "Label String Textbox",
            ["Text"] = "Trigger Name",
            ["Variable"] = "Trigger_Code",
        },
    })

    optionsHeight = optionsHeight + valuebar.TriggerBox:GetHeight() + 5

    valuebar.DurationBox = OptionsControl(valuebar.optionsControl, width - 20, optionsHeight, {
        [1] = {
            ["Type"] = "Enable Checkbox",
            ["Text"] = "Start Timer",
            ["Variable"] = "Timer",
        },
        [2] = {
            ["Type"] = "Label Number Textbox",
            ["Text"] = "Timer Duration",
            ["Variable"] = "Timer_Duration",
        },
        [3] = {
            ["Type"] = "Enable Checkbox",
            ["Text"] = "From Trigger",
            ["Variable"] = "Special_Trigger",
        },
    })

    optionsHeight = optionsHeight + valuebar.DurationBox:GetHeight() + 5

    valuebar.ScaleBox = OptionsControl(valuebar.optionsControl, width - 20, optionsHeight, {
        [1] = {
            ["Type"] = "Enable Checkbox",
            ["Text"] = "Change Scale",
            ["Variable"] = "Change_Scale",
        },
        [2] = {
            ["Type"] = "Label Number Textbox",
            ["Text"] = "Scale",
            ["Variable"] = "Change_Scale_Number",
        }
    })

    optionsHeight = optionsHeight + valuebar.ScaleBox:GetHeight() + 5

    valuebar.ChangingScaleBox = OptionsControl(valuebar.optionsControl, width - 20, optionsHeight, {
        [1] = {
            ["Type"] = "Enable Checkbox",
            ["Text"] = "Change Scale Over Duration",
            ["Variable"] = "Change_Scale_Duration",
        },
        [2] = {
            ["Type"] = "Label Number Textbox",
            ["Text"] = "Scale Start",
            ["Variable"] = "Change_Scale_Number_Start",
        },
        [3] = {
            ["Type"] = "Label Number Textbox",
            ["Text"] = "Scale End",
            ["Variable"] = "Change_Scale_Number_End",
        }
    })

    optionsHeight = optionsHeight + valuebar.ChangingScaleBox:GetHeight() + 5

    valuebar.SetOpacityOptions = OptionsControl(valuebar.optionsControl, width - 20, optionsHeight, {
        [1] = {
            ["Type"] = "Enable Checkbox",
            ["Text"] = "Set Opacity",
            ["Variable"] = "Set_Opacity",
        },
        [2] = {
            ["Type"] = "Label Number Textbox",
            ["Text"] = "Opacity",
            ["Variable"] = "Set_Opacity_Number",
        }
    })

    optionsHeight = optionsHeight + valuebar.SetOpacityOptions:GetHeight() + 5

    valuebar.ChangeOpacityOptions = OptionsControl(valuebar.optionsControl, width - 20, optionsHeight, {
        [1] = {
            ["Type"] = "Enable Checkbox",
            ["Text"] = "Change Opacity Over Duration",
            ["Variable"] = "Change_Opacity",
        },
        [2] = {
            ["Type"] = "Label Number Textbox",
            ["Text"] = "Start Opacity",
            ["Variable"] = "Start_Opacity",
        },
        [3] = {
            ["Type"] = "Label Number Textbox",
            ["Text"] = "End Opacity",
            ["Variable"] = "End_Opacity",
        }
    })

    optionsHeight = optionsHeight + valuebar.ChangeOpacityOptions:GetHeight() + 5

    valuebar.ChangeText = OptionsControl(valuebar.optionsControl, width - 20, optionsHeight, {
        [1] = {
            ["Type"] = "Enable Checkbox",
            ["Text"] = "Change Text",
            ["Variable"] = "Change_Text",
        },
        [2] = {
            ["Type"] = "Label String Textbox",
            ["Text"] = "Text",
            ["Variable"] = "New_Text",
        }
    })

    optionsHeight = optionsHeight + valuebar.ChangeText:GetHeight() + 5
    
    valuebar.ChangeRotation = OptionsControl(valuebar.optionsControl, width - 20, optionsHeight, {
        [1] = {
            ["Type"] = "Enable Checkbox",
            ["Text"] = "Rotate",
            ["Variable"] = "Rotate",
        },
        [2] = {
            ["Type"] = "Label Number Textbox",
            ["Text"] = "Rotation Per Second",
            ["Variable"] = "Rotation_Per_Second",
        }
    })

    optionsHeight = optionsHeight + valuebar.ChangeRotation:GetHeight() + 5

    valuebar.ChangeWiggle = OptionsControl(valuebar.optionsControl, width - 20, optionsHeight, {
        [1] = {
            ["Type"] = "Enable Checkbox",
            ["Text"] = "Change Wiggle State",
            ["Variable"] = "Wiggle",
        },
        [2] = {
            ["Type"] = "Enable Checkbox",
            ["Text"] = "Start Wiggle",
            ["Variable"] = "Start_Wiggle",
        },
        [3] = {
            ["Type"] = "Enable Checkbox",
            ["Text"] = "End Wiggle",
            ["Variable"] = "End_Wiggle",
        }
    })

    optionsHeight = optionsHeight + valuebar.ChangeWiggle:GetHeight() + 5

    valuebar.addTriggerEntryButton = Turbine.UI.Lotro.Button()
    valuebar.addTriggerEntryButton:SetParent(valuebar)
    valuebar.addTriggerEntryButton:SetSize(100, 20)
    valuebar.addTriggerEntryButton:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    valuebar.addTriggerEntryButton:SetPosition(width - 120, optionsHeight)
    valuebar.addTriggerEntryButton:SetText("Add")

    optionsHeight = optionsHeight + 20

    -- Set options control to match all its children
    valuebar.optionsControl:SetSize(width, optionsHeight)

    -- Add listbox for items
    valuebar.listbox = Turbine.UI.ListBox()
    valuebar.listbox:SetParent(valuebar)
    valuebar.listbox:SetSize(width - 10, listboxHeight)
    valuebar.listbox:SetPosition(0, valuebar.optionsControl:GetHeight())
    valuebar.listbox:SetVisible(tablelength(listboxItems) > 0)

    valuebar.Scrollbar = Turbine.UI.Lotro.ScrollBar()
    valuebar.Scrollbar:SetOrientation(Turbine.UI.Orientation.Vertical)
    valuebar.Scrollbar:SetParent(valuebar)
    valuebar.Scrollbar:SetPosition(width - 10, valuebar.optionsControl:GetHeight())
    valuebar.Scrollbar:SetSize(10, listboxHeight)
    valuebar.Scrollbar:SetBackColor(Turbine.UI.Color.DarkSlateGray)
    valuebar.listbox:SetVerticalScrollBar(valuebar.Scrollbar)

    for key, value in spairs(listboxItems, function(t, a, b) return tostring(a) < tostring(b) end) do
        valuebar.listbox:AddItem(CreateTriggerListBoxOptionsListboxItem(key, value, width - 10, triggerType, UIType, func, valuebar.listbox))
    end

    valuebar:SetSize(width, valuebar.listbox:GetHeight() + valuebar.optionsControl:GetHeight())

    valuebar.addTriggerEntryButton.Click = function()
        local trigger_result = valuebar.TriggerBox:GetValues()
        local timer_result = valuebar.DurationBox:GetValues()
        local scale_change_result = valuebar.ScaleBox:GetValues()
        local changing_scale_change_result = valuebar.ChangingScaleBox:GetValues()
        local set_opacity_result = valuebar.SetOpacityOptions:GetValues()
        local change_opacity_result = valuebar.ChangeOpacityOptions:GetValues()
        local change_text_result = valuebar.ChangeText:GetValues()
        local change_wiggle_result = valuebar.ChangeWiggle:GetValues()


        local triggerEntry = {
            ["Trigger_Code"] = trigger_result.Trigger_Code,

            ["Timer"] = timer_result.Timer,
            ["Timer_Duration"] = timer_result.Timer_Duration,
            ["Special_Trigger"] = timer_result.Special_Trigger,

            ["Change_Scale"] = scale_change_result.Change_Scale,
            ["Change_Scale_Number"] = scale_change_result.Change_Scale_Number,

            ["Change_Scale_Duration"] = changing_scale_change_result.Change_Scale_Duration,
            ["Change_Scale_Number_Start"] = changing_scale_change_result.Change_Scale_Number_Start,
            ["Change_Scale_Number_End"] = changing_scale_change_result.Change_Scale_Number_End,

            ["Set_Opacity"] = set_opacity_result.Set_Opacity,
            ["Set_Opacity_Number"] = set_opacity_result.Set_Opacity_Number,

            ["Change_Opacity"] = change_opacity_result.Change_Opacity,
            ["Start_Opacity"] = change_opacity_result.Start_Opacity,
            ["End_Opacity"] = change_opacity_result.End_Opacity,

            ["Change_Text"] = change_text_result.Change_Text,
            ["New_Text"] = change_text_result.New_Text,

            ["Wiggle"] = change_wiggle_result.Wiggle,
            ["Start_Wiggle"] = change_wiggle_result.Start_Wiggle,
            ["End_Wiggle"] = change_wiggle_result.End_Wiggle,
        }

        if func(trigger_result.Trigger_Code, triggerEntry) then
            return
        end

        valuebar.listbox:AddItem(CreateTriggerListBoxOptionsListboxItem(trigger_result.Trigger_Code, triggerEntry, width - 10, triggerType, UIType, func, valuebar.listbox))
        valuebar.listbox:SetVisible(true)
    end

    optionsTreeNode:Add(valuebar)

    return headerNode
end

OptionsControl = class(Turbine.UI.Control)
function OptionsControl:Constructor(parent, width, y, args)
    Turbine.UI.Control.Constructor(self)

    self.width = width
    self.height = 0
    self.borderSize = 2

    self:SetParent(parent)
    self:SetMouseVisible(false)
    self:SetPosition(10, y)
    self:SetBackColorBlendMode(Turbine.UI.BlendMode.Overlay)
    self:SetBackColor(Turbine.UI.Color.Black)

    self.currentBackground = Turbine.UI.Control()
    self.currentBackground:SetParent(self)
    self.currentBackground:SetMouseVisible(false)

    self.currentBackground:SetBackColorBlendMode(Turbine.UI.BlendMode.Overlay)
    self.currentBackground:SetBackColor(Turbine.UI.Color.DarkGray)

    self.UI = {}

    local optionsHeight = 5

    for key, value in ipairs(args) do
        if value.Type == "Enable Checkbox" then
            self.UI[value.Variable] = Turbine.UI.Lotro.CheckBox()
            self.UI[value.Variable]:SetParent(self.currentBackground)
            self.UI[value.Variable]:SetSize(300, 20)
            self.UI[value.Variable]:SetPosition(5, optionsHeight)
            self.UI[value.Variable]:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
            self.UI[value.Variable]:SetText(value.Text)
            self.UI[value.Variable]:SetChecked(value.Value)
            self.UI[value.Variable].CheckedChanged = function ()
                self:ValueChanged()
            end
            self.UI[value.Variable].GetValue = function()
                return self.UI[value.Variable]:IsChecked()
            end

            optionsHeight = optionsHeight + 25
        elseif value.Type == "Label Number Textbox" or value.Type == "Label String Textbox" then
            self.UI[value.Variable] = LabelTextboxControl(self.currentBackground, width - 20, optionsHeight, value, value.Type == "Label Number Textbox")
            self.UI[value.Variable].ValueChanged = function()
                self:ValueChanged()
            end
            optionsHeight = optionsHeight + 25
        end
    end
    self.height = optionsHeight
    self:Format()
end

function OptionsControl:Format()
    self:SetSize(self.width, self.height + 2 * self.borderSize)
    self.currentBackground:SetPosition(self.borderSize, self.borderSize)
    self.currentBackground:SetSize(self.width - 2 * self.borderSize, self.height)
end

function OptionsControl:ValueChanged()

end

function OptionsControl:GetValues()
    local valueTable = {}
    for key, value in pairs(self.UI) do
        valueTable[key] = value:GetValue()
    end
    return valueTable
end

LabelTextboxControl = class(Turbine.UI.Control)
function LabelTextboxControl:Constructor(parent, width, y, args, number)
    Turbine.UI.Control.Constructor(self)
    self:SetParent(parent)
    self:SetMouseVisible(false)
    self:SetPosition(0, y)
    self:SetBackColorBlendMode(Turbine.UI.BlendMode.Overlay)

    self.width = width
    self.number = number

    self.label = Turbine.UI.Label()
    self.label:SetParent(self)
    self.label:SetPosition(5, 0)
    self.label:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    self.label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    self.label:SetText(args.Text)

    self.textbox = Turbine.UI.Lotro.TextBox()
    self.textbox:SetParent(self)
    self.textbox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    self.textbox:SetText(args.Value and tostring(args.Value))

    self.textbox.TextChanged = function ()
        self:ValueChanged()
    end

    self:Format()
end

function LabelTextboxControl:ValueChanged()

end

function LabelTextboxControl:Format()
    self:SetSize(self.width, 20)
    self.label:SetSize(self.width * .3, 20)
    self.textbox:SetPosition(self.width * .3, 0)
    self.textbox:SetSize(self.width * .7, 20)
end

function LabelTextboxControl:GetValue()
    if self.number then
        return tonumber(tostring(self.textbox:GetText()))
    else
        return tostring(self.textbox:GetText())
    end
end

function LabelTextboxControl:SetValue(value)
    self.textbox:SetText(tostring(value))
end

function CreateTriggerListBoxOptionsListboxItem(key, value, width, triggerType, UIType, func, listbox)
    local listBoxItem = Turbine.UI.Control()
    listBoxItem:SetMouseVisible(false)
    listBoxItem:SetSize(width, 20)
    listBoxItem:SetBackColor(Turbine.UI.Color.Black)

    local innerWidth = width - 2

    local optionsHeight = 0

    listBoxItem.InnerBox = Turbine.UI.Control()
    listBoxItem.InnerBox:SetParent(listBoxItem)
    listBoxItem.InnerBox:SetPosition(1, 1)
    listBoxItem.InnerBox:SetSize(innerWidth, 18)
    listBoxItem.InnerBox:SetBackColor(Turbine.UI.Color.DarkSlateBlue)
    
    listBoxItem.label = Turbine.UI.Label()
    listBoxItem.label:SetParent(listBoxItem.InnerBox)
	listBoxItem.label:SetSize(innerWidth, 25)
	listBoxItem.label:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold22)
	listBoxItem.label:SetPosition(0, optionsHeight)
    listBoxItem.label:SetText(tostring(key))
    listBoxItem.label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    listBoxItem.label:SetFontStyle(Turbine.UI.FontStyle.Outline)
    listBoxItem.label:SetOutlineColor(Turbine.UI.Color.Black)
    listBoxItem.label:SetBackColor(Turbine.UI.Color(0.2,0.15,0.53))

    
    listBoxItem.RemovalButton = Turbine.UI.Lotro.Button()
    listBoxItem.RemovalButton:SetParent(listBoxItem.InnerBox)
    listBoxItem.RemovalButton:SetSize(100, 20)
    listBoxItem.RemovalButton:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    listBoxItem.RemovalButton:SetMouseVisible(false)
    listBoxItem.RemovalButton:SetPosition(width - 110, optionsHeight + 2)
    listBoxItem.RemovalButton:SetText("Remove")

    optionsHeight = optionsHeight + listBoxItem.RemovalButton:GetHeight() + 5

    listBoxItem.RemovalButton.Click = function()
        func(key, nil)
        listbox:RemoveItem(listBoxItem)
    end

    listBoxItem.options = {}

    listBoxItem.DurationBox = OptionsControl(listBoxItem.InnerBox, width - 20, optionsHeight, {
        [1] = {
            ["Type"] = "Enable Checkbox",
            ["Text"] = "Start Timer",
            ["Variable"] = "Timer",
            ["Value"] = value.Timer
        },
        [2] = {
            ["Type"] = "Label Number Textbox",
            ["Text"] = "Timer Duration",
            ["Variable"] = "Timer_Duration",
            ["Value"] = value.Timer_Duration
        },
        [3] = {
            ["Type"] = "Enable Checkbox",
            ["Text"] = "From Trigger",
            ["Variable"] = "Special_Trigger",
            ["Value"] = value.Special_Trigger
        },
    })

    listBoxItem.DurationBox.ValueChanged = function()
        listBoxItem.ChangeFunction()
    end

    optionsHeight = optionsHeight + listBoxItem.DurationBox:GetHeight() + 5

    listBoxItem.ScaleBox = OptionsControl(listBoxItem.InnerBox, width - 20, optionsHeight, {
        [1] = {
            ["Type"] = "Enable Checkbox",
            ["Text"] = "Change Scale",
            ["Variable"] = "Change_Scale",
            ["Value"] = value.Change_Scale
        },
        [2] = {
            ["Type"] = "Label Number Textbox",
            ["Text"] = "Scale",
            ["Variable"] = "Change_Scale_Number",
            ["Value"] = value.Change_Scale_Number
        }
    })

    listBoxItem.ScaleBox.ValueChanged = function()
        listBoxItem.ChangeFunction()
    end

    optionsHeight = optionsHeight + listBoxItem.ScaleBox:GetHeight() + 5

    listBoxItem.ChangingScaleBox = OptionsControl(listBoxItem.InnerBox, width - 20, optionsHeight, {
        [1] = {
            ["Type"] = "Enable Checkbox",
            ["Text"] = "Change Scale Over Duration",
            ["Variable"] = "Change_Scale_Duration",
            ["Value"] = value.Change_Scale_Duration
        },
        [2] = {
            ["Type"] = "Label Number Textbox",
            ["Text"] = "Scale Start",
            ["Variable"] = "Change_Scale_Number_Start",
            ["Value"] = value.Change_Scale_Number_Start
        },
        [3] = {
            ["Type"] = "Label Number Textbox",
            ["Text"] = "Scale End",
            ["Variable"] = "Change_Scale_Number_End",
            ["Value"] = value.Change_Scale_Number_End
        }
    })

    listBoxItem.ChangingScaleBox.ValueChanged = function()
        listBoxItem.ChangeFunction()
    end

    optionsHeight = optionsHeight + listBoxItem.ChangingScaleBox:GetHeight() + 5

    listBoxItem.SetOpacityOptions = OptionsControl(listBoxItem.InnerBox, width - 20, optionsHeight, {
        [1] = {
            ["Type"] = "Enable Checkbox",
            ["Text"] = "Set Opacity",
            ["Variable"] = "Set_Opacity",
            ["Value"] = value.Set_Opacity
        },
        [2] = {
            ["Type"] = "Label Number Textbox",
            ["Text"] = "Opacity",
            ["Variable"] = "Set_Opacity_Number",
            ["Value"] = value.Set_Opacity_Number
        }
    })

    listBoxItem.SetOpacityOptions.ValueChanged = function()
        listBoxItem.ChangeFunction()
    end

    optionsHeight = optionsHeight + listBoxItem.SetOpacityOptions:GetHeight() + 5

    listBoxItem.ChangeOpacityOptions = OptionsControl(listBoxItem.InnerBox, width - 20, optionsHeight, {
        [1] = {
            ["Type"] = "Enable Checkbox",
            ["Text"] = "Change Opacity Over Duration",
            ["Variable"] = "Change_Opacity",
            ["Value"] = value.Change_Opacity
        },
        [2] = {
            ["Type"] = "Label Number Textbox",
            ["Text"] = "Start Opacity",
            ["Variable"] = "Start_Opacity",
            ["Value"] = value.Start_Opacity
        },
        [3] = {
            ["Type"] = "Label Number Textbox",
            ["Text"] = "End Opacity",
            ["Variable"] = "End_Opacity",
            ["Value"] = value.End_Opacity
        }
    })

    listBoxItem.ChangeOpacityOptions.ValueChanged = function()
        listBoxItem.ChangeFunction()
    end

    optionsHeight = optionsHeight + listBoxItem.ChangeOpacityOptions:GetHeight() + 5

    listBoxItem.ChangeText = OptionsControl(listBoxItem.InnerBox, width - 20, optionsHeight, {
        [1] = {
            ["Type"] = "Enable Checkbox",
            ["Text"] = "Change Text",
            ["Variable"] = "Change_Text",
            ["Value"] = value.Change_Text
        },
        [2] = {
            ["Type"] = "Label String Textbox",
            ["Text"] = "Text",
            ["Variable"] = "New_Text",
            ["Value"] = value.New_Text
        }
    })

    listBoxItem.ChangeText.ValueChanged = function()
        listBoxItem.ChangeFunction()
    end

    optionsHeight = optionsHeight + listBoxItem.ChangeText:GetHeight() + 5

    listBoxItem.ChangeRotation = OptionsControl(listBoxItem.InnerBox, width - 20, optionsHeight, {
        [1] = {
            ["Type"] = "Enable Checkbox",
            ["Text"] = "Rotate",
            ["Variable"] = "Rotate",
            ["Value"] = value.Rotate
        },
        [2] = {
            ["Type"] = "Label Number Textbox",
            ["Text"] = "Rotation Per Second",
            ["Variable"] = "Rotation_Per_Second",
            ["Value"] = value.Rotation_Per_Second
        }
    })

    listBoxItem.ChangeRotation.ValueChanged = function()
        listBoxItem.ChangeFunction()
    end

    optionsHeight = optionsHeight + listBoxItem.ChangeRotation:GetHeight() + 5
    
    listBoxItem.ChangeWiggle = OptionsControl(listBoxItem.InnerBox, width - 20, optionsHeight, {
        [1] = {
            ["Type"] = "Enable Checkbox",
            ["Text"] = "Change Wiggle State",
            ["Variable"] = "Wiggle",
            ["Value"] = value.Wiggle
        },
        [2] = {
            ["Type"] = "Enable Checkbox",
            ["Text"] = "Start Wiggle",
            ["Variable"] = "Start_Wiggle",
            ["Value"] = value.Start_Wiggle
        },
        [3] = {
            ["Type"] = "Enable Checkbox",
            ["Text"] = "End Wiggle",
            ["Variable"] = "End_Wiggle",
            ["Value"] = value.End_Wiggle
        }
    })

    listBoxItem.ChangeWiggle.ValueChanged = function()
        listBoxItem.ChangeFunction()
    end

    optionsHeight = optionsHeight + listBoxItem.ChangeWiggle:GetHeight() + 5

    listBoxItem.InnerBox:SetSize(innerWidth, optionsHeight)
    listBoxItem:SetSize(width, optionsHeight + 2)

    listBoxItem.ChangeFunction = function()
        func(key, nil)

        local timer_result = listBoxItem.DurationBox:GetValues()
        local scale_change_result = listBoxItem.ScaleBox:GetValues()
        local changing_scale_change_result = listBoxItem.ChangingScaleBox:GetValues()
        local set_opacity_result = listBoxItem.SetOpacityOptions:GetValues()
        local change_opacity_result = listBoxItem.ChangeOpacityOptions:GetValues()
        local change_text_result = listBoxItem.ChangeText:GetValues()
        local change_rotate_result = listBoxItem.ChangeRotation:GetValues()
        local change_wiggle_result = listBoxItem.ChangeWiggle:GetValues()

        local triggerEntry = {
            ["Trigger_Code"] = key,

            ["Timer"] = timer_result.Timer,
            ["Timer_Duration"] = timer_result.Timer_Duration,
            ["Special_Trigger"] = timer_result.Special_Trigger,

            ["Change_Scale"] = scale_change_result.Change_Scale,
            ["Change_Scale_Number"] = scale_change_result.Change_Scale_Number,

            ["Change_Scale_Duration"] = changing_scale_change_result.Change_Scale_Duration,
            ["Change_Scale_Number_Start"] = changing_scale_change_result.Change_Scale_Number_Start,
            ["Change_Scale_Number_End"] = changing_scale_change_result.Change_Scale_Number_End,

            ["Set_Opacity"] = set_opacity_result.Set_Opacity,
            ["Set_Opacity_Number"] = set_opacity_result.Set_Opacity_Number,

            ["Change_Opacity"] = change_opacity_result.Change_Opacity,
            ["Start_Opacity"] = change_opacity_result.Start_Opacity,
            ["End_Opacity"] = change_opacity_result.End_Opacity,

            ["Change_Text"] = change_text_result.Change_Text,
            ["New_Text"] = change_text_result.New_Text,

            ["Rotate"] = change_rotate_result.Rotate,
            ["Rotation_Per_Second"] = change_rotate_result.Rotation_Per_Second,

            ["Wiggle"] = change_wiggle_result.Wiggle,
            ["Start_Wiggle"] = change_wiggle_result.Start_Wiggle,
            ["End_Wiggle"] = change_wiggle_result.End_Wiggle,
        }
        func(key, triggerEntry) 
    end

    return listBoxItem
end