function GetQuickslotListboxItem(key, value, width, triggerType, UIType, func, listbox)
    local listBoxItem = Turbine.UI.Control()
    listBoxItem:SetMouseVisible(false)
    listBoxItem:SetSize(width, 20)
    listBoxItem:SetBackColor(Turbine.UI.Color.Black)

    local innerWidth = width - 2

    local itemHeight = 0

    listBoxItem.InnerBox = Turbine.UI.Control()
    listBoxItem.InnerBox:SetParent(listBoxItem)
    listBoxItem.InnerBox:SetPosition(1, 1)
    listBoxItem.InnerBox:SetSize(innerWidth, 18)
    listBoxItem.InnerBox:SetBackColor(Turbine.UI.Color.DarkSlateBlue)

    listBoxItem.RemovalButton = Turbine.UI.Lotro.Button()
    listBoxItem.RemovalButton:SetParent(listBoxItem.InnerBox)
    listBoxItem.RemovalButton:SetSize(100, 20)
    listBoxItem.RemovalButton:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    listBoxItem.RemovalButton:SetMouseVisible(false)
    listBoxItem.RemovalButton:SetPosition(width - 110, itemHeight + 2)
    listBoxItem.RemovalButton:SetText("Remove")

    listBoxItem.RemovalButton.Click = function()
        func(key, nil)
        listbox:RemoveItem(listBoxItem)
    end

    itemHeight = itemHeight + 35

    listBoxItem.slotBox = Turbine.UI.Lotro.Quickslot()
    listBoxItem.slotBox:SetParent(listBoxItem.InnerBox)
    listBoxItem.slotBox:SetSize(35, 35)
    listBoxItem.slotBox:SetPosition(0, itemHeight)
    local success, result = pcall(Turbine.UI.Lotro.Shortcut, value.Type, value.Data)
    if success then 
        pcall(listBoxItem.slotBox.SetShortcut, listBoxItem.slotBox, result)
        --listBoxItem.slotBox:SetShortcut(result)
    else
        success, result = pcall(Turbine.UI.Lotro.Shortcut, value.Item)
        if success then 
            pcall(listBoxItem.slotBox.SetShortcut, listBoxItem.slotBox, result)
            --listBoxItem.slotBox:SetShortcut(result)
        else
            success, result = pcall(Turbine.UI.Lotro.Shortcut, value.Code)
            if success then 
                pcall(listBoxItem.slotBox.SetShortcut, listBoxItem.slotBox, result)
                --listBoxItem.slotBox:SetShortcut(result)
            end
        end
    end

    itemHeight = itemHeight + 35

    -- X & Y
    listBoxItem.XLabel = Turbine.UI.Label()
    listBoxItem.XLabel:SetParent(listBoxItem.InnerBox)
    listBoxItem.XLabel:SetSize(60, 20)
    listBoxItem.XLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    listBoxItem.XLabel:SetPosition(0, itemHeight)
    listBoxItem.XLabel:SetText("X-order:")

    listBoxItem.XBox = Turbine.UI.Lotro.TextBox()
    listBoxItem.XBox:SetParent(listBoxItem.InnerBox)
    listBoxItem.XBox:SetSize(50, 20)
    listBoxItem.XBox:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    listBoxItem.XBox:SetPosition(60, itemHeight)
    listBoxItem.XBox:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    listBoxItem.XBox:SetText(tostring(value.XPrio))

    listBoxItem.XBox.TextChanged = function()
        listBoxItem.ChangeFunction()
    end

    listBoxItem.YLabel = Turbine.UI.Label()
    listBoxItem.YLabel:SetParent(listBoxItem.InnerBox)
    listBoxItem.YLabel:SetSize(60, 20)
    listBoxItem.YLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    listBoxItem.YLabel:SetPosition(110, itemHeight)
    listBoxItem.YLabel:SetText("Y-order:")

    listBoxItem.YBox = Turbine.UI.Lotro.TextBox()
    listBoxItem.YBox:SetParent(listBoxItem.InnerBox)
    listBoxItem.YBox:SetSize(50, 20)
    listBoxItem.YBox:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    listBoxItem.YBox:SetPosition(170, itemHeight)
    listBoxItem.YBox:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    listBoxItem.YBox:SetText(tostring(value.YPrio))

    listBoxItem.YBox.TextChanged = function()
        listBoxItem.ChangeFunction()
    end

    itemHeight = itemHeight + 25

    if value.HideOnType and value.HideOnType ~= "" then
        listBoxItem.YLabel = Turbine.UI.Label()
        listBoxItem.YLabel:SetParent(listBoxItem.InnerBox)
        listBoxItem.YLabel:SetSize(300, 20)
        listBoxItem.YLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
        listBoxItem.YLabel:SetPosition(0, itemHeight)
        listBoxItem.YLabel:SetText("Only show on removable:" .. tostring(value.HideOnType))

        itemHeight = itemHeight + 25
    end

    listBoxItem.InnerBox:SetSize(innerWidth, itemHeight)
    listBoxItem:SetSize(width, itemHeight + 2)

    listBoxItem.ChangeFunction = function()
        func(key, nil)

        local rewrittenValue = {}
        for valueKey, valueValue in pairs(value) do
            rewrittenValue[valueKey] = valueValue
        end

        -- Check X & Y Prio
        if listBoxItem.XBox then
            rewrittenValue.XPrio = tonumber(listBoxItem.XBox:GetText())
        end

        if listBoxItem.YBox then
            rewrittenValue.YPrio = tonumber(listBoxItem.YBox:GetText())
        end


        func(key, rewrittenValue)
    end

    return listBoxItem
end

function GetSkillBarQuickslotListboxItem(key, value, width, triggerType, UIType, func, listbox)
    local listBoxItem = Turbine.UI.Control()
    listBoxItem:SetMouseVisible(false)
    listBoxItem:SetSize(width, 20)
    listBoxItem:SetBackColor(Turbine.UI.Color.Black)

    local innerWidth = width - 2

    local itemHeight = 0

    listBoxItem.InnerBox = Turbine.UI.Control()
    listBoxItem.InnerBox:SetParent(listBoxItem)
    listBoxItem.InnerBox:SetPosition(1, 1)
    listBoxItem.InnerBox:SetSize(innerWidth, 18)
    listBoxItem.InnerBox:SetBackColor(Turbine.UI.Color.DarkSlateBlue)

    listBoxItem.RemovalButton = Turbine.UI.Lotro.Button()
    listBoxItem.RemovalButton:SetParent(listBoxItem.InnerBox)
    listBoxItem.RemovalButton:SetSize(100, 20)
    listBoxItem.RemovalButton:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    listBoxItem.RemovalButton:SetMouseVisible(false)
    listBoxItem.RemovalButton:SetPosition(width - 110, itemHeight + 2)
    listBoxItem.RemovalButton:SetText("Remove")

    listBoxItem.RemovalButton.Click = function()
        func(key, nil)
        listbox:RemoveItem(listBoxItem)
    end

    itemHeight = itemHeight + 35

    listBoxItem.slotBox = Turbine.UI.Lotro.Quickslot()
    listBoxItem.slotBox:SetParent(listBoxItem.InnerBox)
    listBoxItem.slotBox:SetSize(35, 35)
    listBoxItem.slotBox:SetPosition(0, itemHeight)
    local success, result = pcall(Turbine.UI.Lotro.Shortcut, value.Type, value.Data)
    if success then 
        pcall(listBoxItem.slotBox.SetShortcut, listBoxItem.slotBox, result)
        --listBoxItem.slotBox:SetShortcut(result)
    else
        success, result = pcall(Turbine.UI.Lotro.Shortcut, value.Item)
        if success then 
            pcall(listBoxItem.slotBox.SetShortcut, listBoxItem.slotBox, result)
            --listBoxItem.slotBox:SetShortcut(result)
        else
            success, result = pcall(Turbine.UI.Lotro.Shortcut, value.Code)
            if success then 
                pcall(listBoxItem.slotBox.SetShortcut, listBoxItem.slotBox, result)
                --listBoxItem.slotBox:SetShortcut(result)
            end
        end
    end

    listBoxItem.timerLabel = Turbine.UI.Label()
    listBoxItem.timerLabel:SetParent(listBoxItem.InnerBox)
    listBoxItem.timerLabel:SetSize(50, 20)
    listBoxItem.timerLabel:SetPosition(80, itemHeight)
    listBoxItem.timerLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    listBoxItem.timerLabel:SetText("Timer:")

    listBoxItem.timeBar = Turbine.UI.Lotro.TextBox()
    listBoxItem.timeBar:SetParent(listBoxItem.InnerBox)
    listBoxItem.timeBar:SetSize(50, 20)
    listBoxItem.timeBar:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    listBoxItem.timeBar:SetPosition(170, itemHeight)
    listBoxItem.timeBar:SetText(value.Time == true and "" or tonumber(value.Number) or "")

    listBoxItem.timeBar.TextChanged = function()
        listBoxItem.ChangeFunction()
    end
    
    listBoxItem.timerCheckBox = Turbine.UI.Lotro.CheckBox()
    listBoxItem.timerCheckBox:SetParent(listBoxItem.InnerBox)
    listBoxItem.timerCheckBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    listBoxItem.timerCheckBox:SetText("Use skill cooldown as time")
    listBoxItem.timerCheckBox:SetPosition(width - 250, itemHeight)
    listBoxItem.timerCheckBox:SetSize(250, 20)
    listBoxItem.timerCheckBox:SetChecked(value.Time == true)

    listBoxItem.timerCheckBox.CheckedChanged = function()
        listBoxItem.ChangeFunction()
    end

    itemHeight = itemHeight + 40

    
    listBoxItem.xBox = Turbine.UI.Label()
    listBoxItem.xBox:SetParent(listBoxItem.InnerBox)
    listBoxItem.xBox:SetSize(100, 20)
    listBoxItem.xBox:SetPosition(0, itemHeight)
    listBoxItem.xBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    listBoxItem.xBox:SetText("X-position:")

    listBoxItem.xBoxValue = Turbine.UI.Lotro.TextBox()
    listBoxItem.xBoxValue:SetParent(listBoxItem.InnerBox)
    listBoxItem.xBoxValue:SetSize(50, 20)
    listBoxItem.xBoxValue:SetPosition(100, itemHeight)
    listBoxItem.xBoxValue:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    listBoxItem.xBoxValue:SetText(tostring(value.XPrio))

    listBoxItem.xBoxValue.TextChanged = function()
        listBoxItem.ChangeFunction()
    end

    listBoxItem.yBox = Turbine.UI.Label()
    listBoxItem.yBox:SetParent(listBoxItem.InnerBox)
    listBoxItem.yBox:SetSize(100, 20)
    listBoxItem.yBox:SetPosition(170, itemHeight)
    listBoxItem.yBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    listBoxItem.yBox:SetText("Y-position:")

    listBoxItem.yBoxValue = Turbine.UI.Lotro.TextBox()
    listBoxItem.yBoxValue:SetParent(listBoxItem.InnerBox)
    listBoxItem.yBoxValue:SetSize(50, 20)
    listBoxItem.yBoxValue:SetPosition(270, itemHeight)
    listBoxItem.yBoxValue:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    listBoxItem.yBoxValue:SetText(tostring(value.YPrio))
    
    listBoxItem.yBoxValue.TextChanged = function()
        listBoxItem.ChangeFunction()
    end

    itemHeight = itemHeight + 25

    listBoxItem.eventLabel = Turbine.UI.Label()
    listBoxItem.eventLabel:SetParent(listBoxItem.InnerBox)
    listBoxItem.eventLabel:SetSize(60, 20)
    listBoxItem.eventLabel:SetPosition(0, itemHeight)
    listBoxItem.eventLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    listBoxItem.eventLabel:SetText("Events:")

    listBoxItem.eventBox = Turbine.UI.Lotro.TextBox()
    listBoxItem.eventBox:SetParent(listBoxItem.InnerBox)
    listBoxItem.eventBox:SetSize(350, 20)
    listBoxItem.eventBox:SetPosition(100, itemHeight)
    listBoxItem.eventBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    listBoxItem.eventBox:SetText(tostring(value.Events))

    listBoxItem.eventBox.TextChanged = function()
        listBoxItem.ChangeFunction()
    end

    itemHeight = itemHeight + 25

    listBoxItem.durationAlignmentLabel = Turbine.UI.Label()
    listBoxItem.durationAlignmentLabel:SetParent(listBoxItem.InnerBox)
    listBoxItem.durationAlignmentLabel:SetSize(200, 20)
    listBoxItem.durationAlignmentLabel:SetPosition(0, itemHeight)
    listBoxItem.durationAlignmentLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    listBoxItem.durationAlignmentLabel:SetText("Duration Alignment")

    listBoxItem.durationAlignmentMenu = Turbine.UI.Lotro.Button()
    listBoxItem.durationAlignmentMenu:SetParent(listBoxItem.InnerBox)
    listBoxItem.durationAlignmentMenu:SetSize(200, 20)
    listBoxItem.durationAlignmentMenu:SetPosition(150, itemHeight)
    listBoxItem.durationAlignmentMenu:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    listBoxItem.durationAlignmentMenu:SetText(tostring(value.Duration_Alignment))

    listBoxItem.menu = Turbine.UI.ContextMenu()
    listBoxItem.menuItems = listBoxItem.menu:GetItems()

    local sortedKeys = {}
    for key, _ in pairs(Turbine.UI.ContentAlignment) do table.insert( sortedKeys, key ) end
    table.sort( sortedKeys )

    for key, name in pairs(sortedKeys) do
        local menuItem = Turbine.UI.MenuItem( name )

        menuItem.Click = function()
            listBoxItem.durationAlignmentMenu:SetText(name)
            listBoxItem.ChangeFunction()
        end
        
        listBoxItem.menuItems:Add(menuItem)
    end

    listBoxItem.durationAlignmentMenu.Click = function()
        listBoxItem.menu:ShowMenu()
    end

    listBoxItem.durationAlignmentMenu.TextChanged = function()
        listBoxItem.ChangeFunction()
    end

    itemHeight = itemHeight + 25

    listBoxItem.durationFontLabel = Turbine.UI.Label()
    listBoxItem.durationFontLabel:SetParent(listBoxItem.InnerBox)
    listBoxItem.durationFontLabel:SetSize(200, 20)
    listBoxItem.durationFontLabel:SetPosition(0, itemHeight)
    listBoxItem.durationFontLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    listBoxItem.durationFontLabel:SetText("Duration Font:")

    listBoxItem.durationFontMenu = Turbine.UI.Lotro.Button()
    listBoxItem.durationFontMenu:SetParent(listBoxItem.InnerBox)
    listBoxItem.durationFontMenu:SetSize(100, 20)
    listBoxItem.durationFontMenu:SetPosition(150, itemHeight)
    listBoxItem.durationFontMenu:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    listBoxItem.durationFontMenu:SetText(tostring(value.Duration_Font))

    listBoxItem.fontmenu = Turbine.UI.ContextMenu()
    listBoxItem.fontmenuItems = listBoxItem.fontmenu:GetItems()

    local fontsortedKeys = {}
    for key, _ in pairs(Turbine.UI.Lotro.Font) do table.insert( fontsortedKeys, key ) end
    table.sort( fontsortedKeys )

    for key, name in pairs(fontsortedKeys) do
        local menuItem = Turbine.UI.MenuItem( name )

        menuItem.Click = function()
            listBoxItem.durationFontMenu:SetText(name)
            listBoxItem.ChangeFunction()
        end
        
        listBoxItem.fontmenuItems:Add(menuItem)
    end

    listBoxItem.durationFontMenu.Click = function()
        listBoxItem.fontmenu:ShowMenu()
    end

    listBoxItem.durationFontMenu.TextChanged = function()
        listBoxItem.ChangeFunction()
    end

    listBoxItem.durationCheckbox = Turbine.UI.Lotro.CheckBox()
    listBoxItem.durationCheckbox:SetParent(listBoxItem.InnerBox)
    listBoxItem.durationCheckbox:SetSize(200, 20)
    listBoxItem.durationCheckbox:SetPosition(270, itemHeight)
    listBoxItem.durationCheckbox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    listBoxItem.durationCheckbox:SetText("Show duration")
    listBoxItem.durationCheckbox:SetChecked(value.Show_Duration)

    listBoxItem.durationCheckbox.CheckedChanged = function()
        listBoxItem.ChangeFunction()
    end

    itemHeight = itemHeight + 25

    listBoxItem.keybindLabel = Turbine.UI.Label()
    listBoxItem.keybindLabel:SetParent(listBoxItem.InnerBox)
    listBoxItem.keybindLabel:SetSize(60, 20)
    listBoxItem.keybindLabel:SetPosition(0, itemHeight)
    listBoxItem.keybindLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    listBoxItem.keybindLabel:SetText("Keybind:")

    listBoxItem.keybindBox = Turbine.UI.Lotro.TextBox()
    listBoxItem.keybindBox:SetParent(listBoxItem.InnerBox)
    listBoxItem.keybindBox:SetSize(50, 20)
    listBoxItem.keybindBox:SetPosition(100, itemHeight)
    listBoxItem.keybindBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    listBoxItem.keybindBox:SetText(tostring(value.Keybind_Text))
    
    listBoxItem.keybindBox.TextChanged = function()
        listBoxItem.ChangeFunction()
    end

    listBoxItem.keybindCheckbox = Turbine.UI.Lotro.CheckBox()
    listBoxItem.keybindCheckbox:SetParent(listBoxItem.InnerBox)
    listBoxItem.keybindCheckbox:SetSize(200, 20)
    listBoxItem.keybindCheckbox:SetPosition(230, itemHeight)
    listBoxItem.keybindCheckbox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    listBoxItem.keybindCheckbox:SetText("Show Keybind")
    listBoxItem.keybindCheckbox:SetChecked(value.Show_Keybind)

    listBoxItem.keybindCheckbox.CheckedChanged = function()
        listBoxItem.ChangeFunction()
    end

    itemHeight = itemHeight + 25

    listBoxItem.keybindAlignmentLabel = Turbine.UI.Label()
    listBoxItem.keybindAlignmentLabel:SetParent(listBoxItem.InnerBox)
    listBoxItem.keybindAlignmentLabel:SetSize(200, 20)
    listBoxItem.keybindAlignmentLabel:SetPosition(0, itemHeight)
    listBoxItem.keybindAlignmentLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    listBoxItem.keybindAlignmentLabel:SetText("Keybind Text Alignment")

    listBoxItem.keybindAlignmentMenu = Turbine.UI.Lotro.Button()
    listBoxItem.keybindAlignmentMenu:SetParent(listBoxItem.InnerBox)
    listBoxItem.keybindAlignmentMenu:SetSize(300, 20)
    listBoxItem.keybindAlignmentMenu:SetPosition(150, itemHeight)
    listBoxItem.keybindAlignmentMenu:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    listBoxItem.keybindAlignmentMenu:SetText(tostring(value.Keybind_Alignment))

    listBoxItem.keybindMenu = Turbine.UI.ContextMenu()
    listBoxItem.keybindMenuItems = listBoxItem.keybindMenu:GetItems()

    for key, name in pairs(sortedKeys) do
        local menuItem = Turbine.UI.MenuItem( name )

        menuItem.Click = function()
            listBoxItem.keybindAlignmentMenu:SetText(name)
            listBoxItem.ChangeFunction()
        end
        
        listBoxItem.keybindMenuItems:Add(menuItem)
    end

    listBoxItem.keybindAlignmentMenu.Click = function()
        listBoxItem.keybindMenu:ShowMenu()
    end

    listBoxItem.keybindAlignmentMenu.TextChanged = function()
        listBoxItem.ChangeFunction()
    end

    itemHeight = itemHeight + 25

    listBoxItem.keybindFontLabel = Turbine.UI.Label()
    listBoxItem.keybindFontLabel:SetParent(listBoxItem.InnerBox)
    listBoxItem.keybindFontLabel:SetSize(200, 20)
    listBoxItem.keybindFontLabel:SetPosition(0, itemHeight)
    listBoxItem.keybindFontLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    listBoxItem.keybindFontLabel:SetText("Keybind Font:")

    listBoxItem.keybindFontMenu = Turbine.UI.Lotro.Button()
    listBoxItem.keybindFontMenu:SetParent(listBoxItem.InnerBox)
    listBoxItem.keybindFontMenu:SetSize(100, 20)
    listBoxItem.keybindFontMenu:SetPosition(150, itemHeight)
    listBoxItem.keybindFontMenu:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    listBoxItem.keybindFontMenu:SetText(tostring(value.Keybind_Font))
    
    listBoxItem.keybindFontmenu = Turbine.UI.ContextMenu()
    listBoxItem.keybindFontmenuItems = listBoxItem.keybindFontmenu:GetItems()

    for key, name in pairs(fontsortedKeys) do
        local menuItem = Turbine.UI.MenuItem( name )

        menuItem.Click = function()
            listBoxItem.keybindFontMenu:SetText(name)
            listBoxItem.ChangeFunction()
        end
        
        listBoxItem.keybindFontmenuItems:Add(menuItem)
    end

    listBoxItem.keybindFontMenu.Click = function()
        listBoxItem.keybindFontmenu:ShowMenu()
    end

    listBoxItem.keybindFontMenu.TextChanged = function()
        listBoxItem.ChangeFunction()
    end

    itemHeight = itemHeight + 25

    listBoxItem.hideLabel = Turbine.UI.Label()
    listBoxItem.hideLabel:SetParent(listBoxItem.InnerBox)
    listBoxItem.hideLabel:SetSize(150, 20)
    listBoxItem.hideLabel:SetPosition(0, itemHeight)
    listBoxItem.hideLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    listBoxItem.hideLabel:SetText("Hide When:")

    listBoxItem.hideOnCheckbox = Turbine.UI.Lotro.CheckBox()
    listBoxItem.hideOnCheckbox:SetParent(listBoxItem.InnerBox)
    listBoxItem.hideOnCheckbox:SetSize(150, 20)
    listBoxItem.hideOnCheckbox:SetPosition(170, itemHeight)
    listBoxItem.hideOnCheckbox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    listBoxItem.hideOnCheckbox:SetText("Timer Active")
    listBoxItem.hideOnCheckbox:SetChecked(value.Hide_While_Timer_Active)

    listBoxItem.hideOnCheckbox.CheckedChanged = function()
        listBoxItem.ChangeFunction()
    end

    listBoxItem.hideOffCheckbox = Turbine.UI.Lotro.CheckBox()
    listBoxItem.hideOffCheckbox:SetParent(listBoxItem.InnerBox)
    listBoxItem.hideOffCheckbox:SetSize(150, 20)
    listBoxItem.hideOffCheckbox:SetPosition(330, itemHeight)
    listBoxItem.hideOffCheckbox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    listBoxItem.hideOffCheckbox:SetText("Timer Inactive")
    listBoxItem.hideOffCheckbox:SetChecked(value.Hide_While_Timer_Inactive)

    listBoxItem.hideOffCheckbox.CheckedChanged = function()
        listBoxItem.ChangeFunction()
    end

    itemHeight = itemHeight + 25
    
    --[[
    listBoxItem.opacityLabel = Turbine.UI.Label()
    listBoxItem.opacityLabel:SetParent(listBoxItem.InnerBox)
    listBoxItem.opacityLabel:SetSize(250, 20)
    listBoxItem.opacityLabel:SetPosition(0, itemHeight)
    listBoxItem.opacityLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    listBoxItem.opacityLabel:SetText("Opacity When Timer Inactive:")

    listBoxItem.opacityOnCheckbox = Turbine.UI.Lotro.TextBox()
    listBoxItem.opacityOnCheckbox:SetParent(listBoxItem.InnerBox)
    listBoxItem.opacityOnCheckbox:SetSize(150, 20)
    listBoxItem.opacityOnCheckbox:SetPosition(250, itemHeight)
    listBoxItem.opacityOnCheckbox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    listBoxItem.opacityOnCheckbox:SetText(tostring(value.Opacity_While_Timer_Active))

    listBoxItem.opacityOnCheckbox.TextChanged = function()
        listBoxItem.ChangeFunction()
    end

    itemHeight = itemHeight + 25
    
    listBoxItem.opacityOffLabel = Turbine.UI.Label()
    listBoxItem.opacityOffLabel:SetParent(listBoxItem.InnerBox)
    listBoxItem.opacityOffLabel:SetSize(250, 20)
    listBoxItem.opacityOffLabel:SetPosition(0, itemHeight)
    listBoxItem.opacityOffLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    listBoxItem.opacityOffLabel:SetText("Opacity When Timer Inactive:")

    listBoxItem.opacityOffCheckbox = Turbine.UI.Lotro.TextBox()
    listBoxItem.opacityOffCheckbox:SetParent(listBoxItem.InnerBox)
    listBoxItem.opacityOffCheckbox:SetSize(150, 20)
    listBoxItem.opacityOffCheckbox:SetPosition(250, itemHeight)
    listBoxItem.opacityOffCheckbox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    listBoxItem.opacityOffCheckbox:SetText(tostring(value.Opacity_While_Timer_Inactive))

    listBoxItem.opacityOffCheckbox.TextChanged = function()
        listBoxItem.ChangeFunction()
    end
    
    itemHeight = itemHeight + 25
    --]]

    listBoxItem.highlgihtOnReady = Turbine.UI.Label()
    listBoxItem.highlgihtOnReady:SetParent(listBoxItem.InnerBox)
    listBoxItem.highlgihtOnReady:SetSize(250, 20)
    listBoxItem.highlgihtOnReady:SetPosition(0, itemHeight)
    listBoxItem.highlgihtOnReady:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    listBoxItem.highlgihtOnReady:SetText("Highlight When Timer Expires:")

    listBoxItem.highlgihtOnReadyTextbox = Turbine.UI.Lotro.TextBox()
    listBoxItem.highlgihtOnReadyTextbox:SetParent(listBoxItem.InnerBox)
    listBoxItem.highlgihtOnReadyTextbox:SetSize(50, 20)
    listBoxItem.highlgihtOnReadyTextbox:SetPosition(250, itemHeight)
    listBoxItem.highlgihtOnReadyTextbox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    listBoxItem.highlgihtOnReadyTextbox:SetText(tostring(value.highlightOnReady))

    listBoxItem.highlgihtOnReadyTextbox.TextChanged = function()
        listBoxItem.ChangeFunction()
    end

    itemHeight = itemHeight + 25

    listBoxItem.visibitilityThresholdLabel = Turbine.UI.Label()
    listBoxItem.visibitilityThresholdLabel:SetParent(listBoxItem.InnerBox)
    listBoxItem.visibitilityThresholdLabel:SetSize(150, 20)
    listBoxItem.visibitilityThresholdLabel:SetPosition(0, itemHeight)
    listBoxItem.visibitilityThresholdLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    listBoxItem.visibitilityThresholdLabel:SetText("Visibility Threshold:")

    listBoxItem.visibitilityThresholdTextbox = Turbine.UI.Lotro.TextBox()
    listBoxItem.visibitilityThresholdTextbox:SetParent(listBoxItem.InnerBox)
    listBoxItem.visibitilityThresholdTextbox:SetSize(150, 20)
    listBoxItem.visibitilityThresholdTextbox:SetPosition(250, itemHeight)
    listBoxItem.visibitilityThresholdTextbox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    listBoxItem.visibitilityThresholdTextbox:SetText(tostring(value.visibitilityThreshold))

    listBoxItem.visibitilityThresholdTextbox.TextChanged = function()
        listBoxItem.ChangeFunction()
    end

    itemHeight = itemHeight + 25

    listBoxItem.decimalLabel = Turbine.UI.Label()
    listBoxItem.decimalLabel:SetParent(listBoxItem.InnerBox)
    listBoxItem.decimalLabel:SetSize(150, 20)
    listBoxItem.decimalLabel:SetPosition(0, itemHeight)
    listBoxItem.decimalLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    listBoxItem.decimalLabel:SetText("Decimal Threshold:")

    listBoxItem.decimalTextbox = Turbine.UI.Lotro.TextBox()
    listBoxItem.decimalTextbox:SetParent(listBoxItem.InnerBox)
    listBoxItem.decimalTextbox:SetSize(100, 20)
    listBoxItem.decimalTextbox:SetPosition(150, itemHeight)
    listBoxItem.decimalTextbox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    listBoxItem.decimalTextbox:SetText(value.Decimal_Threshold)

    listBoxItem.decimalTextbox.TextChanged = function()
        listBoxItem.ChangeFunction()
    end

    listBoxItem.unitsCheckbox = Turbine.UI.Lotro.CheckBox()
    listBoxItem.unitsCheckbox:SetParent(listBoxItem.InnerBox)
    listBoxItem.unitsCheckbox:SetSize(150, 20)
    listBoxItem.unitsCheckbox:SetPosition(250, itemHeight)
    listBoxItem.unitsCheckbox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    listBoxItem.unitsCheckbox:SetText("Use Units")
    listBoxItem.unitsCheckbox:SetChecked(value.Use_Units)

    listBoxItem.unitsCheckbox.CheckedChanged = function()
        listBoxItem.ChangeFunction()
    end

    itemHeight = itemHeight + 25

    listBoxItem.onlyShowOnSkillCheckbox = Turbine.UI.Lotro.CheckBox()
    listBoxItem.onlyShowOnSkillCheckbox:SetParent(listBoxItem.InnerBox)
    listBoxItem.onlyShowOnSkillCheckbox:SetSize(350, 20)
    listBoxItem.onlyShowOnSkillCheckbox:SetPosition(0, itemHeight)
    listBoxItem.onlyShowOnSkillCheckbox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    listBoxItem.onlyShowOnSkillCheckbox:SetText("Only show when detected (skill)")
    listBoxItem.onlyShowOnSkillCheckbox:SetChecked(value.Skill_Check)

    listBoxItem.onlyShowOnSkillCheckbox.CheckedChanged = function()
        listBoxItem.ChangeFunction()
    end

    listBoxItem.hideQuickslotCheckbox = Turbine.UI.Lotro.CheckBox()
    listBoxItem.hideQuickslotCheckbox:SetParent(listBoxItem.InnerBox)
    listBoxItem.hideQuickslotCheckbox:SetSize(150, 20)
    listBoxItem.hideQuickslotCheckbox:SetPosition(350, itemHeight)
    listBoxItem.hideQuickslotCheckbox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    listBoxItem.hideQuickslotCheckbox:SetText("Hide quickslot")
    listBoxItem.hideQuickslotCheckbox:SetChecked(value.Hide_Quickslot)

    listBoxItem.hideQuickslotCheckbox.CheckedChanged = function()
        listBoxItem.ChangeFunction()
    end

    itemHeight = itemHeight + 25

    listBoxItem.eventKeywordLabel = Turbine.UI.Label()
    listBoxItem.eventKeywordLabel:SetParent(listBoxItem.InnerBox)
    listBoxItem.eventKeywordLabel:SetSize(120, 20)
    listBoxItem.eventKeywordLabel:SetPosition(0, itemHeight)
    listBoxItem.eventKeywordLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    listBoxItem.eventKeywordLabel:SetText("Event Keyword:")

    listBoxItem.eventKeywordTextbox = Turbine.UI.Lotro.TextBox()
    listBoxItem.eventKeywordTextbox:SetParent(listBoxItem.InnerBox)
    listBoxItem.eventKeywordTextbox:SetSize(250, 20)
    listBoxItem.eventKeywordTextbox:SetPosition(150, itemHeight)
    listBoxItem.eventKeywordTextbox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    listBoxItem.eventKeywordTextbox:SetText(value.Event_Keyword or "")

    listBoxItem.eventKeywordTextbox.TextChanged = function()
        listBoxItem.ChangeFunction()
    end

    itemHeight = itemHeight + 25

    listBoxItem.InnerBox:SetSize(innerWidth, itemHeight)
    listBoxItem:SetSize(width, itemHeight + 2)

    listBoxItem.ChangeFunction = function()
        func(key, nil)

        local rewrittenValue = {}
        for valueKey, valueValue in pairs(value) do
            rewrittenValue[valueKey] = valueValue
        end

        -- Check X & Y Prio
        if listBoxItem.xBoxValue then
            rewrittenValue.XPrio = tonumber(listBoxItem.xBoxValue:GetText()) or 1
        end

        if listBoxItem.yBoxValue then
            rewrittenValue.YPrio = tonumber(listBoxItem.yBoxValue:GetText()) or 1
        end

        if listBoxItem.keybindCheckbox then
            rewrittenValue.Show_Keybind = listBoxItem.keybindCheckbox:IsChecked()
        end

        if listBoxItem.keybindFontMenu then
            rewrittenValue.Keybind_Font = tostring(listBoxItem.keybindFontMenu:GetText())
        end

        if listBoxItem.keybindBox then
            rewrittenValue.Keybind_Text = tostring(listBoxItem.keybindBox:GetText())
        end

        if listBoxItem.keybindAlignmentMenu then
            rewrittenValue.Keybind_Alignment = tostring(listBoxItem.keybindAlignmentMenu:GetText())
        end

        if listBoxItem.eventBox then
            rewrittenValue.Events = tostring(listBoxItem.eventBox:GetText())
        end

        if listBoxItem.hideOnCheckbox then
            rewrittenValue.Hide_While_Timer_Active = listBoxItem.hideOnCheckbox:IsChecked()
        end

        if listBoxItem.hideOffCheckbox then
            rewrittenValue.Hide_While_Timer_Inactive = listBoxItem.hideOffCheckbox:IsChecked()
        end

        --[[
        if listBoxItem.opacityOnCheckbox then
            rewrittenValue.Opacity_While_Timer_Inactive = tonumber(tostring(listBoxItem.opacityOnCheckbox:GetText())) or 1
        end

        if listBoxItem.opacityOffCheckbox then
            rewrittenValue.Opacity_While_Timer_Active = tonumber(tostring(listBoxItem.opacityOffCheckbox:GetText())) or 1
        end
        --]]

        if listBoxItem.highlgihtOnReadyTextbox then
            rewrittenValue.highlightOnReady = tonumber(tostring(listBoxItem.highlgihtOnReadyTextbox:GetText())) or 1
        end

        if listBoxItem.visibitilityThresholdTextbox then
            rewrittenValue.visibitilityThreshold = tonumber(tostring(listBoxItem.visibitilityThresholdTextbox:GetText())) or 1
        end

        if listBoxItem.durationCheckbox then
            rewrittenValue.Show_Duration = listBoxItem.durationCheckbox:IsChecked()
        end

        if listBoxItem.durationAlignmentMenu then
            rewrittenValue.Duration_Alignment = tostring(listBoxItem.durationAlignmentMenu:GetText())
        end

        if listBoxItem.durationFontMenu then
            rewrittenValue.Duration_Font = tostring(listBoxItem.durationFontMenu:GetText())
        end

        if listBoxItem.decimalTextbox then
            rewrittenValue.Decimal_Threshold = tonumber(tostring(listBoxItem.decimalTextbox:GetText()))
        end

        if listBoxItem.unitsCheckbox then
            rewrittenValue.Use_Units = listBoxItem.unitsCheckbox:IsChecked()
        end

        if listBoxItem.hideQuickslotCheckbox then
            rewrittenValue.Hide_Quickslot = listBoxItem.hideQuickslotCheckbox:IsChecked()
        end

        if listBoxItem.onlyShowOnSkillCheckbox then
            rewrittenValue.Skill_Check = listBoxItem.onlyShowOnSkillCheckbox:IsChecked()
        end

        if listBoxItem.eventKeywordTextbox then
            rewrittenValue.Event_Keyword = listBoxItem.eventKeywordTextbox:GetText() or ""
        end

        func(key, rewrittenValue)
    end

    listBoxItem.Unload = function()
        listBoxItem.menuItems:Clear()
        listBoxItem.menuItems = nil
        listBoxItem.menu = nil
        listBoxItem.fontmenuItems:Clear()
        listBoxItem.fontmenuItems = nil
        listBoxItem.fontmenu = nil
        listBoxItem.keybindMenuItems:Clear()
        listBoxItem.keybindMenuItems = nil
        listBoxItem.keybindMenu = nil
        listBoxItem.keybindFontmenuItems:Clear()
        listBoxItem.keybindFontmenuItems = nil
        listBoxItem.keybindFontmenu = nil
        local elementsToClearParent = {
            "InnerBox", "RemovalButton", "slotBox", "timerLabel", "timeBar", "timerCheckBox", 
            "xBox", "xBoxValue", "yBox", "yBoxValue",
            "eventLabel", "eventBox", "durationAlignmentLabel", "durationAlignmentMenu",
            "durationFontLabel", "durationFontMenu", "durationCheckbox", "keybindLabel",
            "keybindBox", "keybindCheckbox", "keybindAlignmentLabel", "keybindAlignmentMenu",
            "keybindFontLabel", "keybindFontMenu", "hideLabel", "hideOnCheckbox",
            "hideOffCheckbox", "highlgihtOnReady", "highlgihtOnReadyTextbox",
            "visibitilityThresholdLabel", "visibitilityThresholdTextbox",
            "decimalLabel", "decimalTextbox", "unitsCheckbox",
            "onlyShowOnSkillCheckbox", "hideQuickslotCheckbox",
            "eventKeywordLabel", "eventKeywordTextbox"
        }

        for _, elementName in ipairs(elementsToClearParent) do
            listBoxItem[elementName]:SetParent(nil)
            listBoxItem[elementName] = nil
        end
        func = nil
        collectgarbage()
        collectgarbage()
    end

    return listBoxItem
end

function GetQuickslotEventListboxItem(key, value, width, triggerType, UIType, func, listbox)
    local listBoxItem = Turbine.UI.Control()
    listBoxItem:SetMouseVisible(false)
    listBoxItem:SetSize(width, 20)
    listBoxItem:SetBackColor(Turbine.UI.Color.Black)

    local innerWidth = width - 2

    local itemHeight = 0

    listBoxItem.InnerBox = Turbine.UI.Control()
    listBoxItem.InnerBox:SetParent(listBoxItem)
    listBoxItem.InnerBox:SetPosition(1, 1)
    listBoxItem.InnerBox:SetSize(innerWidth, 18)
    listBoxItem.InnerBox:SetBackColor(Turbine.UI.Color.DarkSlateBlue)

    listBoxItem.RemovalButton = Turbine.UI.Lotro.Button()
    listBoxItem.RemovalButton:SetParent(listBoxItem.InnerBox)
    listBoxItem.RemovalButton:SetSize(100, 20)
    listBoxItem.RemovalButton:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    listBoxItem.RemovalButton:SetMouseVisible(false)
    listBoxItem.RemovalButton:SetPosition(width - 110, itemHeight + 2)
    listBoxItem.RemovalButton:SetText("Remove")

    listBoxItem.RemovalButton.Click = function()
        func(key, nil)
        listbox:RemoveItem(listBoxItem)
    end

    listBoxItem.eventLabel = Turbine.UI.Label()
    listBoxItem.eventLabel:SetParent(listBoxItem.InnerBox)
    listBoxItem.eventLabel:SetSize(300, 20)
    listBoxItem.eventLabel:SetPosition(0, itemHeight)
    listBoxItem.eventLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    listBoxItem.eventLabel:SetText("Event Name: " .. tostring(key))

    itemHeight = itemHeight + 35

    listBoxItem.highligtCheckbox = Turbine.UI.Lotro.CheckBox()
    listBoxItem.highligtCheckbox:SetParent(listBoxItem.InnerBox)
    listBoxItem.highligtCheckbox:SetSize(250, 20)
    listBoxItem.highligtCheckbox:SetPosition(0, itemHeight)
    listBoxItem.highligtCheckbox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    listBoxItem.highligtCheckbox:SetText("Turn On Highlight")
    listBoxItem.highligtCheckbox:SetChecked(value.HiglightValue)

    listBoxItem.highligtCheckbox.CheckedChanged = function()
        listBoxItem.ChangeFunction()
    end
    
    listBoxItem.highligtOffCheckbox = Turbine.UI.Lotro.CheckBox()
    listBoxItem.highligtOffCheckbox:SetParent(listBoxItem.InnerBox)
    listBoxItem.highligtOffCheckbox:SetSize(250, 20)
    listBoxItem.highligtOffCheckbox:SetPosition(250, itemHeight)
    listBoxItem.highligtOffCheckbox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    listBoxItem.highligtOffCheckbox:SetText("Turn Off Highlight")
    listBoxItem.highligtOffCheckbox:SetChecked(value.HiglightValue == false)

    listBoxItem.highligtOffCheckbox.CheckedChanged = function()
        listBoxItem.ChangeFunction()
    end
    
    itemHeight = itemHeight + 20
    
    listBoxItem.highligtTimedCheckbox = Turbine.UI.Lotro.CheckBox()
    listBoxItem.highligtTimedCheckbox:SetParent(listBoxItem.InnerBox)
    listBoxItem.highligtTimedCheckbox:SetSize(250, 20)
    listBoxItem.highligtTimedCheckbox:SetPosition(0, itemHeight)
    listBoxItem.highligtTimedCheckbox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    listBoxItem.highligtTimedCheckbox:SetText("Timed Highlight")
    listBoxItem.highligtTimedCheckbox:SetChecked(value.HiglightTimed)

    listBoxItem.highligtTimedCheckbox.CheckedChanged = function()
        listBoxItem.ChangeFunction()
    end
    
    listBoxItem.highlightTimerTextBox = Turbine.UI.Lotro.TextBox()
    listBoxItem.highlightTimerTextBox:SetParent(listBoxItem.InnerBox)
    listBoxItem.highlightTimerTextBox:SetSize(50, 20)
    listBoxItem.highlightTimerTextBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    listBoxItem.highlightTimerTextBox:SetPosition(250, itemHeight)
    listBoxItem.highlightTimerTextBox:SetText(value.HighlightTimer or "0")


    listBoxItem.highlightTimerTextBox.TextChanged = function()
        listBoxItem.ChangeFunction()
    end
    
    itemHeight = itemHeight + 40

    --[[
    listBoxItem.opacityCheckbox = Turbine.UI.Lotro.CheckBox()
    listBoxItem.opacityCheckbox:SetParent(listBoxItem.InnerBox)
    listBoxItem.opacityCheckbox:SetSize(250, 20)
    listBoxItem.opacityCheckbox:SetPosition(0, itemHeight)
    listBoxItem.opacityCheckbox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    listBoxItem.opacityCheckbox:SetText("Change Opacity")
    listBoxItem.opacityCheckbox:SetChecked(value.OpacityEvent)

    
    listBoxItem.opacityCheckbox.TextChanged = function()
        listBoxItem.ChangeFunction()
    end

    listBoxItem.opacityTextBox = Turbine.UI.Lotro.TextBox()
    listBoxItem.opacityTextBox:SetParent(listBoxItem.InnerBox)
    listBoxItem.opacityTextBox:SetSize(50, 20)
    listBoxItem.opacityTextBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    listBoxItem.opacityTextBox:SetPosition(250, itemHeight)
    listBoxItem.opacityTextBox:SetText(value.OpacityValue or "1")

    
    listBoxItem.opacityTextBox.TextChanged = function()
        listBoxItem.ChangeFunction()
    end

    itemHeight = itemHeight + 20
    --]]

    listBoxItem.visibiltyCheckbox = Turbine.UI.Lotro.CheckBox()
    listBoxItem.visibiltyCheckbox:SetParent(listBoxItem.InnerBox)
    listBoxItem.visibiltyCheckbox:SetSize(250, 20)
    listBoxItem.visibiltyCheckbox:SetPosition(0, itemHeight)
    listBoxItem.visibiltyCheckbox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    listBoxItem.visibiltyCheckbox:SetText("Change Visiblity")
    listBoxItem.visibiltyCheckbox:SetChecked(value.VisibleEvent)



    itemHeight = itemHeight + 20

    listBoxItem.visibiltyOnCheckbox = Turbine.UI.Lotro.CheckBox()
    listBoxItem.visibiltyOnCheckbox:SetParent(listBoxItem.InnerBox)
    listBoxItem.visibiltyOnCheckbox:SetSize(250, 20)
    listBoxItem.visibiltyOnCheckbox:SetPosition(0, itemHeight)
    listBoxItem.visibiltyOnCheckbox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    listBoxItem.visibiltyOnCheckbox:SetText("Set Visible")
    listBoxItem.visibiltyOnCheckbox:SetEnabled(listBoxItem.visibiltyCheckbox:IsChecked())
    listBoxItem.visibiltyOnCheckbox:SetChecked(value.VisibilityValueOn)
    listBoxItem.visibiltyOnCheckbox:SetForeColor(Turbine.UI.Color(0.75, 0.75, 0.75))

    listBoxItem.visibiltyOnCheckbox.CheckedChanged = function()
        listBoxItem.ChangeFunction()
    end

    listBoxItem.visibiltyOffCheckbox = Turbine.UI.Lotro.CheckBox()
    listBoxItem.visibiltyOffCheckbox:SetParent(listBoxItem.InnerBox)
    listBoxItem.visibiltyOffCheckbox:SetSize(250, 20)
    listBoxItem.visibiltyOffCheckbox:SetPosition(250, itemHeight)
    listBoxItem.visibiltyOffCheckbox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    listBoxItem.visibiltyOffCheckbox:SetText("Set Invisible")
    listBoxItem.visibiltyOffCheckbox:SetEnabled(listBoxItem.visibiltyCheckbox:IsChecked())
    listBoxItem.visibiltyOffCheckbox:SetChecked(value.VisibilityValueOff)
    listBoxItem.visibiltyOffCheckbox:SetForeColor(Turbine.UI.Color(0.75, 0.75, 0.75))

    listBoxItem.visibiltyOffCheckbox.CheckedChanged = function()
        listBoxItem.ChangeFunction()
    end

    listBoxItem.visibiltyCheckbox.CheckedChanged = function()
        local enabled = listBoxItem.visibiltyCheckbox:IsChecked()
        listBoxItem.visibiltyOnCheckbox:SetEnabled(enabled)
        listBoxItem.visibiltyOffCheckbox:SetEnabled(enabled)
        if enabled then
            listBoxItem.visibiltyOnCheckbox:SetForeColor(Turbine.UI.Color.White)
            listBoxItem.visibiltyOffCheckbox:SetForeColor(Turbine.UI.Color.White)
        else
            listBoxItem.visibiltyOnCheckbox:SetForeColor(Turbine.UI.Color(0.75, 0.75, 0.75))
            listBoxItem.visibiltyOffCheckbox:SetForeColor(Turbine.UI.Color(0.75, 0.75, 0.75))
        end
        listBoxItem.ChangeFunction()
    end

    itemHeight = itemHeight + 40

    listBoxItem.timerCheckbox = Turbine.UI.Lotro.CheckBox()
    listBoxItem.timerCheckbox:SetParent(listBoxItem.InnerBox)
    listBoxItem.timerCheckbox:SetSize(250, 20)
    listBoxItem.timerCheckbox:SetPosition(0, itemHeight)
    listBoxItem.timerCheckbox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    listBoxItem.timerCheckbox:SetText("Start Timer")
    listBoxItem.timerCheckbox:SetChecked(value.TimerEvent)

    listBoxItem.timerCheckbox.CheckedChanged = function()
        listBoxItem.ChangeFunction()
    end

    listBoxItem.timerTextBox = Turbine.UI.Lotro.TextBox()
    listBoxItem.timerTextBox:SetParent(listBoxItem.InnerBox)
    listBoxItem.timerTextBox:SetSize(50, 20)
    listBoxItem.timerTextBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    listBoxItem.timerTextBox:SetPosition(250, itemHeight)
    listBoxItem.timerTextBox:SetText(value.TimerValue or "0")

    listBoxItem.timerTextBox.TextChanged = function()
        listBoxItem.ChangeFunction()
    end

    itemHeight = itemHeight + 40


    listBoxItem.InnerBox:SetSize(innerWidth, itemHeight)
    listBoxItem:SetSize(width, itemHeight + 2)

    listBoxItem.ChangeFunction = function()
        func(key, nil)

        local rewrittenValue = {}
        for valueKey, valueValue in pairs(value) do
            rewrittenValue[valueKey] = valueValue
        end

        -- Highlight
        local highlightEvent = (listBoxItem.highligtCheckbox:IsChecked() or listBoxItem.highligtOffCheckbox:IsChecked())

        if listBoxItem.highligtCheckbox then
            rewrittenValue.HiglightValue = (listBoxItem.highligtCheckbox:IsChecked() or listBoxItem.highligtOffCheckbox:IsChecked() and false or nil) or nil
        end 

        if listBoxItem.highligtCheckbox then
            rewrittenValue.HiglightEvent = highlightEvent  or nil
        end

        if listBoxItem.highligtTimedCheckbox then
            rewrittenValue.HiglightTimed = highlightEvent and listBoxItem.highligtTimedCheckbox:IsChecked() or nil
        end

        if listBoxItem.highlightTimerTextBox then
            rewrittenValue.HighlightTimer = highlightEvent and tonumber(listBoxItem.highlightTimerTextBox:GetText())  or nil
        end

        -- Opacity
        --[[
        local opacityEvent = listBoxItem.opacityCheckbox:IsChecked()

        if listBoxItem.opacityCheckbox then
            rewrittenValue.OpacityEvent = opacityEvent and listBoxItem.opacityCheckbox:IsChecked() or nil
        end

        if listBoxItem.highlightTimerTextBox then
            rewrittenValue.OpacityValue = opacityEvent and tonumber(listBoxItem.opacityTextBox:GetText())  or nil
        end
        --]]

        -- Visibility
        local visibilityEvent = listBoxItem.visibiltyCheckbox:IsChecked()

        if listBoxItem.visibiltyCheckbox then
            rewrittenValue.VisibleEvent = visibilityEvent and listBoxItem.visibiltyCheckbox:IsChecked() or nil
        end

        if listBoxItem.visibiltyOnCheckbox then
            rewrittenValue.VisibilityValueOn = visibilityEvent and listBoxItem.visibiltyOnCheckbox:IsChecked() or nil
        end

        if listBoxItem.visibiltyOffCheckbox then
            rewrittenValue.VisibilityValueOff = visibilityEvent and listBoxItem.visibiltyOffCheckbox:IsChecked()  or nil
        end

        -- Timer
        local timerEvent = listBoxItem.timerCheckbox:IsChecked()

        if listBoxItem.timerCheckbox then
            rewrittenValue.TimerEvent = timerEvent or nil
        end

        if listBoxItem.timerTextBox then
            rewrittenValue.TimerValue = timerEvent and tonumber(listBoxItem.timerTextBox:GetText())  or nil
        end

        func(key, rewrittenValue)
    end

    return listBoxItem
end
