function CreateQuickslotOptions(width, triggerType, listboxItems, UIType, func, optionPage)
    local headerNode = Turbine.UI.TreeNode()
    headerNode:SetMouseVisible(false)
    headerNode:SetSize(width, 20)

    -- The header label with the trigger name
    headerNode.label = Turbine.UI.Label()
    headerNode.label:SetParent(headerNode)
    headerNode.label:SetSize(width, 20)
    headerNode.label:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    headerNode.label:SetPosition(0, 0)
    headerNode.label:SetText(triggerType)
    headerNode.label:SetBackColor(Turbine.UI.Color.Black)

    local optionsTreeNode = headerNode:GetChildNodes()

    local valuebar = Turbine.UI.TreeNode()
    valuebar:SetPosition(0, 0)
    valuebar:SetMouseVisible(false)
   --valuebar:SetBackColor(GetRandomColour())

   local optionsHeight = 0
   local listboxHeight = 350

    valuebar.optionsControl = Turbine.UI.Control()
	valuebar.optionsControl:SetParent(valuebar)
    valuebar.optionsControl:SetPosition(0, 0)
    valuebar.optionsControl:SetBackColor(Turbine.UI.Color.DarkSlateGray)

    valuebar.slotInfo = Turbine.UI.Label()
    valuebar.slotInfo:SetParent(valuebar.optionsControl)
    valuebar.slotInfo:SetSize(200, 20)
    valuebar.slotInfo:SetPosition(0, optionsHeight)
    valuebar.slotInfo:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    valuebar.slotInfo:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleRight)
    valuebar.slotInfo:SetText("Drag item/skill etc here ->")

    valuebar.slotBox = Turbine.UI.Lotro.Quickslot()
    valuebar.slotBox:SetParent(valuebar.optionsControl)
    valuebar.slotBox:SetSize(35, 35)
    valuebar.slotBox:SetPosition(220, optionsHeight)

    optionsHeight = optionsHeight + 45

    valuebar.xBox = Turbine.UI.Label()
    valuebar.xBox:SetParent(valuebar.optionsControl)
    valuebar.xBox:SetSize(60, 20)
    valuebar.xBox:SetPosition(0, optionsHeight)
    valuebar.xBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    valuebar.xBox:SetText("X-order:")

    valuebar.xBoxValue = Turbine.UI.Lotro.TextBox()
    valuebar.xBoxValue:SetParent(valuebar.optionsControl)
    valuebar.xBoxValue:SetSize(50, 20)
    valuebar.xBoxValue:SetPosition(60, optionsHeight)
    valuebar.xBoxValue:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)

    valuebar.yBox = Turbine.UI.Label()
    valuebar.yBox:SetParent(valuebar.optionsControl)
    valuebar.yBox:SetSize(60, 20)
    valuebar.yBox:SetPosition(110, optionsHeight)
    valuebar.yBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    valuebar.yBox:SetText("Y-order:")

    valuebar.yBoxValue = Turbine.UI.Lotro.TextBox()
    valuebar.yBoxValue:SetParent(valuebar.optionsControl)
    valuebar.yBoxValue:SetSize(50, 20)
    valuebar.yBoxValue:SetPosition(170, optionsHeight)
    valuebar.yBoxValue:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)

    valuebar.orderBoxShowInfo = InfoButton(valuebar.optionsControl, width, 220, optionsHeight + 2, "The X and Y order is where in the grid the skill is placed. These are not coordinates, but the order of the skills. The skillbar will place the skill on the appropriate Y level and then sort all skills based on their X order.", optionPage.infoWindow)

    optionsHeight = optionsHeight + 25

    valuebar.categoryLabel = Turbine.UI.Lotro.CheckBox()
    valuebar.categoryLabel:SetParent(valuebar.optionsControl)
    valuebar.categoryLabel:SetSize(220, 20)
    valuebar.categoryLabel:SetPosition(0, optionsHeight)
    valuebar.categoryLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    valuebar.categoryLabel:SetText("Only show on removable:")

    valuebar.categoryButton = Turbine.UI.Lotro.Button()
    valuebar.categoryButton:SetParent(valuebar.optionsControl)
    valuebar.categoryButton:SetSize(100, 20)
    valuebar.categoryButton:SetPosition(220, optionsHeight)
    valuebar.categoryButton:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)

    valuebar.categoryMenu = UI.DropDownMenuControl(valuebar, 200, "Tier Menu Dropdown Menu")
    for key, value in pairs(Turbine.Gameplay.EffectCategory) do
        valuebar.categoryMenu:AddItem(key, 
        function()
            valuebar.categoryButton:SetText(key)
            valuebar.categoryMenu:ToggleVisible()
        end)
    end

    valuebar.categoryButton.Click = function()
        valuebar.categoryMenu:ToggleVisible()
    end

    valuebar.categoryShowInfo = InfoButton(valuebar.optionsControl, width, 320, optionsHeight + 2, "This quick slot will only be shown if this type of removable effect is applied to the player.", optionPage.infoWindow)

    optionsHeight = optionsHeight + 25

    valuebar.addTriggerEntryButton = Turbine.UI.Lotro.Button()
    valuebar.addTriggerEntryButton:SetParent(valuebar)
    valuebar.addTriggerEntryButton:SetSize(100, 20)
    valuebar.addTriggerEntryButton:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    valuebar.addTriggerEntryButton:SetPosition(width - 120, optionsHeight)
    valuebar.addTriggerEntryButton:SetText("Add")

    optionsHeight = optionsHeight + 20

    -- Set options control to match all its children
    valuebar.optionsControl:SetSize(width, optionsHeight)

    -- Add listbox for items
    valuebar.listbox = Turbine.UI.ListBox()
    valuebar.listbox:SetParent(valuebar)
    valuebar.listbox:SetSize(width - 10, listboxHeight)
    valuebar.listbox:SetPosition(0, valuebar.optionsControl:GetHeight())
    valuebar.listbox:SetVisible(tablelength(listboxItems) > 0)

    valuebar.Scrollbar = Turbine.UI.Lotro.ScrollBar()
    valuebar.Scrollbar:SetOrientation(Turbine.UI.Orientation.Vertical)
    valuebar.Scrollbar:SetParent(valuebar)
    valuebar.Scrollbar:SetPosition(width - 10, valuebar.optionsControl:GetHeight())
    valuebar.Scrollbar:SetSize(10, listboxHeight)
    valuebar.Scrollbar:SetBackColor(Turbine.UI.Color.DarkSlateGray)
    valuebar.listbox:SetVerticalScrollBar(valuebar.Scrollbar)

    for key, value in pairs(listboxItems) do
        valuebar.listbox:AddItem(GetQuickslotListboxItem(key, value, width - 10, triggerType, UIType, func, valuebar.listbox))
    end

    valuebar.addTriggerEntryButton.Click = function()
        local xPrio = tonumber(tostring(valuebar.xBoxValue:GetText()))
        local yPrio = tonumber(tostring(valuebar.yBoxValue:GetText()))
        local shortcutData = valuebar.slotBox:GetShortcut():GetData()
        local shortcutType = valuebar.slotBox:GetShortcut():GetType()
        local shortcutItem = valuebar.slotBox:GetShortcut():GetItem()
        local ID = Turbine.Engine.GetGameTime()

        if not(shortcutData) or not(shortcutType) or not(ID) or not(xPrio) or not(yPrio) then ChatOutput("Not all fields are correctly filled!"); return end

        local triggerEntry = {["Code"] = code, ["XPrio"] = xPrio, ["YPrio"] = yPrio, ["Type"] = shortcutType, ["Data"] = shortcutData, ["Item"] = shortcutItem, ["HideOnType"] = valuebar.categoryLabel and valuebar.categoryLabel:IsChecked() and valuebar.categoryButton:GetText() or ""}

        if func(ID, triggerEntry) then
            return
        end

        valuebar.listbox:AddItem(GetQuickslotListboxItem(ID, triggerEntry, width - 10, triggerType, UIType, func, valuebar.listbox))
        valuebar.listbox:SetVisible(true)
    end

    valuebar:SetSize(width, valuebar.listbox:GetHeight() + valuebar.optionsControl:GetHeight())

    optionsTreeNode:Add(valuebar.optionsControl)

    optionsTreeNode:Add(valuebar)

    headerNode.Unload = function()
        ClearListbox(valuebar.listbox)
        RecursiveDeletion(valuebar)
        ClearNodes(optionsTreeNode)
    end

    return headerNode
end

function CreateSkillBarQuickslotOptions(width, triggerType, listboxItems, UIType, func, optionPage)
    local headerNode = Turbine.UI.TreeNode()
    headerNode:SetMouseVisible(false)
    headerNode:SetSize(width, 20)

    -- The header label with the trigger name
    headerNode.label = Turbine.UI.Label()
    headerNode.label:SetParent(headerNode)
    headerNode.label:SetSize(width, 20)
    headerNode.label:SetPosition(0, 0)
    headerNode.label:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    headerNode.label:SetText(triggerType)
    headerNode.label:SetBackColor(Turbine.UI.Color.Black)

    local optionsTreeNode = headerNode:GetChildNodes()

    local valuebar = Turbine.UI.TreeNode()
    valuebar:SetPosition(0, 0)
    valuebar:SetMouseVisible(false)
   --valuebar:SetBackColor(GetRandomColour())

   local optionsHeight = 0
   local listboxHeight = 600

   valuebar.showboxesTable = {}

    valuebar.optionsControl = Turbine.UI.Control()
	valuebar.optionsControl:SetParent(valuebar)
    valuebar.optionsControl:SetPosition(0, 0)
    valuebar.optionsControl:SetBackColor(Turbine.UI.Color.DarkSlateGray)

    valuebar.slotInfo = Turbine.UI.Label()
    valuebar.slotInfo:SetParent(valuebar.optionsControl)
    valuebar.slotInfo:SetSize(210, 40)
    valuebar.slotInfo:SetPosition(0, optionsHeight)
    valuebar.slotInfo:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    valuebar.slotInfo:SetTextAlignment(Turbine.UI.ContentAlignment.TopLeft)
    valuebar.slotInfo:SetText("Drag item/skill etc here ->\nOr use the skill list")

    valuebar.slotBox = Turbine.UI.Lotro.Quickslot()
    valuebar.slotBox:SetParent(valuebar.optionsControl)
    valuebar.slotBox:SetSize(35, 35)
    valuebar.slotBox:SetPosition(220, optionsHeight)

    valuebar.timeBar = Turbine.UI.Lotro.TextBox()
    valuebar.timeBar:SetParent(valuebar.optionsControl)
    valuebar.timeBar:SetSize(50, 20)
    valuebar.timeBar:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    valuebar.timeBar:SetPosition(width - 50, optionsHeight)
    valuebar.timeBar:SetText("Time")

    valuebar.timerCheckBox = Turbine.UI.Lotro.CheckBox()
    valuebar.timerCheckBox:SetParent(valuebar.optionsControl)
    valuebar.timerCheckBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    valuebar.timerCheckBox:SetText("Use skill cooldown as time")
    valuebar.timerCheckBox:SetPosition(width - 280, optionsHeight)
    valuebar.timerCheckBox:SetSize(220, 20)

    optionsHeight = optionsHeight + 40

    valuebar.text = Turbine.UI.Label()
    valuebar.text:SetParent(valuebar.optionsControl)
    valuebar.text:SetSize(210, 40)
    valuebar.text:SetPosition(0, optionsHeight)
    valuebar.text:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    valuebar.text:SetTextAlignment(Turbine.UI.ContentAlignment.TopLeft)
    valuebar.text:SetText("")
    valuebar.text:SetVisible(false)

    valuebar.slotInfo2 = Turbine.UI.Lotro.Button()
    valuebar.slotInfo2:SetParent(valuebar.optionsControl)
    valuebar.slotInfo2:SetSize(100, 20)
    valuebar.slotInfo2:SetPosition(50, optionsHeight)
    valuebar.slotInfo2:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    valuebar.slotInfo2:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    valuebar.slotInfo2:SetText("Skill List")

    valuebar.slotInfo2.Click = function()
        local skillOverview = optionPage:AllSkillOverview()
        skillOverview:SetVisible(true)
        skillOverview:Register(valuebar.text, valuebar.slotBox)
    end

    valuebar.clearInfo = Turbine.UI.Lotro.Button()
    valuebar.clearInfo:SetParent(valuebar.optionsControl)
    valuebar.clearInfo:SetSize(100, 20)
    valuebar.clearInfo:SetPosition(200, optionsHeight)
    valuebar.clearInfo:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    valuebar.clearInfo:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    valuebar.clearInfo:SetText("Clear Slot")

    valuebar.clearInfo.Click = function()
        valuebar.slotBox:SetShortcut(Turbine.UI.Lotro.Shortcut())
    end

    optionsHeight = optionsHeight + 25


    valuebar.xBox = Turbine.UI.Label()
    valuebar.xBox:SetParent(valuebar.optionsControl)
    valuebar.xBox:SetSize(100, 20)
    valuebar.xBox:SetPosition(0, optionsHeight)
    valuebar.xBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    valuebar.xBox:SetText("X-position:")

    valuebar.xBoxValue = Turbine.UI.Lotro.TextBox()
    valuebar.xBoxValue:SetParent(valuebar.optionsControl)
    valuebar.xBoxValue:SetSize(50, 20)
    valuebar.xBoxValue:SetPosition(100, optionsHeight)
    valuebar.xBoxValue:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    valuebar.xBoxValue:SetText("1")

    table.insert(valuebar.showboxesTable, InfoButton(valuebar.optionsControl, width, 150, optionsHeight + 2, "The X and Y order is where in the grid the skill is placed. These are not coordinates, but the order of the skills. The skillbar will place the skill on the appropriate Y level and then sort all skills based on their X order.", optionPage.infoWindow))

    valuebar.yBox = Turbine.UI.Label()
    valuebar.yBox:SetParent(valuebar.optionsControl)
    valuebar.yBox:SetSize(100, 20)
    valuebar.yBox:SetPosition(170, optionsHeight)
    valuebar.yBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    valuebar.yBox:SetText("Y-position:")

    valuebar.yBoxValue = Turbine.UI.Lotro.TextBox()
    valuebar.yBoxValue:SetParent(valuebar.optionsControl)
    valuebar.yBoxValue:SetSize(50, 20)
    valuebar.yBoxValue:SetPosition(270, optionsHeight)
    valuebar.yBoxValue:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    valuebar.yBoxValue:SetText("1")

    table.insert(valuebar.showboxesTable, InfoButton(valuebar.optionsControl, width, 320, optionsHeight + 2, "The X and Y order is where in the grid the skill is placed. These are not coordinates, but the order of the skills. The skillbar will place the skill on the appropriate Y level and then sort all skills based on their X order.", optionPage.infoWindow))
    
    optionsHeight = optionsHeight + 25

    valuebar.eventLabel = Turbine.UI.Label()
    valuebar.eventLabel:SetParent(valuebar.optionsControl)
    valuebar.eventLabel:SetSize(60, 20)
    valuebar.eventLabel:SetPosition(0, optionsHeight)
    valuebar.eventLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    valuebar.eventLabel:SetText("Events:")

    table.insert(valuebar.showboxesTable, InfoButton(valuebar.optionsControl, width, 60, optionsHeight + 2, "All the events this quickslot will reacto to. Multiple events can be specified, each of these events need to be split by a \",\". For example Event1,Event2,Event3.", optionPage.infoWindow))

    valuebar.eventBox = Turbine.UI.Lotro.TextBox()
    valuebar.eventBox:SetParent(valuebar.optionsControl)
    valuebar.eventBox:SetSize(350, 20)
    valuebar.eventBox:SetPosition(100, optionsHeight)
    valuebar.eventBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)

    optionsHeight = optionsHeight + 25

    valuebar.durationAlignmentLabel = Turbine.UI.Label()
    valuebar.durationAlignmentLabel:SetParent(valuebar.optionsControl)
    valuebar.durationAlignmentLabel:SetSize(200, 20)
    valuebar.durationAlignmentLabel:SetPosition(0, optionsHeight)
    valuebar.durationAlignmentLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    valuebar.durationAlignmentLabel:SetText("Duration Alignment")

    valuebar.durationAlignmentMenu = Turbine.UI.Lotro.Button()
    valuebar.durationAlignmentMenu:SetParent(valuebar.optionsControl)
    valuebar.durationAlignmentMenu:SetSize(200, 20)
    valuebar.durationAlignmentMenu:SetPosition(150, optionsHeight)
    valuebar.durationAlignmentMenu:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    valuebar.durationAlignmentMenu:SetText("MiddleCenter")

    table.insert(valuebar.showboxesTable, InfoButton(valuebar.optionsControl, width, 350, optionsHeight + 2, "The place on the quickslot where the duration text is placed.", optionPage.infoWindow))

    valuebar.menu = Turbine.UI.ContextMenu()
    valuebar.menuItems = valuebar.menu:GetItems()

    local sortedKeys = {}
    for key, _ in pairs(optionPage.textAlignments) do table.insert( sortedKeys, key ) end
    table.sort( sortedKeys )

    for key, name in pairs(sortedKeys) do
        local menuItem = Turbine.UI.MenuItem( name )

        menuItem.Click = function()
            valuebar.durationAlignmentMenu:SetText(name)
        end
        
        valuebar.menuItems:Add(menuItem)
    end

    valuebar.durationAlignmentMenu.Click = function()
        valuebar.menu:ShowMenu()
    end

    optionsHeight = optionsHeight + 25

    valuebar.durationFontLabel = Turbine.UI.Label()
    valuebar.durationFontLabel:SetParent(valuebar.optionsControl)
    valuebar.durationFontLabel:SetSize(200, 20)
    valuebar.durationFontLabel:SetPosition(0, optionsHeight)
    valuebar.durationFontLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    valuebar.durationFontLabel:SetText("Duration Font:")

    valuebar.durationFontMenu = Turbine.UI.Lotro.Button()
    valuebar.durationFontMenu:SetParent(valuebar.optionsControl)
    valuebar.durationFontMenu:SetSize(100, 20)
    valuebar.durationFontMenu:SetPosition(150, optionsHeight)
    valuebar.durationFontMenu:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    valuebar.durationFontMenu:SetText("FixedSys15")

    valuebar.fontmenu = Turbine.UI.ContextMenu()
    valuebar.fontmenuItems = valuebar.fontmenu:GetItems()

    local fontsortedKeys = {}
    for key, _ in pairs(Turbine.UI.Lotro.Font) do table.insert( fontsortedKeys, key ) end
    table.sort( fontsortedKeys )

    for key, name in pairs(fontsortedKeys) do
        local menuItem = Turbine.UI.MenuItem( name )

        menuItem.Click = function()
            valuebar.durationFontMenu:SetText(name)
        end
        
        valuebar.fontmenuItems:Add(menuItem)
    end

    valuebar.durationFontMenu.Click = function()
        valuebar.fontmenu:ShowMenu()
    end

    valuebar.durationCheckbox = Turbine.UI.Lotro.CheckBox()
    valuebar.durationCheckbox:SetParent(valuebar.optionsControl)
    valuebar.durationCheckbox:SetSize(200, 20)
    valuebar.durationCheckbox:SetPosition(270, optionsHeight)
    valuebar.durationCheckbox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    valuebar.durationCheckbox:SetText("Show duration")
    valuebar.durationCheckbox:SetChecked(true)

    table.insert(valuebar.showboxesTable, InfoButton(valuebar.optionsControl, width, 400, optionsHeight + 2, "Toggles the duration text on the quickslot. An important note is that the duration is still active for other purposes, just not visible.", optionPage.infoWindow))

    optionsHeight = optionsHeight + 25

    valuebar.keybindLabel = Turbine.UI.Label()
    valuebar.keybindLabel:SetParent(valuebar.optionsControl)
    valuebar.keybindLabel:SetSize(60, 20)
    valuebar.keybindLabel:SetPosition(0, optionsHeight)
    valuebar.keybindLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    valuebar.keybindLabel:SetText("Keybind:")

    valuebar.keybindBox = Turbine.UI.Lotro.TextBox()
    valuebar.keybindBox:SetParent(valuebar.optionsControl)
    valuebar.keybindBox:SetSize(50, 20)
    valuebar.keybindBox:SetPosition(100, optionsHeight)
    valuebar.keybindBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)

    valuebar.keybindCheckbox = Turbine.UI.Lotro.CheckBox()
    valuebar.keybindCheckbox:SetParent(valuebar.optionsControl)
    valuebar.keybindCheckbox:SetSize(200, 20)
    valuebar.keybindCheckbox:SetPosition(230, optionsHeight)
    valuebar.keybindCheckbox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    valuebar.keybindCheckbox:SetText("Show Keybind")

    table.insert(valuebar.showboxesTable, InfoButton(valuebar.optionsControl, width, 350, optionsHeight + 2, "This will show a keybind text on the quickslot. Important note this does not mean the keybind will activate the quickslot, it is purely cosmetic.", optionPage.infoWindow))

    optionsHeight = optionsHeight + 25

    valuebar.keybindAlignmentLabel = Turbine.UI.Label()
    valuebar.keybindAlignmentLabel:SetParent(valuebar.optionsControl)
    valuebar.keybindAlignmentLabel:SetSize(200, 20)
    valuebar.keybindAlignmentLabel:SetPosition(0, optionsHeight)
    valuebar.keybindAlignmentLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    valuebar.keybindAlignmentLabel:SetText("Keybind Alignment")

    valuebar.keybindAlignmentMenu = Turbine.UI.Lotro.Button()
    valuebar.keybindAlignmentMenu:SetParent(valuebar.optionsControl)
    valuebar.keybindAlignmentMenu:SetSize(200, 20)
    valuebar.keybindAlignmentMenu:SetPosition(150, optionsHeight)
    valuebar.keybindAlignmentMenu:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    valuebar.keybindAlignmentMenu:SetText("BottomRight")

    valuebar.keybindMenu = Turbine.UI.ContextMenu()
    valuebar.keybindMenuItems = valuebar.keybindMenu:GetItems()

    for key, name in pairs(sortedKeys) do
        local menuItem = Turbine.UI.MenuItem( name )

        menuItem.Click = function()
            valuebar.keybindAlignmentMenu:SetText(name)
        end
        
        valuebar.keybindMenuItems:Add(menuItem)
    end

    valuebar.keybindAlignmentMenu.Click = function()
        valuebar.keybindMenu:ShowMenu()
    end

    optionsHeight = optionsHeight + 25

    valuebar.keybindFontLabel = Turbine.UI.Label()
    valuebar.keybindFontLabel:SetParent(valuebar.optionsControl)
    valuebar.keybindFontLabel:SetSize(200, 20)
    valuebar.keybindFontLabel:SetPosition(0, optionsHeight)
    valuebar.keybindFontLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    valuebar.keybindFontLabel:SetText("Keybind Font:")

    valuebar.keybindFontMenu = Turbine.UI.Lotro.Button()
    valuebar.keybindFontMenu:SetParent(valuebar.optionsControl)
    valuebar.keybindFontMenu:SetSize(100, 20)
    valuebar.keybindFontMenu:SetPosition(150, optionsHeight)
    valuebar.keybindFontMenu:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    valuebar.keybindFontMenu:SetText("Verdana12")

    valuebar.keybindFontmenu = Turbine.UI.ContextMenu()
    valuebar.keybindFontmenuItems = valuebar.keybindFontmenu:GetItems()

    for key, name in pairs(fontsortedKeys) do
        local menuItem = Turbine.UI.MenuItem( name )

        menuItem.Click = function()
            valuebar.keybindFontMenu:SetText(name)
        end
        
        valuebar.keybindFontmenuItems:Add(menuItem)
    end

    valuebar.keybindFontMenu.Click = function()
        valuebar.keybindFontmenu:ShowMenu()
    end

    optionsHeight = optionsHeight + 25

    valuebar.hideLabel = Turbine.UI.Label()
    valuebar.hideLabel:SetParent(valuebar.optionsControl)
    valuebar.hideLabel:SetSize(150, 20)
    valuebar.hideLabel:SetPosition(0, optionsHeight)
    valuebar.hideLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    valuebar.hideLabel:SetText("Hide When:")

    valuebar.hideOnCheckbox = Turbine.UI.Lotro.CheckBox()
    valuebar.hideOnCheckbox:SetParent(valuebar.optionsControl)
    valuebar.hideOnCheckbox:SetSize(150, 20)
    valuebar.hideOnCheckbox:SetPosition(170, optionsHeight)
    valuebar.hideOnCheckbox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    valuebar.hideOnCheckbox:SetText("Timer Active")

    valuebar.hideOffCheckbox = Turbine.UI.Lotro.CheckBox()
    valuebar.hideOffCheckbox:SetParent(valuebar.optionsControl)
    valuebar.hideOffCheckbox:SetSize(150, 20)
    valuebar.hideOffCheckbox:SetPosition(330, optionsHeight)
    valuebar.hideOffCheckbox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    valuebar.hideOffCheckbox:SetText("Timer Inactive")

    
    optionsHeight = optionsHeight + 25

    --[[
    valuebar.opacityLabel = Turbine.UI.Label()
    valuebar.opacityLabel:SetParent(valuebar.optionsControl)
    valuebar.opacityLabel:SetSize(250, 20)
    valuebar.opacityLabel:SetPosition(0, optionsHeight)
    valuebar.opacityLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    valuebar.opacityLabel:SetText("Opacity When Timer Active:")

    valuebar.opacityOnCheckbox = Turbine.UI.Lotro.TextBox()
    valuebar.opacityOnCheckbox:SetParent(valuebar.optionsControl)
    valuebar.opacityOnCheckbox:SetSize(50, 20)
    valuebar.opacityOnCheckbox:SetPosition(250, optionsHeight)
    valuebar.opacityOnCheckbox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    valuebar.opacityOnCheckbox:SetText("1")

        
    optionsHeight = optionsHeight + 25

    valuebar.opacityLabel = Turbine.UI.Label()
    valuebar.opacityLabel:SetParent(valuebar.optionsControl)
    valuebar.opacityLabel:SetSize(250, 20)
    valuebar.opacityLabel:SetPosition(0, optionsHeight)
    valuebar.opacityLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    valuebar.opacityLabel:SetText("Opacity When Timer Inactive:")

    valuebar.opacityOffCheckbox = Turbine.UI.Lotro.TextBox()
    valuebar.opacityOffCheckbox:SetParent(valuebar.optionsControl)
    valuebar.opacityOffCheckbox:SetSize(50, 20)
    valuebar.opacityOffCheckbox:SetPosition(250, optionsHeight)
    valuebar.opacityOffCheckbox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    valuebar.opacityOffCheckbox:SetText("1")
    
    optionsHeight = optionsHeight + 25
    --]]

    valuebar.highlgihtOnReady = Turbine.UI.Label()
    valuebar.highlgihtOnReady:SetParent(valuebar.optionsControl)
    valuebar.highlgihtOnReady:SetSize(250, 20)
    valuebar.highlgihtOnReady:SetPosition(0, optionsHeight)
    valuebar.highlgihtOnReady:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    valuebar.highlgihtOnReady:SetText("Highlight When Timer Expires:")

    valuebar.highlgihtOnReadyTextbox = Turbine.UI.Lotro.TextBox()
    valuebar.highlgihtOnReadyTextbox:SetParent(valuebar.optionsControl)
    valuebar.highlgihtOnReadyTextbox:SetSize(50, 20)
    valuebar.highlgihtOnReadyTextbox:SetPosition(250, optionsHeight)
    valuebar.highlgihtOnReadyTextbox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    valuebar.highlgihtOnReadyTextbox:SetText("0")

    optionsHeight = optionsHeight + 25

    valuebar.visibitilityThresholdLabel = Turbine.UI.Label()
    valuebar.visibitilityThresholdLabel:SetParent(valuebar.optionsControl)
    valuebar.visibitilityThresholdLabel:SetSize(150, 20)
    valuebar.visibitilityThresholdLabel:SetPosition(0, optionsHeight)
    valuebar.visibitilityThresholdLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    valuebar.visibitilityThresholdLabel:SetText("Visibility Threshold:")

    valuebar.visibitilityThresholdTextbox = Turbine.UI.Lotro.TextBox()
    valuebar.visibitilityThresholdTextbox:SetParent(valuebar.optionsControl)
    valuebar.visibitilityThresholdTextbox:SetSize(150, 20)
    valuebar.visibitilityThresholdTextbox:SetPosition(250, optionsHeight)
    valuebar.visibitilityThresholdTextbox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    valuebar.visibitilityThresholdTextbox:SetText("99999")

    optionsHeight = optionsHeight + 25

    
    valuebar.decimalLabel = Turbine.UI.Label()
    valuebar.decimalLabel:SetParent(valuebar.optionsControl)
    valuebar.decimalLabel:SetSize(150, 20)
    valuebar.decimalLabel:SetPosition(0, optionsHeight)
    valuebar.decimalLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    valuebar.decimalLabel:SetText("Decimal Threshold:")

    valuebar.decimalTextbox = Turbine.UI.Lotro.TextBox()
    valuebar.decimalTextbox:SetParent(valuebar.optionsControl)
    valuebar.decimalTextbox:SetSize(100, 20)
    valuebar.decimalTextbox:SetPosition(150, optionsHeight)
    valuebar.decimalTextbox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    valuebar.decimalTextbox:SetText("0")

    valuebar.unitsCheckbox = Turbine.UI.Lotro.CheckBox()
    valuebar.unitsCheckbox:SetParent(valuebar.optionsControl)
    valuebar.unitsCheckbox:SetSize(150, 20)
    valuebar.unitsCheckbox:SetPosition(250, optionsHeight)
    valuebar.unitsCheckbox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    valuebar.unitsCheckbox:SetText("Use Units")
    valuebar.unitsCheckbox:SetChecked(true)
    
    table.insert(valuebar.showboxesTable, InfoButton(valuebar.optionsControl, width, 350, optionsHeight + 2, "This replaces durations bigger than 60 seconds with the \"m\" suffix.", optionPage.infoWindow))

    optionsHeight = optionsHeight + 25

    valuebar.onlyShowOnSkillCheckbox = Turbine.UI.Lotro.CheckBox()
    valuebar.onlyShowOnSkillCheckbox:SetParent(valuebar.optionsControl)
    valuebar.onlyShowOnSkillCheckbox:SetSize(350, 20)
    valuebar.onlyShowOnSkillCheckbox:SetPosition(0, optionsHeight)
    valuebar.onlyShowOnSkillCheckbox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    valuebar.onlyShowOnSkillCheckbox:SetText("Only show when detected (skill)")

    table.insert(valuebar.showboxesTable, InfoButton(valuebar.optionsControl, width, 320, optionsHeight + 2, "Before the quickslot is loaded a check will be performed to make sure you can actually perform this skill, if this is not the case this quickslot will not be loaded.", optionPage.infoWindow))


    valuebar.hideQuickslotCheckbox = Turbine.UI.Lotro.CheckBox()
    valuebar.hideQuickslotCheckbox:SetParent(valuebar.optionsControl)
    valuebar.hideQuickslotCheckbox:SetSize(150, 20)
    valuebar.hideQuickslotCheckbox:SetPosition(350, optionsHeight)
    valuebar.hideQuickslotCheckbox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    valuebar.hideQuickslotCheckbox:SetText("Hide quickslot")

    table.insert(valuebar.showboxesTable, InfoButton(valuebar.optionsControl, width, 320, optionsHeight + 2, "Hides the quickslot but still shows all other visible aspects, you can use this to create an overlay bar instead of a skillbar.", optionPage.infoWindow))

    optionsHeight = optionsHeight + 25

    valuebar.eventKeywordLabel = Turbine.UI.Label()
    valuebar.eventKeywordLabel:SetParent(valuebar.optionsControl)
    valuebar.eventKeywordLabel:SetSize(120, 20)
    valuebar.eventKeywordLabel:SetPosition(0, optionsHeight)
    valuebar.eventKeywordLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    valuebar.eventKeywordLabel:SetText("Event Keyword:")

    table.insert(valuebar.showboxesTable, InfoButton(valuebar.optionsControl, width, 120, optionsHeight + 2, "These events are fired when the duration timer expires.", optionPage.infoWindow))

    valuebar.eventKeywordTextbox = Turbine.UI.Lotro.TextBox()
    valuebar.eventKeywordTextbox:SetParent(valuebar.optionsControl)
    valuebar.eventKeywordTextbox:SetSize(250, 20)
    valuebar.eventKeywordTextbox:SetPosition(150, optionsHeight)
    valuebar.eventKeywordTextbox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)

    optionsHeight = optionsHeight + 25

    valuebar.addTriggerEntryButton = Turbine.UI.Lotro.Button()
    valuebar.addTriggerEntryButton:SetParent(valuebar)
    valuebar.addTriggerEntryButton:SetSize(100, 20)
    valuebar.addTriggerEntryButton:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    valuebar.addTriggerEntryButton:SetPosition(width - 120, optionsHeight)
    valuebar.addTriggerEntryButton:SetText("Add")

    optionsHeight = optionsHeight + 20

    -- Set options control to match all its children
    valuebar.optionsControl:SetSize(width, optionsHeight)

    -- Add listbox for items
    -- [[
    valuebar.listbox = Turbine.UI.ListBox()
    valuebar.listbox:SetParent(valuebar)
    valuebar.listbox:SetSize(width - 10, listboxHeight)
    valuebar.listbox:SetPosition(0, valuebar.optionsControl:GetHeight())
    valuebar.listbox:SetVisible(tablelength(listboxItems) > 0)

    valuebar.Scrollbar = Turbine.UI.Lotro.ScrollBar()
    valuebar.Scrollbar:SetOrientation(Turbine.UI.Orientation.Vertical)
    valuebar.Scrollbar:SetParent(valuebar)
    valuebar.Scrollbar:SetPosition(width - 10, valuebar.optionsControl:GetHeight())
    valuebar.Scrollbar:SetSize(10, listboxHeight)
    valuebar.Scrollbar:SetBackColor(Turbine.UI.Color.DarkSlateGray)
    valuebar.listbox:SetVerticalScrollBar(valuebar.Scrollbar)

    for key, value in pairs(listboxItems) do
        valuebar.listbox:AddItem(GetSkillBarQuickslotListboxItem(key, value, width - 10, triggerType, UIType, func, valuebar.listbox))
    end
    --]]

    valuebar.addTriggerEntryButton.Click = function()
        local xPrio = tonumber(tostring(valuebar.xBoxValue:GetText())) or 1
        local yPrio = tonumber(tostring(valuebar.yBoxValue:GetText())) or 1
        local shortcutData = valuebar.slotBox:GetShortcut():GetData()
        local shortcutType = valuebar.slotBox:GetShortcut():GetType()
        local shortcutItem = valuebar.slotBox:GetShortcut():GetItem()
        local ID = Turbine.Engine.GetGameTime()
        local events = valuebar.eventBox:GetText()
        local keybindText = valuebar.keybindBox:GetText()
        local useKeybind = valuebar.keybindCheckbox:IsChecked()
        local keybindAlignment = valuebar.keybindAlignmentMenu:GetText()
        local keybindFont = valuebar.keybindFontMenu:GetText()
        local hideOn = valuebar.hideOnCheckbox:IsChecked()
        local hideOff = valuebar.hideOffCheckbox:IsChecked()
        --local opacityOn = tonumber(tostring(valuebar.opacityOnCheckbox:GetText())) or 1
        --local opacityOff = tonumber(tostring(valuebar.opacityOffCheckbox:GetText())) or 1
        local highlightOnReady = tonumber(tostring(valuebar.highlgihtOnReadyTextbox:GetText())) or 0
        local visibitilityThreshold = tonumber(tostring(valuebar.visibitilityThresholdLabel:GetText())) or 99999
        local timer = valuebar.timerCheckBox:IsChecked() or tonumber(tostring(valuebar.timeBar:GetText())) or 0

        local useDuration = valuebar.durationCheckbox:IsChecked()
        local durationAlignment = valuebar.durationAlignmentMenu:GetText()
        local durationFont = valuebar.durationFontMenu:GetText()
        local decimalThreshold = tonumber(tostring(valuebar.decimalLabel:GetText())) or 0
        local useUnits = valuebar.unitsCheckbox:IsChecked()
        local hideQuickslot = valuebar.hideQuickslotCheckbox:IsChecked()

        local hideOnNotDetected = valuebar.onlyShowOnSkillCheckbox:IsChecked()

        if not(shortcutData) or not(shortcutType) or not(ID) or not(xPrio) or not(yPrio) then ChatOutput("Not all fields are correctly filled!"); return end

        local triggerEntry = {
            ["Code"] = code, 
            ["XPrio"] = xPrio, 
            ["YPrio"] = yPrio, 
            ["Type"] = shortcutType, 
            ["Data"] = shortcutData, 
            ["Item"] = shortcutItem, 
            ["Keybind_Font"] = keybindFont or "FixedSys15",
            ["Keybind_Text"] = keybindText or "",
            ["Show_Keybind"] = useKeybind,
            ["Keybind_Alignment"] = keybindAlignment,
            ["Events"] = events,
            ["Hide_While_Timer_Active"] = hideOn,
            ["Hide_While_Timer_Inactive"] = hideOff,
            --["Opacity_While_Timer_Inactive"] = opacityOff,
            --["Opacity_While_Timer_Active"] = opacityOn,
            ["highlightOnReady"] = highlightOnReady,
            ["visibitilityThreshold"] = visibitilityThreshold,
            ["Time"] = timer,

            ["Duration_Font"] = durationFont,
            ["Duration_Alignment"] = durationAlignment,
            ["Show_Duration"] = useDuration,

            ["Decimal_Threshold"] = decimalThreshold,
            ["Use_Units"] = useUnits,
            ["Hide_Quickslot"] = hideQuickslot,

            ["Skill_Check"] = hideOnNotDetected,

            ["Event_Keyword"] = valuebar.eventKeywordTextbox:GetText() or ""
        }

        if func(ID, triggerEntry) then
            return
        end

        valuebar.listbox:AddItem(GetSkillBarQuickslotListboxItem(ID, triggerEntry, width - 10, triggerType, UIType, func, valuebar.listbox))
        valuebar.listbox:SetVisible(true)
    end

    valuebar:SetSize(width, valuebar.listbox:GetHeight() + valuebar.optionsControl:GetHeight())

    optionsTreeNode:Add(valuebar.optionsControl)

    optionsTreeNode:Add(valuebar)

    headerNode.Format = function()
        headerNode.label:SetSize(width, 20)
        headerNode.label:SetPosition(0, 0)

        valuebar:SetWidth(headerNode:GetWidth())
    end

    headerNode.SizeChanged = function()
        headerNode.Format()
    end

    headerNode.Unload = function()

        for i = 1, valuebar.listbox:GetItemCount() do
            valuebar.listbox:GetItem(i):Unload()
        end
        valuebar.listbox:ClearItems()

        headerNode.label:SetParent(nil)
        for key, value in pairs(valuebar.showboxesTable) do
            value:SetParent(nil)    
            valuebar.showboxesTable[key] = nil
        end
        valuebar.showboxesTable = nil
        valuebar.menuItems:Clear()
        valuebar.menuItems = nil
        valuebar.menu = nil
        valuebar.fontmenuItems:Clear()
        valuebar.fontmenuItems = nil
        valuebar.fontmenu = nil
        valuebar.keybindMenuItems:Clear()
        valuebar.keybindMenuItems = nil
        valuebar.keybindMenu = nil
        valuebar.keybindFontmenuItems:Clear()
        valuebar.keybindFontmenuItems = nil
        valuebar.keybindFontmenu = nil
        -- Loop through the UI elements and set their parent to nil
        local elementsToClearParent = {
            "optionsControl", "slotInfo", "slotBox", "timeBar", "timerCheckBox", 
            "text", "slotInfo2", "clearInfo", "xBox", "xBoxValue", "yBox", "yBoxValue",
            "eventLabel", "eventBox", "durationAlignmentLabel", "durationAlignmentMenu",
            "durationFontLabel", "durationFontMenu", "durationCheckbox", "keybindLabel",
            "keybindBox", "keybindCheckbox", "keybindAlignmentLabel", "keybindAlignmentMenu",
            "keybindFontLabel", "keybindFontMenu", "hideLabel", "hideOnCheckbox",
            "hideOffCheckbox", "highlgihtOnReady", "highlgihtOnReadyTextbox",
            "visibitilityThresholdLabel", "visibitilityThresholdTextbox",
            "decimalLabel", "decimalTextbox", "unitsCheckbox",
            "onlyShowOnSkillCheckbox", "hideQuickslotCheckbox",
            "eventKeywordLabel", "eventKeywordTextbox",
            "addTriggerEntryButton", "listbox", "Scrollbar"
        }

        for _, elementName in ipairs(elementsToClearParent) do
            valuebar[elementName]:SetParent(nil)
            valuebar[elementName] = nil
        end

        optionsTreeNode:Clear()
        --ClearListbox(valuebar.listbox)
        RecursiveDeletion(valuebar)
        ClearNodes(optionsTreeNode)
        collectgarbage()
    end

    return headerNode
end

function CreateSkillBarEventOptions(width, triggerType, listboxItems, UIType, func, optionPage)
    local headerNode = Turbine.UI.TreeNode()
    headerNode:SetMouseVisible(false)
    headerNode:SetSize(width, 20)

    -- The header label with the trigger name
    headerNode.label = Turbine.UI.Label()
    headerNode.label:SetParent(headerNode)
    headerNode.label:SetSize(width, 20)
    headerNode.label:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    headerNode.label:SetPosition(0, 0)
    headerNode.label:SetText(triggerType)
    headerNode.label:SetBackColor(Turbine.UI.Color.Black)

    local optionsTreeNode = headerNode:GetChildNodes()

    local valuebar = Turbine.UI.TreeNode()
    valuebar:SetPosition(0, 0)
    valuebar:SetMouseVisible(false)
   --valuebar:SetBackColor(GetRandomColour())

   local optionsHeight = 0
   local listboxHeight = 350

    valuebar.optionsControl = Turbine.UI.Control()
	valuebar.optionsControl:SetParent(valuebar)
    valuebar.optionsControl:SetPosition(0, 0)
    valuebar.optionsControl:SetBackColor(Turbine.UI.Color.DarkSlateGray)



    --valuebar.categoryButton.Click = function()
    --    valuebar.categoryMenu:ToggleVisible()
    --end

    --valuebar.categoryShowInfo = InfoButton(valuebar.optionsControl, width, 320, optionsHeight + 2, "This quick slot will only be shown if this type of removable effect is applied to the player.", optionPage.infoWindow)

    --[[
            Highlight events
			Opacity events
			Visible events
			Cooldown events
    ]]

    valuebar.nameTextBox = Turbine.UI.Lotro.TextBox()
    valuebar.nameTextBox:SetParent(valuebar.optionsControl)
    valuebar.nameTextBox:SetSize(width - 50, 20)
    valuebar.nameTextBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    valuebar.nameTextBox:SetPosition(0, optionsHeight)
    valuebar.nameTextBox:SetText("Event name")

    optionsHeight = optionsHeight + 40

    --highlight

    valuebar.highligtCheckbox = Turbine.UI.Lotro.CheckBox()
    valuebar.highligtCheckbox:SetParent(valuebar.optionsControl)
    valuebar.highligtCheckbox:SetSize(250, 20)
    valuebar.highligtCheckbox:SetPosition(0, optionsHeight)
    valuebar.highligtCheckbox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    valuebar.highligtCheckbox:SetText("Turn On Highlight")

    valuebar.highligtOffCheckbox = Turbine.UI.Lotro.CheckBox()
    valuebar.highligtOffCheckbox:SetParent(valuebar.optionsControl)
    valuebar.highligtOffCheckbox:SetSize(250, 20)
    valuebar.highligtOffCheckbox:SetPosition(250, optionsHeight)
    valuebar.highligtOffCheckbox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    valuebar.highligtOffCheckbox:SetText("Turn Off Highlight")

    optionsHeight = optionsHeight + 20

    valuebar.highligtTimedCheckbox = Turbine.UI.Lotro.CheckBox()
    valuebar.highligtTimedCheckbox:SetParent(valuebar.optionsControl)
    valuebar.highligtTimedCheckbox:SetSize(250, 20)
    valuebar.highligtTimedCheckbox:SetPosition(0, optionsHeight)
    valuebar.highligtTimedCheckbox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    valuebar.highligtTimedCheckbox:SetText("Timed Highlight")

    valuebar.highlightTimerTextBox = Turbine.UI.Lotro.TextBox()
    valuebar.highlightTimerTextBox:SetParent(valuebar.optionsControl)
    valuebar.highlightTimerTextBox:SetSize(50, 20)
    valuebar.highlightTimerTextBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    valuebar.highlightTimerTextBox:SetPosition(250, optionsHeight)
    valuebar.highlightTimerTextBox:SetText("0")
    valuebar.highlightTimerTextBox:SetForeColor(Turbine.UI.Color(0.75, 0.75, 0.75))
    valuebar.highlightTimerTextBox:SetEnabled(valuebar.highligtTimedCheckbox:IsChecked())

    valuebar.highligtTimedCheckbox.CheckedChanged = function()
        local enabled = valuebar.highligtTimedCheckbox:IsChecked()
        valuebar.highlightTimerTextBox:SetEnabled(enabled)
        if enabled then
            valuebar.highlightTimerTextBox:SetForeColor(Turbine.UI.Color.White)
        else
            valuebar.highlightTimerTextBox:SetForeColor(Turbine.UI.Color(0.75, 0.75, 0.75))
        end
    end

    optionsHeight = optionsHeight + 40

    --opacity event

    --[[
    valuebar.opacityCheckbox = Turbine.UI.Lotro.CheckBox()
    valuebar.opacityCheckbox:SetParent(valuebar.optionsControl)
    valuebar.opacityCheckbox:SetSize(250, 20)
    valuebar.opacityCheckbox:SetPosition(0, optionsHeight)
    valuebar.opacityCheckbox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    valuebar.opacityCheckbox:SetText("Change Opacity")

    valuebar.opacityTextBox = Turbine.UI.Lotro.TextBox()
    valuebar.opacityTextBox:SetParent(valuebar.optionsControl)
    valuebar.opacityTextBox:SetSize(50, 20)
    valuebar.opacityTextBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    valuebar.opacityTextBox:SetPosition(250, optionsHeight)
    valuebar.opacityTextBox:SetText("1")

    optionsHeight = optionsHeight + 40
    --]]

    --Visible event

    valuebar.visibiltyCheckbox = Turbine.UI.Lotro.CheckBox()
    valuebar.visibiltyCheckbox:SetParent(valuebar.optionsControl)
    valuebar.visibiltyCheckbox:SetSize(250, 20)
    valuebar.visibiltyCheckbox:SetPosition(0, optionsHeight)
    valuebar.visibiltyCheckbox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    valuebar.visibiltyCheckbox:SetText("Change Visiblity")

    optionsHeight = optionsHeight + 20

    valuebar.visibiltyOnCheckbox = Turbine.UI.Lotro.CheckBox()
    valuebar.visibiltyOnCheckbox:SetParent(valuebar.optionsControl)
    valuebar.visibiltyOnCheckbox:SetSize(250, 20)
    valuebar.visibiltyOnCheckbox:SetPosition(0, optionsHeight)
    valuebar.visibiltyOnCheckbox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    valuebar.visibiltyOnCheckbox:SetText("Set Visible")
    valuebar.visibiltyOnCheckbox:SetEnabled(valuebar.visibiltyCheckbox:IsChecked())
    valuebar.visibiltyOnCheckbox:SetForeColor(Turbine.UI.Color(0.75, 0.75, 0.75))

    valuebar.visibiltyOffCheckbox = Turbine.UI.Lotro.CheckBox()
    valuebar.visibiltyOffCheckbox:SetParent(valuebar.optionsControl)
    valuebar.visibiltyOffCheckbox:SetSize(250, 20)
    valuebar.visibiltyOffCheckbox:SetPosition(250, optionsHeight)
    valuebar.visibiltyOffCheckbox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    valuebar.visibiltyOffCheckbox:SetText("Set Invisible")
    valuebar.visibiltyOffCheckbox:SetEnabled(valuebar.visibiltyCheckbox:IsChecked())
    valuebar.visibiltyOffCheckbox:SetForeColor(Turbine.UI.Color(0.75, 0.75, 0.75))

    valuebar.visibiltyCheckbox.CheckedChanged = function()
        local enabled = valuebar.visibiltyCheckbox:IsChecked()
        valuebar.visibiltyOnCheckbox:SetEnabled(enabled)
        valuebar.visibiltyOffCheckbox:SetEnabled(enabled)
        if enabled then
            valuebar.visibiltyOnCheckbox:SetForeColor(Turbine.UI.Color.White)
            valuebar.visibiltyOffCheckbox:SetForeColor(Turbine.UI.Color.White)
        else
            valuebar.visibiltyOnCheckbox:SetForeColor(Turbine.UI.Color(0.75, 0.75, 0.75))
            valuebar.visibiltyOffCheckbox:SetForeColor(Turbine.UI.Color(0.75, 0.75, 0.75))
        end
    end

    optionsHeight = optionsHeight + 40

    --Cooldown event

    valuebar.timerCheckbox = Turbine.UI.Lotro.CheckBox()
    valuebar.timerCheckbox:SetParent(valuebar.optionsControl)
    valuebar.timerCheckbox:SetSize(250, 20)
    valuebar.timerCheckbox:SetPosition(0, optionsHeight)
    valuebar.timerCheckbox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    valuebar.timerCheckbox:SetText("Start Timer")

    valuebar.timerTextBox = Turbine.UI.Lotro.TextBox()
    valuebar.timerTextBox:SetParent(valuebar.optionsControl)
    valuebar.timerTextBox:SetSize(50, 20)
    valuebar.timerTextBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    valuebar.timerTextBox:SetPosition(250, optionsHeight)
    valuebar.timerTextBox:SetText("0")

    optionsHeight = optionsHeight + 40

    valuebar.addTriggerEntryButton = Turbine.UI.Lotro.Button()
    valuebar.addTriggerEntryButton:SetParent(valuebar)
    valuebar.addTriggerEntryButton:SetSize(100, 20)
    valuebar.addTriggerEntryButton:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    valuebar.addTriggerEntryButton:SetPosition(width - 120, optionsHeight)
    valuebar.addTriggerEntryButton:SetText("Add")

    optionsHeight = optionsHeight + 20

    -- Set options control to match all its children
    valuebar.optionsControl:SetSize(width, optionsHeight)

    -- Add listbox for items
    valuebar.listbox = Turbine.UI.ListBox()
    valuebar.listbox:SetParent(valuebar)
    valuebar.listbox:SetSize(width - 10, listboxHeight)
    valuebar.listbox:SetPosition(0, valuebar.optionsControl:GetHeight())
    valuebar.listbox:SetVisible(tablelength(listboxItems) > 0)

    valuebar.Scrollbar = Turbine.UI.Lotro.ScrollBar()
    valuebar.Scrollbar:SetOrientation(Turbine.UI.Orientation.Vertical)
    valuebar.Scrollbar:SetParent(valuebar)
    valuebar.Scrollbar:SetPosition(width - 10, valuebar.optionsControl:GetHeight())
    valuebar.Scrollbar:SetSize(10, listboxHeight)
    valuebar.Scrollbar:SetBackColor(Turbine.UI.Color.DarkSlateGray)
    valuebar.listbox:SetVerticalScrollBar(valuebar.Scrollbar)

    for key, value in pairs(listboxItems) do
        valuebar.listbox:AddItem(GetQuickslotEventListboxItem(key, value, width - 10, triggerType, UIType, func, valuebar.listbox))
    end

    valuebar.addTriggerEntryButton.Click = function()
        local ID = tostring(valuebar.nameTextBox:GetText())

        local highlightEvent = valuebar.highligtCheckbox:IsChecked() or valuebar.highligtOffCheckbox:IsChecked()
        --local opacityEvent = valuebar.opacityCheckbox:IsChecked()
        local visibilityEvent = valuebar.visibiltyCheckbox:IsChecked()
        local timerEvent = valuebar.timerCheckbox:IsChecked()

        local triggerEntry = {
            ["Code"] = code,

            ["HiglightEvent"] = highlightEvent,
            ["HiglightValue"] = highlightEvent and (valuebar.highligtCheckbox:IsChecked() or valuebar.highligtOffCheckbox:IsChecked() and false or nil)  or nil, 
            ["HiglightTimed"] = highlightEvent and valuebar.highligtTimedCheckbox:IsChecked() or nil, 
            ["HighlightTimer"] = highlightEvent and tonumber(tostring(valuebar.highlightTimerTextBox:GetText())) or nil, 

            --["OpacityEvent"] = opacityEvent,
            --["OpacityValue"] = opacityEvent and tonumber(tostring(valuebar.opacityTextBox:GetText()))  or nil,

            ["VisibleEvent"] = visibilityEvent,
            ["VisibilityValueOn"] = visibilityEvent and valuebar.visibiltyOnCheckbox:IsChecked() or nil,
            ["VisibilityValueOff"] = visibilityEvent and valuebar.visibiltyOffCheckbox:IsChecked() or nil,

            ["TimerEvent"] = timerEvent,
            ["TimerValue"] = timerEvent and tonumber(tostring(valuebar.timerTextBox:GetText())) or nil,
        }

        if func(ID, triggerEntry) then
            return
        end

        valuebar.listbox:AddItem(GetQuickslotEventListboxItem(ID, triggerEntry, width - 10, triggerType, UIType, func, valuebar.listbox))
        valuebar.listbox:SetVisible(true)
    end

    valuebar:SetSize(width, valuebar.listbox:GetHeight() + valuebar.optionsControl:GetHeight())

    optionsTreeNode:Add(valuebar.optionsControl)

    optionsTreeNode:Add(valuebar)

    headerNode.Unload = function()
        ClearListbox(valuebar.listbox)
        RecursiveDeletion(valuebar)
        ClearNodes(optionsTreeNode)
    end

    return headerNode
end