PrimeUIOptions = class(Turbine.UI.Lotro.Window)
function PrimeUIOptions:Constructor(parent)
    self.width = 1200
    self.height = 800
    self.borderSize = 5
    self.x = Turbine.UI.Display.GetWidth() / 2 - self.width / 2
    self.y = Turbine.UI.Display.GetHeight() / 2 - self.height / 2
    local colour = Turbine.UI.Color(1, 1, 1)
    Turbine.UI.Lotro.Window.Constructor(self)
    self:SetSize(self.width, self.height)
    --self:SetParent(parent)
    self:SetPosition(self.x, self.y)
    self:SetWantsKeyEvents(true)
    self:SetVisible(false)
    self:SetResizable(true)
    self:SetMinimumSize(600, 500)

    self.notChanging = false

    self.BorderBackground = Turbine.UI.Control()
    self.BorderBackground:SetParent(self)
    self.BorderBackground:SetPosition(10 - 2, 10 - 2)
    self.BorderBackground:SetSize(760 + 4 + 8, self.height + 4)
    self.BorderBackground:SetBackColor(Turbine.UI.Color.Black)
    self.BorderBackground:SetMouseVisible(false)

    self.Background = Turbine.UI.Control()
    self.Background:SetParent(self)
    self.Background:SetPosition(10, 10)
    self.Background:SetSize(740, self.height)
    self.Background:SetBackColor(Turbine.UI.Color(0.1, 0.1, 0.1))
    self.Background:SetMouseVisible(false)

    self.minorOptionBackgroundColour = Turbine.UI.Color(0.01,0.21,0.21)
    self.optionExpandBackgroundColour = Turbine.UI.Color(0.01,0.41,0.41)

    --if true then return end

    self.infoWindow = InfoWindow()
    self.codeWindow = CodeWindow()

    self.treeviewBoxes = {}
    self.treeviewOptions = {}
    self.optionBoxes = {}
    self.subOptionBoxes = {}

    self.Moving = false

    self.listBoxCategories = {
        ["Effects"] = true,
        ["Skills"] = true,
        ["PlayerHits"] = true,
        ["EnemyHits"] = true,
        ["EffectAdded"] = true,
        ["EffectRemoved"] = true,
        ["PartyChat"] = true,
        ["StandardChat"] = true,
        ["SayChat"] = true,
        ["HealthThreshold"] = true,
        ["EffectAdded_Group"] = true,
        ["EffectAdded_Target"] = true,
        ["Target_HealthThreshold"] = true,
        ["Highlight_On_Effect"] = true,
        ["PlayerHeal"] = true,
        ["PlayerBenefit"] = true,
        ["Circle Timer"] = true,
        ["Quickslots"] = true,
        ["FightStart"] = true,
        ["FightEnd"] = true,
        ["FightPhase"] = true,
        ["CCBreak"] = true,
        ["EventTrigger"] = true,
        ["DefeatEvent"] = true,
        ["DNFApplied"] = true,
        ["DNFRemoved"] = true,
        ["Corruption"] = true,
        ["Event Keyword"] = true,
        ["Quest Accepted"] = true,
        ["Quest or Deed Completed"] = true,
        ["New Deed"] = true,
        ["Quest or Deed Progress"] = true,
        ["Highlight_On_Resource"] = true,
        ["Location"] = true,
        ["Visibilty_Event"] = true,
        ["Invisibility_Event"] = true,
        ["Highlight_On_Event"] = true,
        ["Highlight_When_Ready"] = true,
        ["Toggle_Visibility_On_Event"] = true,
        ["Resource"] = true,
        ["Action"] = true,
        ["Skill_Ready"] = true,
        ["Effect_BlackList"] = true,
        ["Variables"] = true,
    }

    self.specialListBoxCategories = {
        ["Triggers"] = true,
    }

    self.nontriggerListBox = {
        ["Start_Keyword"] = true,
        ["End_Keyword"] = true,
        ["Reset_Keyword"] = true,
        ["Counter_Event"] = true,
        ["Name_Filter_List"] = true,
    }

    self.UIElementInfoStrings = {
        ["Icon"] = "An icon element that can be set to show up under specific circumstances. There is one important settings conjuction will cause the icon to show up if ALL conditions are satisfied. If this setting is turned off the icon will show up if ANY condition is satisfied.",
        ["Text"] = "A text element that can be set to show up under specific circumstances. There is one important settings conjuction will cause the icon to show up if ALL conditions are satisfied. If this setting is turned off the icon will show up if ANY condition is satisfied.",
        ["TimerIcon"] = "An icon element which utilizes a timer as its main function. It can be started with various triggers. As well as its visiblity can toggeled for various situations.",

        ["MoraleBar"] = "A morale bar that has multiple options to changes its layout.",
        ["MoraleBar_Target"] = "A morale bar of your current target that has multiple options to changes its layout.",
        ["PowerBar_Target"] = "A power bar of your current target that has multiple options to changes its layout.",
        ["PowerBar"] = "A power bar that has multiple options to changes its layout.",
        ["WrathBar"] = "A power bar that has multiple options to changes its layout.",
        ["PetMoraleBar"] = "A morale bar for pets",

        ["ResourceBar"] = "A resource bar to track class specific resources in a modern layout, there are many options to change its look. Currenlty supported classes Beorning (blue), Champion, Brawler, Hunter, Guardian (blue), RuneKeeper & Weaver.",
        ["Ballad Bar"] = "Three bars that indicate the current state of your ballads.",

        ["BuffBar"] = "A bar of icons that can be generated with various triggers.",
        ["BuffBar_Target"] = "A bar of icons that can be generated with effects added to your current target.",

        ["Skills"] = "A skill bar that populates with LOTRO quickslots to have skills in easily configurable positions. It also supports any other quickslot type using the quickslot trigger feature.",

        ["ValueBar"] = "A timer bar with minimal layout.",
        ["Timer"] = "A simple timer with various layout options. Various trigger can start this timer. Having the text of a timer as <name> will result in the UI trying to replace the text with the target of the effect.",
        ["TimerGroup"] = "A timer group where specified triggers will start new timers and add them to timer group. Timers that are of the same trigger but a different stack will attempt to refresh already existing timers. Having the text of a timer as <name> will result in the UI trying to replace the text with the target of the effect.",
        ["Circle Timer"] = "A simple circle timer with various layout options. Various trigger can start this timer. Having the text of a timer as <name> will result in the UI trying to replace the text with the target of the effect.",

        ["Countdown"] = "Start a countdown based on various triggers. There can only be one countdown active at the time.",
        ["Sound"] = "Play a sound on various triggers. This requires the Prime Sound Player to be running.",

        ["SkillLabel"] = "A simple label with background and timer.",
        ["Alert"] = "A big text alert that only allows one alert at the time to show.",
        ["AlertGroup"] = "This UI element allows multiple alerts to be shown at the same time.",

        ["Note Event"] = "Interact with the currently active note.",
        ["Note Activation"] = "Set a new active note.",

        ["Effect Listbox"] = "A listbox that contains effect icons that can be modified in multiple ways.",

        ["Counter"] = "Increment or decrement a counter based on triggers. This element can be used to display this information or fire events when certain counts are reached.",
        ["Conditions"] = "??",
        ["Event Keyword"] = "Fire events based on all triggers. This element can be used to control all the other UI elements in a PrimeUI in a central place.",
        ["Figures"] = "Simple shapes or textures that can be (shortly) displayed.",
    }

    self.specialTextText = {
        ["Text"] = "Changes the text of the current UI element. In the case of the Text UI element these keywords will have additional function if used between \"<\"\">\":"
        .. [[ 
        State - In an instance or not
        Instance_Name - Name of the instance or all
        Instance_Tier - Tier of instance or \"\"
        Boss_Name - Name of the boss fight
        Boss_Tier - Tier of the boss fight
        Boss_Completion_Time - Fight duration (wipe or completion)
        Boss_Wipes - Amount of wipes in a fight
        Player_Name - Name of the player
        Player_Class - Class of the player
        Death_Count_Character - Amount of deaths on character
        Death_Count_Account - Amount of deaths on account
        Death_Count_Misadventure_Character - Amount of Misadventure deaths on character
        Death_Count_Misadventure_Account - Amount of Misadventure deaths on account
        Player_Morale
        Player_Max_Morale
        Player_Base_Max_Morale
        Player_Morale_Percentage
        Player_Temporary_Morale
        Player_Max_Temporary_Morale
        Player_Power 
        Player_Max_Power
        Player_Base_Max_Power 
        Player_Power_Percentage
        Player_Temporary_Power 
        Player_Max_Temporary_Power
        Player_Level 
        Player_Is_In_Combat
        Target_Name
        Target_Morale 
        Target_Max_Morale 
        Target_Base_Max_Morale 
        Target_Temporary_Morale 
        Target_Max_Temporary_Morale 
        Target_Power 
        Target_Max_Power 
        Target_Base_Max_Power 
        Target_Temporary_Power
        Target_Max_Temporary_Power
        Target_Level
        Pet_Morale
        Pet_Max_Morale
        Pet_Morale_Percentage
        Pet_Temporary_Morale
        Pet_Max_Temporary_Morale
        Pet_Name                                                                                                                                                                          
                                                                                                                                                                                         
                                                                                                                                                                                  
                                                                                                                                                                                         ]]
    }
        

    self.optionInfoText = {
        ["Icon"] = "Changes the icon of the UI element. Click on the white box or current icon to bring up the icon selection menu. Alternatively you can enter the ID of an icon.",
        ["Colour"] = "Changes varies colours setting. Each scrollbar represents a different channel of the ARGB system. (Alpha changes the opacity of the colour, a value of 0 renders a colour invisible)",
        ["Font"] = "Set the font for a UI element. Some UI element will scale the font while others do not. (FixedSys15 is the only always working monospaced font)",
        ["Timer_Stack_Direction"] = "Determines which way timers are added and sorted to a timergroup. Addition will work from the opposite side of the direction.",
        ["Timer_Sorting"] = "Determines which sorting is used for a timergroup.",
        ["TextAlignment"] = "Determines the alignment of the text within the current UI element.",
        ["StackTextAlignment"] = "Determines the alignment of the text within the current UI element.",
        ["Alignment"] = "Sets the alignment of the current UI element in respect to the parent PrimeUI.",

        -- Number
        ["Height"] = "Sets the height of current UI element if applicable",
        ["Width"] = "Sets the width of current UI element if applicable",
        ["OffsetAbove"] = "Sets the offset above this UI element with the above UI element within the PrimeUI or the top of the parent UI.",
        ["OffsetBelow"] = "Sets the offset below this UI element with the below UI element within the PrimeUI or the bottom of the parent UI.",
        ["Scale"] = "Sets the scaling factor of the current UI element or the UI elements within/created.",
        ["X"] = "Sets the X coordinate (only applicable if in advanced mode)",
        ["Y"] = "Sets the Y coordinate (only applicable if in advanced mode)",
        ["BorderSize"] = "The width of the border around the UI element.",
        ["Intervals"] = "Determines the amount of bars that will be drawn over the bar.",
        ["BoxOffset"] = "Distance between the boxes.",

        ["Text"] = "Changes the text of the current UI element.",

        -- Setting
        ["AllEffects"] = "Turning this setting on will forego specific trigger settings for effects but instead process any effect.",
        ["OnlyBuffs"] = "Only allows buffs to go through selection.",
        ["OnlyDebuffs"] = "Only allows debuffs to go through selection.",
        ["AllHighlight"] = "Highlights every element within this UI element without the need to specify this for these specific elements",
        ["Reset_On_Retarget"] = "This setting will wipe the buffbar when a target swap event is detected.",
        ["AlwaysVisible"] = "Will always turn this UI element visible.",
        ["Clockwise"] = "This setting will turn the visual timer direction.",
        ["GrayOut"] = "Will slightly grayout the timericon.",
        ["Hide_While_Not_Active"] = "Will hide this element when there is no timer active.",
        ["Highlight"] = "Enabling this will highlight this element.",
        ["HighlightWhileOff"] = "Enabling this will highlight this element when it is considered \"off\".",
        ["ShowText"]  = "This setting will toggle the visiblity of the text.",
        ["Visual_Timer"] = "This setting will enable the visual timer for this element.",
        ["Static_Timers"] = "This setting will cause every trigger event associated with this UI element to create a timer that is always visible within the group timer UI.",
        ["Full_Border"] = "This setting will cause the UI element to draw a full border around the innerbox.",
        ["RKLayout"] = "This setting will cause the UI element to go up to only 10 charges instead of 20.",
        ["Conjuction"] = "This will cause the icon to show up if ALL conditions are satisfied. If this setting is turned off the icon will show up if ANY condition is satisfied.",

        -- Triggers
        ["Effects"] = "This places a trigger on any effect added that matches the conditions specified. This trigger type will keep track when an effect is added and removed and update the UI accordingly.",
        --["Skills"] = "Whenever a skill matching ",
        ["PlayerHits"] = "Whenever the player hits any target with a hit which name matches the conditions specified it utilizes the function of the UI.",
        ["EnemyHits"] = "Whenever the player is hit by a hit which name matches the conditions specified it utilizes the function of the UI.",
        ["EffectAdded"] = "Whenever an effect is added to the player that matches the conditions specified it utilizes the function of the UI.",
        ["EffectRemoved"] = "Whenever an effect is removed from the player that matches the conditions specified it utilizes the function of the UI.",
        ["PartyChat"] = "When a phrase is detected in party chat (fellowship or raid) it utilizes the function of the UI. (Markup colours have to be added to the matching string)",
        ["StandardChat"] = "When a phrase is detected in standard chat it utilizes the function of the UI. (Markup colours have to be added to the matching string)",
        ["SayChat"] = "When a phrase is detected in say chat it utilizes the function of the UI. (Markup colours have to be added to the matching string)",
        ["HealthThreshold"] = "When a player falls below or moves above a set threshold it utilizes the function of the UI. (This effect has a cooldown)",
        ["EffectAdded_Group"] = "Whenever an effect is added to any player in the group (does not include the player) that matches the conditions specified it utilizes the function of the UI.",
        ["EffectAdded_Target"] = "Whenever an effect is added to the target of the player that matches the conditions specified it utilizes the function of the UI.",
        ["Target_HealthThreshold"] = "When a target falls below or moves above a set threshold it utilizes the function of the UI. (This effect has a cooldown)",

        ["All_Buffs"] = "Enabling this will make this UI element track all buffs",
        ["All_Debuffs"] = "Enabling this will make this UI element track all debuffs",
        ["Flipped_Layout"] = "This setting will cause the listbox to fill its items in a flipped manner. Instead of top left or bottom right (Reverse_Fill enabled) items will instead fill from bottom left and top right.",
        ["Reverse fill"] = "This will cause the listbox to fill up from bottom right instead of top left. (Flipped if Flipped_Layout is enabled)",
        ["Show_Duration"] = "Show duration on the UI element",
        ["Orientation"] = "Sets the orientation of the fill direction of a listbox.",
        ["Effect_Size"] = "The size of the effect boxes minus spacing and bordersize.",
        ["Spacing"] = "Spacing inbetween items in a list box.",
        ["Visibility_Threshold"] = "Only if the duration is lower than this number will it be shown.",
        ["Show_Stack"] = "Shows the stack on the effect if applicable.",

        ["Disable_Player_Vitals"] = "Removes the player vitals from the UI. This can cause issues with other plugins and/or when loading/unloading, to fix this simply disable this optoin and relog.",

        ["DNFApplied"] = "Trigger that fires whenever a DNF is applied to a member of your party. Important note: this does not track DNFS on the player themselves.",
        ["DNFRemoved"] = "Trigger that fires whenever a DNF is removed from a party member. Important note: this does not track DNFS on the player themselves.",

        ["DefeatEvent"] = "Trigger that fires whenver someone around you is defeated or gets defeated. Allowing you to start triggers based on enemies you defeat.",

        ["EventTrigger"] = "This trigger can be fired by the EventTrigger UI Element or when specific components in other UI elements expire (for example at the end of a timer in a timer group). This allows you to start tools based on expiration of other triggers.",
        ["FightStart"] = "This trigger is fired whenever a fight that is tracked by the plugin starts.",
        ["FightPhase"] = "This trigger is fired whenever a fight that is tracked by the plugin that is in progress phases to the next phase.",
        ["FightEnd"] = "This trigger is fired whenever a fight that is tracked by the plugin ends, either by completion or wipe.",

        ["PlayerHeal"] = "Whenver the player is healed by anything or anyone this trigger will fire based on conditions; if the name of this healing skills matches the user input the trigger will fire.",
        ["PlayerBenefit"] = "Many events in this game such as heals or buffs are signaled by a line in the combat log that states that a certain benefit is applied to the player. This trigger can be used to start functionality of the UI element based on a matching benefit.",

        ["Timer_Height"] = "The height of timers in the timergroup. This also influences the size of the icon as icons are a square.",
        ["Timer_Offset"] = "The space inbetween timers in a timergroup.",

        ["Reset_On_Fight_End"] = "Whenver a fight that is tracked by the plugin ends this will remove all timers from the timergroup. (For example this can remove enrage timers).",
        ["Spark"] = "Enables a sparking graphic at the edge of timer bars for visiblity purposes.",

        ["NickName"] = "Name of the UI element given to it by the player for identifaction purposes when the PrimeUI is in advanced mode.",
        
        ["Offset"] = "Offset between items within this UI element.",

        ["Toggle_Type"] = "When this UI is activated this toggle type determines in what way the activation is displayed.",

        ["Texture"] = "The texture used for this UI. This is the path to a texture, which is in relation to the LotRo folder.",

        ["Use_Texture"] = "Determines if this UI uses the texture defined in the Texture field.",

        ["Use_Screen_Width"] = "The Width of this UI is automatically set to the width of the screen.",
        ["Use_Screen_Height"] = "The Height of this UI is automatically set to the height of the screen.",

        ["CCBreak"] = "When an enemy within your render distance is freed from a CC early this trigger will fire. It can be set up for a specific type of enemy or all enemies. It can also function on specific CC types or all CC types. This trigger requires the in game option to show CC breaks in chat to be turned on!",
        ["Corruption"] = "This trigger fires when you remove a corruption, it can be setup to work on any or a specific corruption.",

        ["Quest Accepted"] = "Whenever a quest is accepted by the player this trigger will fire if the quest name matches the trigger phrase.",
        ["Quest or Deed Completed"] = "Whenever a quest or deed is completed by the player this trigger will fire if the quest or deed name matches the trigger phrase.",
        ["Quest or Deed Progess"] = "Options are a WIP",

        ["Changes_On_Full"] = "If the resourcebar reaches max capacity this toggle will change the colour of the resourcebar to a different colour as defined by the Filled_Colour.",
        ["Filled_Colour"] = "The colour the resource bar takes when it is full and the toggle Changes_On_Full is enabled.",

        ["Animate"] = "Adds a slow animation to the appearance of a resourcebox.",

        ["Highlight_On_Effect"] = "Whenever a specific effect is applied to the player a skill or a set of skills can be highlighted. This can also be inverted to work whenever this effect is not active on the player.",
        ["Highlight_On_Resource"] = "Whenever a specific resource number is reached a skill or a set of skills can be highlighted. This can also be inverted to work whenever this threshold is not reached.",
        ["Quickslots"] = "A skill, item or anything else that can be dragged into a quickslot can be added to a skill layout using this trigger.",

        ["Start_Keyword"] = "If any start keyword is defined this UI will only accept triggers whenever this start keyword is applied. This start keyword can be any event keyword from any UI element within this PrimeUI.",
        ["End_Keyword"] = "If this UI is currently active an End_Keyword fired by any event keyword from any UI element within this PrimeUI it will stop accepting triggers until a Start_Keyword is received. If any End_Keyword is defined the UI element will be inactive by default.",
        ["Reset_Keyword"] = "A Reset_Keyword will clear the currently active elemnts within this UI element.",
        
        ["Opacity"] = "Changes the opacity of the UI element. Accepts a value between 0.0 and 1.0",

        ["Location"] = "A trigger to fires when the player enters a specific area, these correspond to the regional zones. Note: instances do not tend to have areas associated with them, in those cases the location is empty.",
        ["Resource"] = "A trigger category that accesses a resource that sometimes cannot be accessed through the effect system. This trigger covers: Attunement, Fervour, Focus and Wrath.",

        ["Activation_Triggers"] = "All of the triggers in this category are fired and applied to the primeUI if the condition in this conditions UI element equal to true and the previous state is false. If the conjucntion toggle is enabled all conditions have to be satisfied, if not only 1 condition has to be true.",
        ["Deactivation_Triggers"] = "All of the triggers in this category are fired and applied to the primeUI if the condition in this conditions UI element equal to false and the previous state was true. If the conjucntion toggle is enabled all conditions have to be satisfied, if not only 1 condition has to be true.",

        ["Header_Text"] = "The header text at the top of a timergroup.",
        ["Timer_Header"] = "If enabled the timergroup will have a header above itself, the text in this header can be edited in Header_Text.",
        ["Header_Only_When_Active"] = "If the Timer_Header is enabled this toggle determines if the header is always visible or only if there are timers active.",
        ["Change_On_Full"] = "Changes the colour of the resourcebar to the Filled_Colour if full.",

        ["Highlight_On_Event"] = "Highlight a skill or turn a highlight skill off when an event is fired in the primeUI.",
        ["Toggle_Visibility_On_Event"] = "Turn a skill visible or invisible based on an event.",

        ["Action"] = "Triggers based on keybinds",

        ["Duration_X_Offset"] = "The X offset the number has to its position, to give you more control where exactly you want the duration. This way the number can be outside the label for example.",
        ["Duration_Y_Offset"] = "The Y offset the number has to its position, to give you more control where exactly you want the duration. This way the number can be outside the label for example.",
        ["Stack_X_Offset"] = "The X offset the number has to its position, to give you more control where exactly you want the stack amount. This way the number can be outside the label for example.",
        ["Stack_Y_Offset"] = "The Y offset the number has to its position, to give you more control where exactly you want the stack amount. This way the number can be outside the label for example.",



    }

    self.textAlignments = {
        ["BottomCenter"] = Turbine.UI.ContentAlignment.BottomCenter,
        ["BottomLeft"] = Turbine.UI.ContentAlignment.BottomLeft,
        ["BottomRight"]	= Turbine.UI.ContentAlignment.BottomRight,
        ["MiddleCenter"] = Turbine.UI.ContentAlignment.MiddleCenter,
        ["MiddleLeft"] = Turbine.UI.ContentAlignment.MiddleLeft,
        ["MiddleRight"] = Turbine.UI.ContentAlignment.MiddleRight,
        ["TopCenter"] = Turbine.UI.ContentAlignment.TopCenter,
        ["TopLeft"] = Turbine.UI.ContentAlignment.TopLeft,
        ["TopRight"] = Turbine.UI.ContentAlignment.TopRight,
    }

    self.contentAlignment = {
        ["Left"] = true,
        ['Middle'] = true,
        ["Right"] = true,
    }

    self.timerGroupAlignments = {
        ["Alphabetical"] = true,
        ["Alphabetical Reverse"] = true,
        ["Hight to Low (Remaining duration)"] = true,
        ["Low to High (Remaining duration)"] = true,
        ["Hight to Low (Max duration)"] = true,
        ["Low to High (Max duration)"] = true,
    }

    self.listboxOrientations = {
        ["Horizontal"] = true,
        ["Vertical"] = true,
    }

    self.timeStackAlignments = {
        ["Up"] = true,
        ["Down"] = true,
    }

    self.Classes = {
        ["Beorning"] = Turbine.Gameplay.Class.Beorning,
        ["Brawler"] = Turbine.Gameplay.Class.Brawler,
        ["Burglar"] = Turbine.Gameplay.Class.Burglar,
        ["Captain"] = Turbine.Gameplay.Class.Captain,
        ["Champion"] = Turbine.Gameplay.Class.Champion,
        ["Corsair"] = Turbine.Gameplay.Class.Brawler,
        ["Guardian"] = Turbine.Gameplay.Class.Guardian,
        ["Hunter"] = Turbine.Gameplay.Class.Hunter,
        ["LoreMaster"] = Turbine.Gameplay.Class.LoreMaster,
        ["Minstrel"] = Turbine.Gameplay.Class.Minstrel,
        ["RuneKeeper"] = Turbine.Gameplay.Class.RuneKeeper,
        ["Warden"] = Turbine.Gameplay.Class.Warden,
        ["BlackArrow"] = Turbine.Gameplay.Class.BlackArrow,
        ["Defiler"] = Turbine.Gameplay.Class.Defiler,
        ["Reaver"] = Turbine.Gameplay.Class.Reaver,
        ["Stalker"] = Turbine.Gameplay.Class.Stalker,
        ["WarLeader"] = Turbine.Gameplay.Class.WarLeader,
        ["Weaver"] = Turbine.Gameplay.Class.Weaver
    }

    self.alignments = {
        ["Left"] = true,
        ["Middle"] = true,
        ["Right"] = true,
    }

    self.UIElements = {
        ["Icon"] = true,
        ["Text"] = true,
        
        --["TimerIcon"] = true,
        ["TimerIcon2"] = true,
        --["SkillLabel"] = true,

        ["MoraleBar"] = true,
        ["MoraleBar_Target"] = true,
        ["PowerBar_Target"] = true,
        ["PowerBar"] = true,
        ["WrathBar"] = true,
        ["PetMoraleBar"] = true,

        ["ResourceBar"] = true,
        ["Ballad Bar"] = true,

        ["BuffBar"] = true,
        ["BuffBar_Target"] = true,

        ["Skills"] = true,

        ["ValueBar"] = true,
        ["Timer"] = true,
        ["TimerGroup"] = true,
        ["Circle Timer"] = true,

        ["Countdown"] = true,
        ["Sound"] = true,

        ["Alert"] = true,
        ["AlertGroup"] = true,

        ["Note Event"] = true,
        ["Note Activation"] = true,

        ["Effect Listbox"] = true,
        ["Counter"] = true,

        ["Event Keyword"] = true,
        ["Conditions"] = true,
        ["Figures"] = true,

        ["Code"] = true,

        ["Gambit Bar"] = true,

        ["User Variables"] = true,

        ["SkillBar"] = true,
    }

    self.SortOrderTable = {
        [1] = "Text",
        [2] = "Text",
        [10] = "Numerical",
        [20] = "Alignment",
        [21] = "Alignment",
        [22] = "Alignment",
        [23] = "Alignment",
        [24] = "Font",
        [30] = "Toggles",
        [35] = "Icon",
        [40] = "Colours",
        [50] = "Triggers",
        [55] = "Activations",
        [60] = "Orientation",
        [70] = "Quickslots",
        [71] = "Quickslot Events",
    }

    self.lines = {
        ["All"] = true,
        ["Blue"] = true,
        ["Red"] = true,
        ["Yellow"] = true,
    }

    self.roles = {
        ["All"] = true,
        ["Undefined"] = true,
        ["Tank"] = true,
        ["Heal"] = true,
        ["Support"] = true,
        ["DPS"] = true,
    }

    --self.iconWindow = IconOverview()
    --self.effectWindow = HistoricalEffectOverview()
    --self.skillWindow = SkillOverview()
    --self.skillCodesWindow = SkillOverview2()

    self.IOWindow = IOWindow(self)
    self.NewWindow = NewWindow(self)

    self.leftBorder1 = Turbine.UI.Control()
    self.leftBorder1:SetParent(self)
    self.leftBorder1:SetSize(2, self.height)
    self.leftBorder1:SetPosition(208, 10)
    self.leftBorder1:SetMouseVisible(false)
    self.leftBorder1:SetBackColorBlendMode(Turbine.UI.BlendMode.AlphaBlend)
    self.leftBorder1:SetBackColor(Turbine.UI.Color.Black)

    self.InfoBorderContainer = Turbine.UI.Control()
    self.InfoBorderContainer:SetParent(self)
    self.InfoBorderContainer:SetPosition(210, 10)
    self.InfoBorderContainer:SetSize(580, 65)
    self.InfoBorderContainer:SetBackColor(Turbine.UI.Color.Black)

    self.InfoContainer = Turbine.UI.Control()
    self.InfoContainer:SetParent(self)
    self.InfoContainer:SetPosition(210, 10)
    self.InfoContainer:SetSize(560, 65 - 2)
    self.InfoContainer:SetBackColor(Turbine.UI.Color(0.2, 0.2, 0.2))
    --self.InfoContainer:SetBackColor(Turbine.UI.Color.Blue)

    self.InfoHeaderBackground = Turbine.UI.Label()
    self.InfoHeaderBackground:SetParent(self.InfoContainer)
    self.InfoHeaderBackground:SetSize(570 + 1, 22)
    self.InfoHeaderBackground:SetMouseVisible(false)
    self.InfoHeaderBackground:SetBackColor(Turbine.UI.Color(0, 0, 0))

    self.InfoHeaderLabel = Turbine.UI.Label()
    self.InfoHeaderLabel:SetParent(self.InfoContainer)
    self.InfoHeaderLabel:SetSize(560 - 3, 20)
    self.InfoHeaderLabel:SetPosition(1, 0)
    self.InfoHeaderLabel:SetMouseVisible(true)
    --self.InfoHeaderLabel:SetBackColorBlendMode(Turbine.UI.BlendMode.AlphaBlend)
    self.InfoHeaderLabel:SetBackColor(Turbine.UI.Color(0.125, 0.125, 0.125))
    self.InfoHeaderLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.InfoHeaderLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold22)
    self.InfoHeaderLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.InfoHeaderLabel:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
    self.InfoHeaderLabel:SetText("PrimeUI Options")

    self.InfoHeaderLabel.MouseDown = function(sender,args)
        self.MoveX = args.X
        self.MoveY = args.Y
        self.Moving = true
    end
  
    self.InfoHeaderLabel.MouseUp = function()
        self.Moving = false
    end
  
    self.InfoHeaderLabel.MouseMove = function(sender,args)
        if self.Moving then
          local newLeft = self:GetLeft() - (self.MoveX - args.X)
          local newTop = self:GetTop() - (self.MoveY - args.Y)
          self:SetPosition(newLeft,newTop)
        end
    end

    self.GeneralPrimeUISettingsControl = Turbine.UI.Control()
    self.GeneralPrimeUISettingsControl:SetParent(self)
    self.GeneralPrimeUISettingsControl:SetPosition(210, 75)
    self.GeneralPrimeUISettingsControl:SetSize(560 - 10, 450)
    self.GeneralPrimeUISettingsControl:SetVisible(false)
    --self.GeneralPrimeUISettingsControl:SetBackColor(Turbine.UI.Color.Red)

    -- PrimeUI Options treeview
    self.PrimeUIOptionsTreeView = Turbine.UI.TreeView()
    self.PrimeUIOptionsTreeView:SetParent(self.InfoContainer)
    self.PrimeUIOptionsTreeView:SetSize(self.InfoContainer:GetWidth(), 20)
    self.PrimeUIOptionsTreeView:SetPosition(0, self.InfoHeaderBackground:GetHeight())
    self.PrimeUIOptionsTreeView:SetIndentationWidth(0)
    --self.PrimeUIOptionsTreeView:SetBackColor(Turbine.UI.Color.BlanchedAlmond)

    self.PrimeUIOptionsTreeNodes = self.PrimeUIOptionsTreeView:GetNodes()

    self.optionsListboxNode = PrimeUITools.PrimeUIOptions.OptionsHeader(self.InfoContainer:GetWidth(), 4, true)

    self.PrimeUIOptionsTreeNodes:Add(self.optionsListboxNode)

    -- PrimeUI general settings treeview toggle
    self.PrimeUISettingsTreeview = Turbine.UI.TreeView()
    self.PrimeUISettingsTreeview:SetParent(self.InfoContainer)
    self.PrimeUISettingsTreeview:SetSize(self.InfoContainer:GetWidth(), 20)
    self.PrimeUISettingsTreeview:SetPosition(0, self.InfoHeaderBackground:GetHeight() + 20)
    self.PrimeUISettingsTreeview:SetIndentationWidth(0)
    --self.PrimeUISettingsTreeview:SetBackColor(Turbine.UI.Color.Crimson)

    self.PrimeUISettingsTreeNodes = self.PrimeUISettingsTreeview:GetNodes()

    self.settingsListboxNode = PrimeUITools.PrimeUIOptions.OptionsHeader(self.InfoContainer:GetWidth(), 3, true)

    self.PrimeUISettingsTreeNodes:Add(self.settingsListboxNode)

    -- [[
    --]]

    self.CurrentLeft = Turbine.UI.Control()
    self.CurrentLeft:SetParent(self.Background)
    self.CurrentLeft:SetPosition(0, 20)
    self.CurrentLeft:SetSize(22, 26)
    self.CurrentLeft:SetBackground(BackgroundHandler:GetBackground(0x411BAF1E))
    self.CurrentLeft:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)

    self.CurrentRight = Turbine.UI.Control()
    self.CurrentRight:SetParent(self.Background)
    self.CurrentRight:SetPosition(195 - 23, 20)
    self.CurrentRight:SetSize(23, 26)
    self.CurrentRight:SetBackground(BackgroundHandler:GetBackground(0x411BAF20))
    self.CurrentRight:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)

    self.CurrentMiddle = Turbine.UI.Control()
    self.CurrentMiddle:SetParent(self.Background)
    self.CurrentMiddle:SetPosition(22, 20)
    self.CurrentMiddle:SetSize(195 - 40, 26)
    self.CurrentMiddle:SetBackground(BackgroundHandler:GetBackground(0x411BAF19))
    self.CurrentMiddle:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)

    self.CurrentLabel = Turbine.UI.Label()
    self.CurrentLabel:SetParent(self.Background)
    self.CurrentLabel:SetPosition(6, 23)
    self.CurrentLabel:SetSize(195, 20)
    self.CurrentLabel:SetTextAlignment(Turbine.UI.ContentAlignment.TopCenter)
    self.CurrentLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold22)
    --self.CurrentLabel:SetBackColor(Turbine.UI.Color(0.5, 0.5, 0.5))
    self.CurrentLabel:SetText("PrimeUIs")

    self.PrimeUIContainer = Turbine.UI.TreeView()
    self.PrimeUIContainer:SetParent(self.Background)
    self.PrimeUIContainer:SetSize(200 - 10, self.Background:GetHeight() - 46 - 10)
    self.PrimeUIContainer:SetPosition(0, 46)
    self.PrimeUIContainer:SetVisible(true)
    self.PrimeUIContainer:SetWantsKeyEvents(true)
    self.PrimeUIContainer:SetMouseVisible(false)
    self.PrimeUIContainer:SetIndentationWidth( 0 )
    --self.PrimeUIContainer:SetBackColor(Turbine.UI.Color.Pink)

    self.PrimeUIContainerScrollbar = Turbine.UI.Lotro.ScrollBar()
    self.PrimeUIContainerScrollbar:SetOrientation( Turbine.UI.Orientation.Vertical )
    self.PrimeUIContainerScrollbar:SetParent( self.Background )
    self.PrimeUIContainerScrollbar:SetPosition( 200 - 10, 46 )
    self.PrimeUIContainerScrollbar:SetSize( 10, self.Background:GetHeight() - 46 - 10)
    self.PrimeUIContainer:SetVerticalScrollBar( self.PrimeUIContainerScrollbar )

    self.SetupContainer = Turbine.UI.Control()
    self.SetupContainer:SetParent(self)
    self.SetupContainer:SetVisible(true)
    self.SetupContainer:SetPosition(210, 75)
    self.SetupContainer:SetSize(565 - 10, 450 - 2)
    --self.SetupContainer:SetBackColor(Turbine.UI.Color(0.1, 0.1, 0.1))
    --self.SetupContainer:SetBackColor(Turbine.UI.Color.Purple)

    self.ElementListbox = Turbine.UI.ListBox()
    self.ElementListbox:SetParent(self.SetupContainer)
    self.ElementListbox:SetVisible(true)
    --self.ElementListbox:SetBackColor(Turbine.UI.Color.Gold)
    self.ElementListbox:SetMaxColumns(1)
    self.ElementListbox:SetOrientation(Turbine.UI.Orientation.Vertical)

    self.ElementListboxScrollbarBackground = Turbine.UI.Control()
    self.ElementListboxScrollbarBackground:SetParent(self.SetupContainer)
    self.ElementListboxScrollbarBackground:SetVisible(true)
    self.ElementListboxScrollbarBackground:SetBackColor(Turbine.UI.Color.Black) 

    self.ElementListboxScrollbar = Turbine.UI.Lotro.ScrollBar()
    self.ElementListboxScrollbar:SetParent(self.SetupContainer)
    self.ElementListboxScrollbar:SetVisible(true)
    self.ElementListboxScrollbar:SetOrientation(Turbine.UI.Orientation.Vertical)
    self.ElementListboxScrollbar:SetBackColor(Turbine.UI.Color.Black)
    self.ElementListbox:SetVerticalScrollBar(self.ElementListboxScrollbar)



    self.ElementOptionsControl = Turbine.UI.Control()
    self.ElementOptionsControl:SetParent(self.SetupContainer)
    self.ElementOptionsControl:SetVisible(true)
    --self.ElementOptionsControl:SetBackColor(Turbine.UI.Color.Red)

    self.PrimeUIElementOptoinsTreeview = Turbine.UI.TreeView()
    self.PrimeUIElementOptoinsTreeview:SetParent(self.ElementOptionsControl)
    self.PrimeUIElementOptoinsTreeview:SetIndentationWidth(0)
    --self.PrimeUIElementOptoinsTreeview:SetBackColor(Turbine.UI.Color.Bisque)

    self.PrimeUIElementxScrollbarBackground = Turbine.UI.Control()
    self.PrimeUIElementxScrollbarBackground:SetParent(self.ElementOptionsControl)
    self.PrimeUIElementxScrollbarBackground:SetVisible(true)
    self.PrimeUIElementxScrollbarBackground:SetBackColor(Turbine.UI.Color.Black) 

    self.PrimeUIElementOptoinsScrollbar = Turbine.UI.Lotro.ScrollBar()
    self.PrimeUIElementOptoinsScrollbar:SetParent(self.ElementOptionsControl)
    self.PrimeUIElementOptoinsScrollbar:SetVisible(true)
    self.PrimeUIElementOptoinsScrollbar:SetOrientation(Turbine.UI.Orientation.Vertical)
    self.PrimeUIElementOptoinsScrollbar:SetBackColor(Turbine.UI.Color.Black)
    self.PrimeUIElementOptoinsTreeview:SetVerticalScrollBar(self.PrimeUIElementOptoinsScrollbar)

    self.PrimeUIElementOptoinsTreeviewNodes = self.PrimeUIElementOptoinsTreeview:GetNodes()

    self.ElementSubOptoinsTreeview = Turbine.UI.TreeView()
    self.ElementSubOptoinsTreeview:SetParent(self.ElementOptionsControl)
    self.ElementSubOptoinsTreeview:SetIndentationWidth(0)
    --self.ElementSubOptoinsTreeview:SetBackColor(Turbine.UI.Color.Purple)

    self.ElementSubOptoinsTreeviewScrollbarBackground = Turbine.UI.Control()
    self.ElementSubOptoinsTreeviewScrollbarBackground:SetParent(self.ElementOptionsControl)
    self.ElementSubOptoinsTreeviewScrollbarBackground:SetVisible(true)
    self.ElementSubOptoinsTreeviewScrollbarBackground:SetBackColor(Turbine.UI.Color.Black) 

    self.ElementSubOptoinsTreeviewScrollbar = Turbine.UI.Lotro.ScrollBar()
    self.ElementSubOptoinsTreeviewScrollbar:SetParent(self.ElementOptionsControl)
    self.ElementSubOptoinsTreeviewScrollbar:SetVisible(true)
    self.ElementSubOptoinsTreeviewScrollbar:SetOrientation(Turbine.UI.Orientation.Vertical)
    self.ElementSubOptoinsTreeviewScrollbar:SetBackColor(Turbine.UI.Color.Black)
    self.ElementSubOptoinsTreeview:SetVerticalScrollBar(self.ElementSubOptoinsTreeviewScrollbar)

    self.ElementSubOptoinsTreeviewNodes = self.ElementSubOptoinsTreeview:GetNodes()

    self.closeButton = Turbine.UI.Control()
    self.closeButton:SetParent(self)
    self.closeButton:SetVisible(true)
    self.closeButton:SetBackColor(Turbine.UI.Color.Red) 
    self.closeButton.MouseClick = function()
        self:SetVisible(false)
    end

    self.ImportButton = Turbine.UI.Lotro.Button()
	self.ImportButton:SetParent(self.Background)
	self.ImportButton:SetSize(115, 40)
	self.ImportButton:SetPosition(0, 0)
    self.ImportButton:SetText("Import PrimeUI")

    self.ImportButton.Click = function()
        self.IOWindow:View()
    end

    self.NewButton = Turbine.UI.Lotro.Button()
	self.NewButton:SetParent(self.Background)
	self.NewButton:SetSize(80, 20)
	self.NewButton:SetPosition(115, 0)
    self.NewButton:SetText("New")

    self.NewButton.Click = function()
        self.NewWindow:View()
    end

    self.rootNodes = self.PrimeUIContainer:GetNodes()

    self.data = PrimeUIHandlerObject:GetData()

    for _, data in spairs(self.data, function(t, a, b) return t[a]["Name"] < t[b]["Name"] end) do
        self:CreateUIItem(self.SetupContainer, data)
    end

    local sortedUIElements = {}
    for key, value in pairs(self.UIElements) do table.insert( sortedUIElements, key ) end
    table.sort( sortedUIElements )

    self.UIElementOptions = UI.DropDownMenuControl(self, 400, "UI Element Dropdown Menu")
    for key, name in pairs(sortedUIElements) do
        --local menuItem = Turbine.UI.MenuItem( value )
        self.UIElementOptions:AddItem(name, 
        function()
            local count = tablelength(self.currentUI["PrimeUI"]) + 1
            local newTable = self:GetUIElementData(name, count)
            table.insert(self.currentUI["PrimeUI"], newTable)
            PrimeUIHandlerObject:Refresh(self.currentUI["Name"], self.currentUI["PrimeUI"])
            self.data = PrimeUIHandlerObject:GetData()
            self.treeviewBoxes[self.currentUI["Name"]].SourceLabel:MouseClick()

            self.UIElementOptions:SetVisible(false)
        end, self.UIElementInfoStrings[name], self.infoWindow)
    end

    self.AddButton = PrimeUITools.PrimeUIOptions.OptionsListBoxButton(math.floor(self.InfoContainer:GetWidth() / 4), 20, "Add UI Element", function()
        if self.currentUI then
            self.UIElementOptions:ToggleVisible()
        end
    end)

    self.optionsListboxNode:AddItem(self.AddButton)

    self.MoveButton = PrimeUITools.PrimeUIOptions.OptionsListBoxButton(math.floor(self.InfoContainer:GetWidth() / 4), 20, "Move PrimeUI", function()
        if self.currentUI then
            self.Moving = not(self.Moving)
            PrimeUIHandlerObject:Move(self.currentUI["Name"])
        end
    end)

    self.optionsListboxNode:AddItem(self.MoveButton)

    self.OutputButton = PrimeUITools.PrimeUIOptions.OptionsListBoxButton(math.floor(self.InfoContainer:GetWidth() / 4), 20, "Output PrimeUI", function()
        if self.currentUI and self.notChanging then
            self.IOWindow:View(self.currentUI)
        end
    end)

    self.optionsListboxNode:AddItem(self.OutputButton)

    self.DeleteButton = PrimeUITools.PrimeUIOptions.OptionsListBoxButton(math.floor(self.InfoContainer:GetWidth() / 4), 20, "Delete PrimeUI", function()
        if self.currentUI then
            local confirmationWindow = UI.ConfirmationWindow("Do you really want to delete this primeUI?", function() 
                if self.currentUI then
                    PrimeUIHandlerObject:Delete(self.currentUI["Name"])
                    self.rootNodes:Remove(self.treeviewBoxes[self.currentUI["Name"]])
                    self.treeviewBoxes[self.currentUI["Name"]]:SetParent(nil)
                    self.treeviewBoxes[self.currentUI["Name"]] = nil
                    self.InfoHeaderLabel:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
                    self.InfoHeaderLabel:SetText("PrimeUIs")
                    self.currentUI = nil
                    self.data = PrimeUIHandlerObject:GetData()
                end
            end, function() end)
        end
    end)

    self.optionsListboxNode:AddItem(self.DeleteButton)

    -- Second row buttons
    self.UIElementOptionsButton = PrimeUITools.PrimeUIOptions.OptionsListBoxButton(math.floor(self.InfoContainer:GetWidth() / 3), 20, "UI Element Options", function()
        if self.currentUI then
            self.SetupContainer:SetVisible(true)
            self.GeneralPrimeUISettingsControl:SetVisible(false)
        end
    end)

    self.settingsListboxNode:AddItem(self.UIElementOptionsButton)

    self.ElementImportSettingsButton = PrimeUITools.PrimeUIOptions.OptionsListBoxButton(math.floor(self.InfoContainer:GetWidth() / 3), 20, "Import Element", function()
        if self.currentUI then
            self.IOWindow:View()
        end
    end)

    self.settingsListboxNode:AddItem(self.ElementImportSettingsButton)

    self.GeneralPrimeUISettingsButton = PrimeUITools.PrimeUIOptions.OptionsListBoxButton(math.floor(self.InfoContainer:GetWidth() / 3), 20, "General PrimeUI Settings", function()
        if self.currentUI then
            self.SetupContainer:SetVisible(false)
            self.GeneralPrimeUISettingsControl:SetVisible(true)
        end
    end)

    self.settingsListboxNode:AddItem(self.GeneralPrimeUISettingsButton)

    self:CreateGeneralPrimeUIOptions()    

    self.SizeChanged = function()
        self:Format()
    end
end

function PrimeUIOptions:Format()
    self.width, self.height = self:GetSize()

    self.BorderBackground:SetPosition(0, 0)
    self.BorderBackground:SetSize(self.width, self.height)

    self.Background:SetPosition(self.borderSize, self.borderSize)
    self.Background:SetSize(self.width - 2 * self.borderSize, self.height - 2 * self.borderSize)

    -- PrimeUI Header label
    self.CurrentLeft:SetPosition(0, self.ImportButton:GetHeight())
    self.CurrentLeft:SetSize(22, 26)

    self.CurrentRight:SetPosition(195 - 23, self.ImportButton:GetHeight())
    self.CurrentRight:SetSize(23, 26)

    self.CurrentMiddle:SetPosition(22, self.ImportButton:GetHeight())
    self.CurrentMiddle:SetSize(195 - 40, 26)

    self.CurrentLabel:SetPosition(6, 23)
    self.CurrentLabel:SetSize(195, self.ImportButton:GetHeight())

    -- Options button
    self.ImportButton:SetSize(115, 40)
    self.ImportButton:SetPosition(0, 0)

    self.NewButton:SetSize(80, 20)
    self.NewButton:SetPosition(115, 0)

    -- PimreUI list treeview
    self.PrimeUIContainer:SetSize(200 - 10, self.Background:GetHeight() - self.CurrentMiddle:GetHeight() - self.CurrentMiddle:GetTop())
    self.PrimeUIContainer:SetPosition(0, self.CurrentMiddle:GetHeight() + self.CurrentMiddle:GetTop())

    self.PrimeUIContainerScrollbar:SetPosition( 200 - 10, self.CurrentMiddle:GetHeight() + self.CurrentMiddle:GetTop())
    self.PrimeUIContainerScrollbar:SetSize( 10, self.Background:GetHeight() - self.CurrentMiddle:GetHeight() - self.CurrentMiddle:GetTop())

    -- Border separating the primeUI list and the options
    self.leftBorder1:SetSize(2, self.Background:GetHeight())
    self.leftBorder1:SetPosition(self.borderSize + self.PrimeUIContainer:GetWidth() + self.PrimeUIContainerScrollbar:GetWidth() + self.PrimeUIContainer:GetLeft(), 0)

    -- Infocontainer is the top containing the header label and the general options
    self.InfoContainer:SetPosition(self.leftBorder1:GetLeft() + self.leftBorder1:GetWidth(), self.borderSize)
    self.InfoContainer:SetSize(self.Background:GetWidth() - self.InfoContainer:GetLeft(), 65)

    self.InfoHeaderLabel:SetSize(self.InfoContainer:GetWidth() - 3, 20)
    self.InfoHeaderLabel:SetPosition(1, 0)

    self.InfoBorderContainer:SetPosition(self.leftBorder1:GetLeft() + self.leftBorder1:GetWidth(), 10)
    self.InfoBorderContainer:SetSize(self.InfoContainer:GetWidth(), self.InfoContainer:GetHeight())

    --Info container options listbox buttons

    local buttonWidth4 = math.floor(self.InfoContainer:GetWidth() / 4)
    -- 4 top buttons
    self.optionsListboxNode:SetWidth(self.InfoContainer:GetWidth())
    self.AddButton:SetSize(buttonWidth4, 20)
    self.MoveButton:SetSize(buttonWidth4, 20)
    self.OutputButton:SetSize(buttonWidth4, 20)
    self.DeleteButton:SetSize(buttonWidth4, 20)

    -- 3 bottom buttons
    local buttonWidth3 = math.floor(self.InfoContainer:GetWidth() / 3)
    self.settingsListboxNode:SetWidth(self.InfoContainer:GetWidth())
    self.UIElementOptionsButton:SetSize(buttonWidth3, 20)
    self.ElementImportSettingsButton:SetSize(buttonWidth3, 20)
    self.GeneralPrimeUISettingsButton:SetSize(buttonWidth3, 20)


    self.InfoHeaderBackground:SetSize(self.InfoContainer:GetWidth(), 22)

    -- PrimeUI Options
    self.GeneralPrimeUISettingsControl:SetPosition(self.leftBorder1:GetLeft() + self.leftBorder1:GetWidth(), self.InfoContainer:GetTop() + self.InfoContainer:GetHeight())
    self.GeneralPrimeUISettingsControl:SetSize(self.Background:GetWidth() - self.GeneralPrimeUISettingsControl:GetLeft(), self.Background:GetHeight() - self.GeneralPrimeUISettingsControl:GetTop())

    -- Element options
    self.PrimeUIOptionsTreeView:SetSize(self.InfoContainer:GetWidth(), 20)
    self.PrimeUIOptionsTreeView:SetPosition(0, self.InfoHeaderBackground:GetHeight())

    self.PrimeUISettingsTreeview:SetSize(self.InfoContainer:GetWidth(), 20)
    self.PrimeUISettingsTreeview:SetPosition(0, self.InfoHeaderBackground:GetHeight() + 20)

    -- General primeUIsettings items
    self.PrimeUIGeneralOptionsTreeviewInControl:SetSize(self.GeneralPrimeUISettingsControl:GetWidth(), self.GeneralPrimeUISettingsControl:GetHeight())
    self.PrimeUIGeneralOptionsScrollbar:SetPosition( self.GeneralPrimeUISettingsControl:GetWidth() - 10, 0)
    self.PrimeUIGeneralOptionsScrollbar:SetSize( 10, self.GeneralPrimeUISettingsControl:GetHeight())

    self.PrimeUIGeneralOptionsScrollbarBackground:SetPosition( self.GeneralPrimeUISettingsControl:GetWidth() - 10, 0)
    self.PrimeUIGeneralOptionsScrollbarBackground:SetSize( 10,self.GeneralPrimeUISettingsControl:GetHeight())

    

    for i = 1, self.PrimeUIGeneralOptionsTreeNodesInControl:GetCount() do
        self.PrimeUIGeneralOptionsTreeNodesInControl:Get(i):SetWidth(self.GeneralPrimeUISettingsControl:GetWidth() - 10)
    end

    for i = 1, self.childClassNode:GetCount() do
        self.childClassNode:Get(i):SetWidth(self.GeneralPrimeUISettingsControl:GetWidth() - 10)
    end

    for i = 1, self.childInstanceNode:GetCount() do
        self.childInstanceNode:Get(i):SetWidth(self.GeneralPrimeUISettingsControl:GetWidth() - 10)
    end

    for i = 1, self.lineClassNode:GetCount() do
        self.lineClassNode:Get(i):SetWidth(self.GeneralPrimeUISettingsControl:GetWidth() - 10)
    end

    for i = 1, self.childInstanceTierNode:GetCount() do
        self.childInstanceTierNode:Get(i):SetWidth(self.GeneralPrimeUISettingsControl:GetWidth() - 10)
    end

    for i = 1, self.roleClassNode:GetCount() do
        self.roleClassNode:Get(i):SetWidth(self.GeneralPrimeUISettingsControl:GetWidth() - 10)
    end

    for i = 1, self.childCharacterNodes:GetCount() do
        self.childCharacterNodes:Get(i):SetWidth(self.GeneralPrimeUISettingsControl:GetWidth() - 10)
    end

    -- Element stuff
    self.SetupContainer:SetPosition(self.leftBorder1:GetLeft() + self.leftBorder1:GetWidth(), self.InfoContainer:GetTop() + self.InfoContainer:GetHeight())
    self.SetupContainer:SetSize(self.Background:GetWidth() - self.SetupContainer:GetLeft(), self.Background:GetHeight() - self.SetupContainer:GetTop())

    self.ElementListbox:SetPosition(0, 0)
    self.ElementListbox:SetSize(340, self.SetupContainer:GetHeight())

    self.ElementListboxScrollbar:SetPosition(self.ElementListbox:GetWidth(), 0)
    self.ElementListboxScrollbar:SetSize(10, self.ElementListbox:GetHeight())

    self.ElementListboxScrollbarBackground:SetPosition(self.ElementListbox:GetWidth(), 0)
    self.ElementListboxScrollbarBackground:SetSize(10, self.ElementListbox:GetHeight())

    self.ElementOptionsControl:SetPosition(self.ElementListbox:GetWidth() + self.ElementListboxScrollbar:GetWidth(), 0)
    self.ElementOptionsControl:SetSize(self.SetupContainer:GetWidth() - self.ElementListbox:GetWidth() - self.ElementListboxScrollbar:GetWidth(), self.SetupContainer:GetHeight())

    local treeviewHeight = 0
    for i = 1, self.PrimeUIElementOptoinsTreeviewNodes:GetCount() do
        treeviewHeight = treeviewHeight + self.PrimeUIElementOptoinsTreeviewNodes:Get(i):GetHeight()
    end
    self.PrimeUIElementOptoinsScrollbar:SetSize(10, treeviewHeight)

    self.PrimeUIElementOptoinsTreeview:SetSize(self.ElementOptionsControl:GetWidth() - self.PrimeUIElementOptoinsScrollbar:GetWidth(), treeviewHeight)
    self.PrimeUIElementOptoinsTreeview:SetPosition(0, 0)

    self.PrimeUIElementOptoinsScrollbar:SetPosition(self.PrimeUIElementOptoinsTreeview:GetWidth(), 0)

    self.PrimeUIElementxScrollbarBackground:SetSize(10, treeviewHeight)
    self.PrimeUIElementxScrollbarBackground:SetPosition(self.PrimeUIElementOptoinsTreeview:GetWidth(), 0)

    for i = 1, self.PrimeUIElementOptoinsTreeviewNodes:GetCount() do
        local item = self.PrimeUIElementOptoinsTreeviewNodes:Get(i)
        item:SetWidth(self.PrimeUIElementOptoinsTreeview:GetWidth())
        if item.ResizeItems then
            item:ResizeItems()
        end
        if item.GetChildNodes then
            local itemNodes = item:GetChildNodes()
            for j = 1, itemNodes:GetCount() do
                itemNodes:Get(j):SetWidth(self.PrimeUIElementOptoinsTreeview:GetWidth())
                if itemNodes.GetChildNodes then
                    local itemNodes2 = itemNodes:GetChildNodes()
                    for k = 1, itemNodes2:GetCount() do
                        itemNodes2:Get(k):SetWidth(self.PrimeUIElementOptoinsTreeview:GetWidth())
                    end
                end
            end
        end

    end

    self.ElementSubOptoinsTreeview:SetSize(self.ElementOptionsControl:GetWidth() - self.ElementSubOptoinsTreeviewScrollbar:GetWidth(), self.ElementOptionsControl:GetHeight() - treeviewHeight)
    self.ElementSubOptoinsTreeview:SetPosition(0, treeviewHeight)

    self.ElementSubOptoinsTreeviewScrollbarBackground:SetSize(10, self.ElementOptionsControl:GetHeight() - treeviewHeight)
    self.ElementSubOptoinsTreeviewScrollbarBackground:SetPosition(self.ElementSubOptoinsTreeview:GetWidth(), self.ElementSubOptoinsTreeview:GetTop())

    self.ElementSubOptoinsTreeviewScrollbar:SetSize(10, self.ElementOptionsControl:GetHeight() - treeviewHeight)
    self.ElementSubOptoinsTreeviewScrollbar:SetPosition(self.ElementSubOptoinsTreeview:GetWidth(), self.ElementSubOptoinsTreeview:GetTop())

    for i = 1, self.ElementSubOptoinsTreeviewNodes:GetCount() do
        self.ElementSubOptoinsTreeviewNodes:Get(i):SetWidth(self.ElementSubOptoinsTreeview:GetWidth())
    end

    self.closeButton:SetSize(20, 20)
    self.closeButton:SetPosition(self.width - 20, 0)
end

function PrimeUIOptions:Add(data, override)
    local code = false
    if not(override) then
        for key, value in pairs(data.PrimeUI) do
            if value.Type == "Code" then
                code = true
            end
        end
    end
    local additionConfirmation = function()
        if PrimeUIHandlerObject:AddUI(data) then
            self:CreateUIItem(self.SetupContainer, data)
            ChatOutput("Imported PrimeUI: " .. tostring(data["Name"]))
            self.IOWindow:SetVisible(false)
            return true
        else
            local confirmationWindow = UI.ConfirmationWindow("A PrimeUI with this name already exists, do you want to override it?", 
                function() 
                    UI.ConfirmationWindow("Do you want to keep the current positioning of the elements?", 
                    -- keep positions
                    function() 
                        if data then
                            local UIData = PrimeUIHandlerObject:GetUI(data["Name"])
                            local positionTable = {}
                            local MainX, MainY = UIData.X, UIData.Y
                            for key, value in pairs(UIData.PrimeUI) do
                                positionTable[value.Order] = {["X"] = value.X, ["Y"] = value.Y}
                            end
                            data.X, data.Y = UIData.X, UIData.Y
                            for key, value in pairs(data.PrimeUI) do
                                if positionTable[value.Order] then
                                    data.PrimeUI[key].X, data.PrimeUI[key].Y = positionTable[value.Order].X, positionTable[value.Order].Y
                                end
                            end
                            PrimeUIHandlerObject:Delete(data["Name"])
                            self.rootNodes:Remove(self.treeviewBoxes[data["Name"]])
                            self.treeviewBoxes[data["Name"]]:SetParent(nil)
                            self.treeviewBoxes[data["Name"]] = nil
                            self.InfoHeaderLabel:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
                            self.InfoHeaderLabel:SetText("PrimeUIs")
                            self.data = PrimeUIHandlerObject:GetData()
                            self:Add(data, true)
                            self.IOWindow:SetVisible(false)
                            ChatOutput("Overwrote the PrimeUI succesfully and retained the positioning!")
                            return true
                        end
                    end, 
                    -- override positions
                    function() 
                        if data then
                            PrimeUIHandlerObject:Delete(data["Name"])
                            self.rootNodes:Remove(self.treeviewBoxes[data["Name"]])
                            self.treeviewBoxes[data["Name"]]:SetParent(nil)
                            self.treeviewBoxes[data["Name"]] = nil
                            self.InfoHeaderLabel:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
                            self.InfoHeaderLabel:SetText("PrimeUIs")
                            self.data = PrimeUIHandlerObject:GetData()
                            self:Add(data, true)
                            self.IOWindow:SetVisible(false)
                            ChatOutput("Overwrote the PrimeUI succesfully and overwrite the positioning!")
                            return true
                        end
                    end)
            end, function() 
                self.IOWindow:SetVisible(false)
                ChatOutput("Failed to add PrimeUI: Name already exists") 
                return false
            end)
        end
    end

    if code then
        local confirmationWindow = UI.ConfirmationWindow("This PrimeUI contains custom LUA code, do you want to proceed?", function()
            ChatOutput("Accepted code step")
            return additionConfirmation()
        end, function()
            self.IOWindow:SetVisible(false)
            ChatOutput("Failed to add PrimeUI: Cancelled by user") 
         end)
    else
        return additionConfirmation()
    end
end

function PrimeUIOptions:CreateNew(name, advancedMode)
    if PrimeUIHandlerObject:AddUI(PrimeUIHandlerObject:GetBaseData(name, advancedMode)) then
        self.data = PrimeUIHandlerObject:GetData()
        for _, data in pairs(self.data) do
            if data["Name"] == name then
                self:CreateUIItem(self.SetupContainer, data)
            end
        end

        return true
    else
        return false
    end
end

function PrimeUIOptions:ExtendTreeview(data, width)

    if self.treeviewBoxes[data["Name"]] then return end

    local SourceNode = Turbine.UI.TreeNode()
    SourceNode:SetSize(width - 10, 20 + 2)

    SourceNode.SourceLabel = Turbine.UI.Label()
    SourceNode.SourceLabel:SetParent(SourceNode)
    SourceNode.SourceLabel:SetPosition(1,1)
    SourceNode.SourceLabel:SetSize(width - 10- 2, 20)
    SourceNode.SourceLabel:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
    SourceNode.SourceLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold24)
    SourceNode.SourceLabel:SetMouseVisible(true)

    SourceNode.LefLabel = Turbine.UI.Label()
    SourceNode.LefLabel:SetParent(SourceNode)
    SourceNode.LefLabel:SetPosition(0, 0)
    SourceNode.LefLabel:SetSize(30, 20)
    SourceNode.LefLabel:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
    SourceNode.LefLabel:SetBackground(BackgroundHandler:GetBackground(0x4111D1FA))
    SourceNode.LefLabel:SetMouseVisible(false)

    SourceNode.RigthLabel = Turbine.UI.Label()
    SourceNode.RigthLabel:SetParent(SourceNode)
    SourceNode.RigthLabel:SetPosition(width - 157, 0)
    SourceNode.RigthLabel:SetSize(147, 20)
    SourceNode.RigthLabel:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
    SourceNode.RigthLabel:SetBackground(BackgroundHandler:GetBackground(0x4111D1FA))
    SourceNode.RigthLabel:SetMouseVisible(false)

    SourceNode.MidLabel = Turbine.UI.Label()
    SourceNode.MidLabel:SetParent(SourceNode)
    SourceNode.MidLabel:SetPosition(30, 0)
    SourceNode.MidLabel:SetSize(width - 70, 20)
    SourceNode.MidLabel:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
    SourceNode.MidLabel:SetBackground(BackgroundHandler:GetBackground(0x4111D201))
    SourceNode.MidLabel:SetMouseVisible(false)

    SourceNode.textLabel = Turbine.UI.Label()
    SourceNode.textLabel:SetParent(SourceNode)
    SourceNode.textLabel:SetPosition(1,1)
    SourceNode.textLabel:SetSize(width - 10- 2, 20)
    SourceNode.textLabel:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
    SourceNode.textLabel:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19)
    SourceNode.textLabel:SetMouseVisible(false)
    SourceNode.textLabel:SetText(data["Name"])

    SourceNode.SourceLabel.MouseEnter = function()
        SourceNode.LefLabel:SetBackground(BackgroundHandler:GetBackground(0x4111D1FB))
        SourceNode.RigthLabel:SetBackground(BackgroundHandler:GetBackground(0x4111D1FB))
        SourceNode.MidLabel:SetBackground(BackgroundHandler:GetBackground(0x4111D202))
    end

    SourceNode.SourceLabel.MouseLeave = function()
        SourceNode.LefLabel:SetBackground(BackgroundHandler:GetBackground(0x4111D1FA))
        SourceNode.RigthLabel:SetBackground(BackgroundHandler:GetBackground(0x4111D1FA))
        SourceNode.MidLabel:SetBackground(BackgroundHandler:GetBackground(0x4111D201))
    end

    SourceNode.SourceLabel.MouseDown = function()
        SourceNode.LefLabel:SetBackground(BackgroundHandler:GetBackground(0x4111D1FC))
        SourceNode.RigthLabel:SetBackground(BackgroundHandler:GetBackground(0x4111D1FC))
        SourceNode.MidLabel:SetBackground(BackgroundHandler:GetBackground(0x4111D203))
    end

    SourceNode.SourceLabel.MouseUp = function()
        SourceNode.LefLabel:SetBackground(BackgroundHandler:GetBackground(0x4111D1FA))
        SourceNode.RigthLabel:SetBackground(BackgroundHandler:GetBackground(0x4111D1FA))
        SourceNode.MidLabel:SetBackground(BackgroundHandler:GetBackground(0x4111D201))
    end

    SourceNode.ClickFunction = function()
        self:UITreeView(data)
        self.notChanging = false
        self:FillInfoContainer(data)
        self.notChanging = true
        if self.currentUI and self.Moving then
            PrimeUIHandlerObject:Move(self.currentUI["Name"])
            self.Moving = false
        end
        self.currentUI = data
    end

    SourceNode.SourceLabel.MouseClick = function()
        SourceNode.ClickFunction()
    end

    self.treeviewBoxes[data["Name"]] = SourceNode

    self.rootNodes:Add(SourceNode)
end

function PrimeUIOptions:FillInfoContainer(data)
    self.InfoHeaderLabel:SetText(data["Name"])
    for _, key in spairs(InstanceController:GetDungeonNameTable(), function(t, a, b) return a < b end) do
        self.instanceLoadNodes[key]:SetChecked(data["InstanceLoad"] and data["InstanceLoad"][key] or false)
    end
    for i = 1, 5 do
        self.instanceTierNodes[i]:SetChecked(data["InstanceLoad"] and data["InstanceLoad"][i] or false)
    end
    self.authorNode.label:SetText("Author: " .. (data["Author"] or "Legacy"))
    for key, _ in spairs(self.Classes, function(t, a, b) return a < b end) do
        self.classLoadNodes[key]:SetChecked(data["ClassLoad"] and data["ClassLoad"][key] or false)
    end
    if data["ClassLoad"] and data["ClassLoad"]["All"] then
        self.classLoadNodes["All"]:SetChecked(true)
    end
    for key, _ in spairs(self.lines, function(t, a, b) return a < b end) do
        self.lineLoadNodes[key]:SetChecked(data["LineLoad"] and data["LineLoad"][key] or false)
    end
    for key, _ in spairs(self.roles, function(t, a, b) return a < b end) do
        self.roleLoadNodes[key]:SetChecked(data["RoleLoad"] and data["RoleLoad"][key] or false)
    end
    self.OOCheckBox:SetChecked(data["OOCLoad"])
    self.ICheckBox:SetChecked(data["ICLoad"])
    self.NeverLoadCheckbox:SetChecked(data["NeverLoad"])
    self.AdvancedCheckbox:SetChecked(data["AdvancedMode"])
    self.CharacterButton:SetChecked(not(data["CharLoad"]))
    self.AllTierCheckbox:SetChecked(data["AllTiers"] == nil or data["AllTiers"])
    self.AnyInstanceToggle:SetChecked(data["AnyInstance"])
    for key, _ in spairs(Profiles:GetPreferences(), function(t, a, b) return a < b end) do
        self.characterLoadNodes[key]:SetChecked(data["CharacterLoad"] and data["CharacterLoad"][key] or false)
    end
    self.AnchorX:SetValue(data["Anchor_Advanced_X"] or 0)
    self.AnchorY:SetValue(data["Anchor_Advanced_Y"] or 0)
    self.PvPCheckbox:SetChecked(data["OnlyPvP"])
    self.AllDelvingTierCheckbox:SetChecked(data["All_Delving_Tiers"] == nil or data["All_Delving_Tiers"])
    self.DelvingTierButton:SetText(data["Delving_Tier"])
    self.AnyDelvingToggle:SetChecked(data["OnlyAllDelvings"])
    self.DelvingButton:SetText(data["Delving"])
    self.PrimeUINameChangeInput.searchBar:SetText(data.Name)
end

function PrimeUIOptions:CreateUIItem(parent, ObjectData, override)
    local width = parent:GetWidth() - 10
    local height = parent:GetHeight()

    --valuebar:ExpandAll()
    if override then
        ChatOutput(Turbine.Engine.GetCallStack())
    end

    self:ExtendTreeview(ObjectData, 200)
end

function PrimeUIOptions:GetUIElementData(type, id)
    return GetUIElementData(type, id)
end

function PrimeUIOptions:UITreeView(PrimeUIData)
    local width = self.PrimeUIElementOptoinsTreeview:GetWidth()
    for key, value in pairs(self.optionBoxes) do
        if value.Unload then
            value:Unload()
        end
        self.optionBoxes[key] = nil
    end

    for key, value in pairs(self.subOptionBoxes) do
        for j = 1, value:GetCount() do
            local elementItem = value:Get(j)
            if elementItem.Unload then
                elementItem:Unload()
            end
        end
        if value.Unload then
            value:Unload()
        end
        value:Clear()
        self.subOptionBoxes[key] = nil
    end
    self.optionBoxes = nil
    self.optionBoxes = {}
    for i = 1, self.ElementListbox:GetItemCount() do
        local item = self.ElementListbox:GetItem(i)
        if item.buttonListboxNode then
            if item.buttonListboxNode.GetChildNodes then
                local btncn = item.buttonListboxNode:GetChildNodes()
                for j = 1, btncn:GetCount() do
                    local btcnNode = btncn:Get(j)
                    if btcnNode.GetChildNodes then
                        local sbl = btcnNode:GetChildNodes()
                        for k = 1, sbl:GetCount() do
                            local elementItem = sbl:Get(k)
                            if elementItem.Unload then
                                elementItem:Unload()
                            else
                                RecursiveDeletion(elementItem)
                            end
                        end
                        sbl:Clear()
                        ClearNodes(sbl)
                    end
                end
                btncn:Clear()
                ClearNodes(btncn)
            end
            item.buttonListboxNode:Unload()
            item.buttonListboxNode = nil
        end

        if item.Unload then
            item:Unload()
        else
            local itemList = item:GetControls()
            for j = 1, itemList:GetCount() do
                local listboxItem = itemList:Get(1)
                if listboxItem.Unload then
                    listboxItem:Unload()
                end
                itemList:RemoveAt(1)
            end
        end
    end
    --for i = 1, self.PrimeUIElementOptoinsTreeviewNodes:GetCount() do
    --    self.PrimeUIElementOptoinsTreeviewNodes:Get(i):Unload()
    --end
    --ClearNodes(self.PrimeUIElementOptoinsTreeviewNodes)
    self.ElementListbox:ClearItems()
    self:ClearSubElementOptions()

    collectgarbage()
    collectgarbage()

    for index, data in spairs(PrimeUIData["PrimeUI"], function(t,a,b) return t[a]["Order"] < t[b]["Order"] end) do

        local removalFunction = function()
            self.currentUI["PrimeUI"][index] = nil

            local index = 1
            for key, value in spairs(self.currentUI["PrimeUI"], function(t,a,b) return t[a]["Order"] < t[b]["Order"] end) do
                self.currentUI["PrimeUI"][key]["Order"] = index
                index = index + 1
            end

            local count = tablelength(self.currentUI["PrimeUI"]) + 1
            local newTable = self:GetUIElementData(self.currentUI["Name"], count)
            table.insert(self.currentUI["PrimeUI"], newTable)
            PrimeUIHandlerObject:Refresh(self.currentUI["Name"], self.currentUI["PrimeUI"])
            self.data = PrimeUIHandlerObject:GetData()
            self.treeviewBoxes[self.currentUI["Name"]].SourceLabel:MouseClick()
        end

        local movefunction = function(up)
            local newOrder = data["Order"]
            local oldOrder = data["Order"]

            if up then
                if newOrder == 1 then return end
                newOrder = newOrder - 1
            else
                if newOrder + 1 > tablelength(self.currentUI["PrimeUI"]) then
                    return 
                end
                newOrder = newOrder + 1
            end

            data["Order"] = -1

            for key, value in spairs(self.currentUI["PrimeUI"], function(t,a,b) return t[a]["Order"] < t[b]["Order"] end) do
                if self.currentUI["PrimeUI"][key]["Order"] == newOrder then
                    self.currentUI["PrimeUI"][key]["Order"] = oldOrder
                end
            end

            for key, value in spairs(self.currentUI["PrimeUI"], function(t,a,b) return t[a]["Order"] < t[b]["Order"] end) do
                if self.currentUI["PrimeUI"][key]["Order"] == -1 then
                    self.currentUI["PrimeUI"][key]["Order"] = newOrder
                end
            end

            local count = tablelength(self.currentUI["PrimeUI"]) + 1
            local newTable = self:GetUIElementData(name, count)
            table.insert(self.currentUI["PrimeUI"], newTable)
            PrimeUIHandlerObject:Refresh(self.currentUI["Name"], self.currentUI["PrimeUI"])
            self.data = PrimeUIHandlerObject:GetData()
            self.treeviewBoxes[self.currentUI["Name"]].SourceLabel:MouseClick()
        end

        --local UINodes = self.PrimeUIElementOptoinsTreeviewNodes
        local buttonListboxNode = PrimeUITools.PrimeUIOptions.OptionsHeader(self.PrimeUIElementOptoinsTreeview:GetWidth(), 5)
        local buttonListboxNodeChildNodes = buttonListboxNode:GetChildNodes()
        --UINodes:Add(self:Border(width))
        --UINodes:Add(buttonListboxNode)

        local optionHeader = ""
        if true then 


        for key, value in spairs(data, function(t,a,b) 
            if self:SortOrder(a, t[a]) == self:SortOrder(b, t[b]) then
                return a < b
            else
                return self:SortOrder(a, t[a]) < self:SortOrder(b, t[b])
            end
        end) do
            local newOptionHeader = self.SortOrderTable[self:SortOrder(key, value)]
            if newOptionHeader and newOptionHeader ~= optionHeader then
                optionHeader = newOptionHeader
                local subLabel = self:OptionLabel(width, tostring(optionHeader))
                buttonListboxNode:AddItem(PrimeUITools.PrimeUIOptions.OptionsListBoxButton(self.PrimeUIElementOptoinsTreeview:GetWidth() / 5, 30, tostring(optionHeader), function() 
                    self:ClearSubElementOptions()
                    self:CreateElementSubOptions(width, PrimeUIData, index, newOptionHeader)
                    self:Format()
                end))
                --UINodes:Add(self:Border(width))
            end                
        end

        buttonListboxNode:AddItem(PrimeUITools.PrimeUIOptions.OptionsListBoxButton(self.PrimeUIElementOptoinsTreeview:GetWidth() / 5, 30, "Load Parameters", function()
            self:ClearSubElementOptions()
            self:CreateLoadSubOptions(width, PrimeUIData, index)
            self:Format()
        end))


    end

        --valuebar:AddItem(self:Border(width))
        --local typeHeader = self:Label(width, data["Type"], removalFunction, movefunction) 
        local typeHeader = PrimeUITools.PrimeUIOptions.UIElementHeaderControl(self.ElementListbox:GetWidth(), data["Type"], data["NickName"], removalFunction, movefunction, function(newName)
            data["NickName"] = newName
            PrimeUIHandlerObject:Refresh(name, data1)
        end, function()
            for key, value in pairs(self:GetUIElementData(data["Type"], 0)) do
                if data[key] == nil then
                    data[key] = value
                    ChatOutput("Added: " .. tostring(key))
                end
            end

            if self.currentUI then
                PrimeUIHandlerObject:Refresh(self.currentUI["Name"], self.currentUI["PrimeUI"])
                self.data = PrimeUIHandlerObject:GetData()
                self.treeviewBoxes[self.currentUI["Name"]].SourceLabel:MouseClick()
                ChatOutput("Added all missing default values to this UI Element")
            end
        end, function() self.IOWindow:View(data, "PrimeUIElement") end)
        typeHeader.MouseClick = function()
            self:SwapVisibleOptions(index)
            self:ClearSubElementOptions()

            if self.selectedUIElement ~= nil then self.selectedUIElement:Unselect()  end
            self.selectedUIElement = typeHeader
            self.selectedUIElement:Select()

            self:Format()
        end

        self.optionBoxes[index] = buttonListboxNode

        --typeHeader.buttonListboxNode = buttonListboxNode

        self.ElementListbox:AddItem(typeHeader)
    end
end

function PrimeUIOptions:ClearSubElementOptions()
    for i = 1, self.ElementSubOptoinsTreeviewNodes:GetCount() do
        local item = self.ElementSubOptoinsTreeviewNodes:Get(i)
        if item.Unload then
            item:Unload()
        end
    end

    self.ElementSubOptoinsTreeviewNodes:Clear()
end

function PrimeUIOptions:CreateElementSubOptions(width, PrimeUIData, primeIndex, optionHeader)
    local data = PrimeUIData["PrimeUI"][primeIndex]
    for key, value in spairs(data, function(t,a,b) 
        if self:SortOrder(a, t[a]) == self:SortOrder(b, t[b]) then
            return a < b
        else
            return self:SortOrder(a, t[a]) < self:SortOrder(b, t[b])
        end
    end) do
        if self.SortOrderTable[self:SortOrder(key, value)] == optionHeader then
            local testEntries = true
            local skip = false
            if (key == "Order" or key == "Type") and testEntries then
                skip = true
            elseif key == "Icon" and testEntries then --clear
                local element = PrimeUITools.PrimeUIOptions.IconInput(width, key, value, self, (function(newIcon)
                    data[key] = newIcon
                    
                    PrimeUIHandlerObject:Refresh(PrimeUIData["Name"], PrimeUIData["PrimeUI"])
                end))
                --self.ElementSubOptoinsTreeviewNodes:Add(element)
                self:InfoButton(element, width, self.optionInfoText[key])
                self.ElementSubOptoinsTreeviewNodes:Add(element)
                skip = true
            elseif key == "Slots" and testEntries then
                local element = PrimeUITools.PrimeUIOptions.CreateSkillBarQuickslotOptions(width, key, value, data["Type"], (function(effectName, newState)
                    if newState and data[key][effectName] then
                        ChatOutput("Failed to add item: Item already exists")
                        return true
                    end
                    data[key][effectName] = newState
                    
                    PrimeUIHandlerObject:Refresh(PrimeUIData["Name"], PrimeUIData["PrimeUI"])
                end), self)
                --self.ElementSubOptoinsTreeviewNodes:Add(element)
                self:InfoButton(element, width, self.optionInfoText[key])

                self.ElementSubOptoinsTreeviewNodes:Add(element)
                skip = true
            elseif key == "Event_List" and testEntries then
                local element = PrimeUITools.PrimeUIOptions.CreateSkillBarEventOptions(width, key, value, data["Type"], (function(effectName, newState)
                    if newState and data[key][effectName] then
                        ChatOutput("Failed to add item: Item already exists")
                        return true
                    end
                    data[key][effectName] = newState
                    
                    PrimeUIHandlerObject:Refresh(PrimeUIData["Name"], PrimeUIData["PrimeUI"])
                end), self)
                --self.ElementSubOptoinsTreeviewNodes:Add(element)
                self:InfoButton(element, width, self.optionInfoText[key])
                self.ElementSubOptoinsTreeviewNodes:Add(element)
                skip = true
            elseif self.listBoxCategories[key] and testEntries then
                local element = self:ListBoxInput(width, key, value, data["Type"], (function(effectName, newState)
                    if newState and data[key][effectName] then
                        ChatOutput("Failed to add item: Item already exists")
                        return true
                    end
                    data[key][effectName] = newState
                    
                    PrimeUIHandlerObject:Refresh(PrimeUIData["Name"], PrimeUIData["PrimeUI"])
                end), self)
                --self.ElementSubOptoinsTreeviewNodes:Add(element)
                self:InfoButton(element, width, self.optionInfoText[key])
                self.ElementSubOptoinsTreeviewNodes:Add(element)
            elseif self.specialListBoxCategories[key] and data.Type ~= "Code" and testEntries then
                local element = PrimeUITools.PrimeUIOptions.CreateTriggerListBoxOptions(width, key, value, data["Type"],  (function(effectName, newState)
                    if newState and data[key][effectName] then
                        ChatOutput("Failed to add item: Item already exists")
                        return true
                    end
                    data[key][effectName] = newState
                    
                    PrimeUIHandlerObject:Refresh(PrimeUIData["Name"], PrimeUIData["PrimeUI"])
                end), self)
                self:InfoButton(element, width, self.optionInfoText[key])
                self.ElementSubOptoinsTreeviewNodes:Add(element)
            elseif self.nontriggerListBox[key] and testEntries then
                local element = PrimeUITools.PrimeUIOptions.CreateSpecialListbox(width, key, value, data["Type"],  (function(effectName, newState)
                    if newState and data[key][effectName] then
                        ChatOutput("Failed to add item: Item already exists")
                        return true
                    end
                    data[key][effectName] = newState
                    
                    PrimeUIHandlerObject:Refresh(PrimeUIData["Name"], PrimeUIData["PrimeUI"])
                end), self)
                self:InfoButton(element, width, self.optionInfoText[key])
                self.ElementSubOptoinsTreeviewNodes:Add(element)
            elseif string.find(key, "Colour") and type(value) == "table" and testEntries then
                local element = self:ColourInput(width, key, value, (function(newColour, index)
                    if index then
                        data[key][index] = newColour
                    else
                        data[key] = newColour
                    end
                    
                    PrimeUIHandlerObject:Refresh(PrimeUIData["Name"], PrimeUIData["PrimeUI"])
                end))
                self:InfoButton(element, width, self.optionInfoText["Colour"])
                self.ElementSubOptoinsTreeviewNodes:Add(element)
            elseif string.find(key, "Font") and testEntries then
                local element = PrimeUITools.PrimeUIOptions.FontInput(width, key, value, (function(newFont)
                    data[key] = newFont
                    
                    PrimeUIHandlerObject:Refresh(PrimeUIData["Name"], PrimeUIData["PrimeUI"])
                end))
                --self.ElementSubOptoinsTreeviewNodes:Add(element)
                self:InfoButton(element, width, self.optionInfoText["Font"])
                self.ElementSubOptoinsTreeviewNodes:Add(element)
                skip = true
            elseif string.find(key, "Timer_Stack_Direction") and testEntries then
                local element = PrimeUITools.PrimeUIOptions.AlignmentInput(width, key, value, self.timeStackAlignments, (function(alignment)
                    data[key] = alignment
                    
                    PrimeUIHandlerObject:Refresh(PrimeUIData["Name"], PrimeUIData["PrimeUI"])
                end))
                --self.ElementSubOptoinsTreeviewNodes:Add(element)
                self:InfoButton(element, width, self.optionInfoText[key])
                self.ElementSubOptoinsTreeviewNodes:Add(element)
                skip = true
            elseif string.find(key, "Timer_Sorting") and testEntries then
                local element = PrimeUITools.PrimeUIOptions.AlignmentInput(width, key, value, self.timerGroupAlignments, (function(alignment)
                    data[key] = alignment
                    
                    PrimeUIHandlerObject:Refresh(PrimeUIData["Name"], PrimeUIData["PrimeUI"])
                end))
                --self.ElementSubOptoinsTreeviewNodes:Add(element)
                self:InfoButton(element, width, self.optionInfoText[key])
                self.ElementSubOptoinsTreeviewNodes:Add(element)
                skip = true
            elseif string.find(key, "Orientation") and testEntries then
                local element = PrimeUITools.PrimeUIOptions.AlignmentInput(width, key, value, self.listboxOrientations, (function(alignment)
                    data[key] = alignment
                    
                    PrimeUIHandlerObject:Refresh(PrimeUIData["Name"], PrimeUIData["PrimeUI"])
                end))
                --self.ElementSubOptoinsTreeviewNodes:Add(element)
                self:InfoButton(element, width, self.optionInfoText[key])
                self.ElementSubOptoinsTreeviewNodes:Add(element)
                skip = true
            elseif string.find(key, "TextAlignment") and testEntries then
                local element = PrimeUITools.PrimeUIOptions.AlignmentInput(width, key, value, self.textAlignments, (function(alignment)
                    data[key] = alignment
                    
                    PrimeUIHandlerObject:Refresh(PrimeUIData["Name"], PrimeUIData["PrimeUI"])
                end))
                --self.ElementSubOptoinsTreeviewNodes:Add(element)
                self:InfoButton(element, width, self.optionInfoText["TextAlignment"])
                self.ElementSubOptoinsTreeviewNodes:Add(element)
                skip = true
            elseif string.find(key, "Alignment") and testEntries then
                local element = PrimeUITools.PrimeUIOptions.AlignmentInput(width, key, value, self.contentAlignment, (function(alignment)
                    data[key] = alignment
                    
                    PrimeUIHandlerObject:Refresh(PrimeUIData["Name"], PrimeUIData["PrimeUI"])
                end))
                --self.ElementSubOptoinsTreeviewNodes:Add(element)
                self:InfoButton(element, width, self.optionInfoText["Alignment"])
                self.ElementSubOptoinsTreeviewNodes:Add(element)
                skip = true
            elseif IsNumber(value) and testEntries then
                local element = PrimeUITools.PrimeUIOptions.NumericalInput(width, key, value, (function(text) 
                    local number = tonumber(text)
                    if number then
                        data[key] = number
                        
                        PrimeUIHandlerObject:Refresh(PrimeUIData["Name"], PrimeUIData["PrimeUI"])
                    end
                end))
                --self.ElementSubOptoinsTreeviewNodes:Add(element)
                self:InfoButton(element, width, self.optionInfoText[key])
                self.ElementSubOptoinsTreeviewNodes:Add(element)
                skip = true
            elseif (value == true or value == false)  and testEntries then
                local element = PrimeUITools.PrimeUIOptions.BoolInput(width, key, value, (function(bool) 
                    data[key] = bool
                    
                    PrimeUIHandlerObject:Refresh(PrimeUIData["Name"], PrimeUIData["PrimeUI"])
                end))
                --self.ElementSubOptoinsTreeviewNodes:Add(element)
                self:InfoButton(element, width, self.optionInfoText[key])
                self.ElementSubOptoinsTreeviewNodes:Add(element)
                skip = true
            elseif string.find(key, "Code")  and testEntries then
                local element = PrimeUITools.PrimeUIOptions.ButtonInput(width, key, (function() 
                    self.codeWindow:View(data, function() PrimeUIHandlerObject:Refresh(PrimeUIData["Name"], PrimeUIData) end)
                end))
                element:SetText("Edit")
                self:InfoButton(element, width, self.optionInfoText[key])
                self.ElementSubOptoinsTreeviewNodes:Add(element)
                skip = true
            elseif type(value) == "string"  and testEntries then
                local element = PrimeUITools.PrimeUIOptions.StringInput(width, key, value, key == "Text", (function(text) 
                    if text then
                        data[key] = text
                        
                        PrimeUIHandlerObject:Refresh(PrimeUIData["Name"], PrimeUIData["PrimeUI"])
                    end
                end))
                --self.ElementSubOptoinsTreeviewNodes:Add(element)
                if key == "Text" and testEntries then
                    self:InfoButton(element, width, self.specialTextText[data["Type"]] or self.optionInfoText[key])
                    local elementHeight = element:GetHeight()
                    local keywordButton = Turbine.UI.Lotro.Button()
                    keywordButton:SetParent(element)
                    keywordButton:SetTop(elementHeight)
                    keywordButton:SetText("Keywords")
                    keywordButton:SetWidth(200)
                    keywordButton.Click = function()
                        local keywordWindow = self:GetKeywordWindow()
                        keywordWindow:SetVisible(true)
                        keywordWindow:SetTextbox(element.searchBar)
                    end
                    element:SetHeight(elementHeight + 20)
                else
                    self:InfoButton(element, width, self.optionInfoText[key])
                end
                self.ElementSubOptoinsTreeviewNodes:Add(element)
                skip = true
            else
                --ChatOutput("Skipped")
                --ChatOutput(key)
            end


            if not(skip) then 
                self.ElementSubOptoinsTreeviewNodes:Add(self:Border(width)) 
            end
        end
    end
end

function PrimeUIOptions:SwapVisibleOptions(key)
    self:ClearSubElementOptions()
    self.PrimeUIElementOptoinsTreeviewNodes:Clear()
    if self.optionBoxes[key] then
        self.optionBoxes[key]:Unselect()
        self.PrimeUIElementOptoinsTreeviewNodes:Add(self.optionBoxes[key])
    end
end

function PrimeUIOptions:SortOrder(key, value)
    if key == "Order" or key == "Type" then
        return 9999
    elseif key == "Slots" then
        return 70
    elseif key == "Event_List" then
        return 71
    elseif key == "Icon" then
        return 35
    elseif string.find(key, "Orientation") then
        return 60
    elseif self.nontriggerListBox[key] then
        return 55
    elseif self.specialListBoxCategories[key] then
        return 50
    elseif self.listBoxCategories[key] then
        return 50
    elseif string.find(key, "Colour") and type(value) == "table" then
        return 40
    elseif string.find(key, "Timer_Sorting") then
        return 22 
    elseif string.find(key, "Font") then
        return 24
    elseif string.find(key, "Timer_Stack_Direction") then
        return 23
    elseif string.find(key, "TextAlignment") then
        return 21
    elseif string.find(key, "Alignment") then
        return 20
    elseif IsNumber(value) then
        return 10
    elseif value == true or value == false then
        return 30
    elseif key == "Text" then
        return 1
    elseif type(value) == "string" then
        return 2
    else
        return 9999
    end
end

function PrimeUIOptions:Border(width)
    local valuebar = Turbine.UI.TreeNode()
    valuebar:SetSize(width, 9)
    valuebar:SetMouseVisible(false)
    valuebar:SetBackColorBlendMode(Turbine.UI.BlendMode.AlphaBlend)
    valuebar:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
    --valuebar:SetBackColor(Turbine.UI.Color(0.6, 0.125, 0.125, 0.125))
    valuebar:SetBackground(BackgroundHandler:GetBackground(0x4110CD4D))

    --[[
    valuebar.topBar = Turbine.UI.Control()
    valuebar.topBar:SetParent(valuebar)
    valuebar.topBar:SetSize(width, 3)
    valuebar.topBar:SetPosition(0, 0)
    valuebar.topBar:SetMouseVisible(false)
    valuebar.topBar:SetBackColorBlendMode(Turbine.UI.BlendMode.AlphaBlend)
    valuebar.topBar:SetBackColor(Turbine.UI.Color(0.6, 1, 1, 1))

    valuebar.lowBar = Turbine.UI.Control()
    valuebar.lowBar:SetParent(valuebar)
    valuebar.lowBar:SetSize(width, 3)
    valuebar.lowBar:SetPosition(0, 6)
    valuebar.lowBar:SetMouseVisible(false)
    valuebar.lowBar:SetBackColorBlendMode(Turbine.UI.BlendMode.AlphaBlend)
    valuebar.lowBar:SetBackColor(Turbine.UI.Color(0.6, 1, 1, 1))
    --]]

    

    return valuebar
end

function PrimeUIOptions:ListBoxBorder(width)
    local valuebar = Turbine.UI.TreeNode()
    valuebar:SetSize(width, 9)
    valuebar:SetMouseVisible(false)
    valuebar:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
    valuebar:SetBackColorBlendMode(Turbine.UI.BlendMode.AlphaBlend)
    valuebar:SetBackground(BackgroundHandler:GetBackground(0x4110CD4D))

    return valuebar
end

function PrimeUIOptions:OptionLabel(width, text)
    local valuebar = Turbine.UI.TreeNode()
    valuebar:SetSize(width, 0)

    valuebar.border = Turbine.UI.Control()
    valuebar.border:SetParent(valuebar)
    valuebar.border:SetSize(width, 50)
    valuebar.border:SetMouseVisible(false)
    valuebar.border:SetBackColor(Turbine.UI.Color(0, 0, 0))

    valuebar.label = Turbine.UI.Label()
    valuebar.label:SetParent(valuebar)
    valuebar.label:SetSize(width - 4, 50 - 4)
    valuebar.label:SetPosition(2, 2)
    valuebar.label:SetMouseVisible(false)
    valuebar.label:SetBackColorBlendMode(Turbine.UI.BlendMode.AlphaBlend)
    valuebar.label:SetBackColor(Turbine.UI.Color(0.8, 0.125, 0.125, 0.125))
    valuebar.label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    valuebar.label:SetFont(Turbine.UI.Lotro.Font.TrajanProBold25)
    valuebar.label:SetFontStyle(Turbine.UI.FontStyle.Outline)
    valuebar.label:SetOutlineColor(Turbine.UI.Color(0, 0, 0))
    valuebar.label:SetText(text)

    return valuebar
end

function PrimeUIOptions:ColourInput(width, text, currentValue, func)

    local valuebar = Turbine.UI.TreeNode()
    valuebar:SetSize(width, 130)
    valuebar:SetPosition(0, 0)
    valuebar:SetMouseVisible(false)
   --valuebar:SetBackColor(GetRandomColour())

    valuebar.Unload = function()
        local controlList = valuebar:GetControls()
        for i = 1, controlList:GetCount() do
            local item = controlList:Get(1)
            if item.Unload then
                item:Unload()
            end
            controlList:RemoveAt(1)
        end
    end

    valuebar.SizeChanged = function()
        local controlList = valuebar:GetControls()
        for i = 1, controlList:GetCount() do
            local item = controlList:Get(1)
            if item.SetWidth then
                item:SetWidth(valuebar:GetWidth())
            end
        end
    end

    if currentValue then
        if type(currentValue[1]) == "table" then
            for key, value in pairs(currentValue) do
                PrimeUITools.PrimeUIOptions.SingleColourOptions(valuebar, width, string.format("%s [%d]", text, key), value, func, key)
                valuebar:SetSize(width, 130 * key)
            end
            return valuebar
        else
            PrimeUITools.PrimeUIOptions.SingleColourOptions(valuebar, width, text, currentValue, func)
            return valuebar
        end
    end

    return valuebar
end

function PrimeUIOptions:ListBoxInput(width, text, currentValue, type, func)
    if type ~= "Skills" then
        return PrimeUITools.PrimeUIOptions.CreateTriggerListBox(width, text, currentValue, type, func, self)
    elseif type == "SkillLabel" and text == "Highlight_On_Effect" or type == "Skills" and text == "Highlight_On_Effect" or type == "Skills" and text == "Highlight_On_Resource" or type == "Skills" and text == "Highlight_On_Event" or type == "Skills" and text == "Highlight_When_Ready" or type == "Skills" and text == "Toggle_Visibility_On_Event" then
        return PrimeUITools.PrimeUIOptions.CreateHighlightSkillListBox(width, text, currentValue, type, func, self)
    elseif type == "Skills" and text ~= "Quickslots" then
        return PrimeUITools.PrimeUIOptions.CreateSkillListBox(width, text, currentValue, type, func, self)
    elseif type == "Skills" and text == "Quickslots" then
        return PrimeUITools.PrimeUIOptions.CreateQuickslotOptions(width, text, currentValue, type, func, self)
    end
end

function PrimeUIOptions:InfoButton(parent, width, text)
    local SelectButton = Turbine.UI.Control()
	SelectButton:SetParent(parent)
	SelectButton:SetSize(16, 16)
    --SelectButton:SetBackColor(GetRandomColour())
    SelectButton:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
    SelectButton:SetBackground(BackgroundHandler:GetBackground(0x41168DAC))
	SelectButton:SetPosition(width - 16, 5)
    SelectButton.Text = text
    SelectButton.MouseEnter = function()
        self.infoWindow:View(SelectButton.Text)
    end

    

    SelectButton.MouseLeave = function()
        self.infoWindow:SetVisible(false)
    end
end

function PrimeUIOptions:AddElement(data)
    if self.currentUI then
        local count = tablelength(self.currentUI["PrimeUI"]) + 1
        data["Order"] = count
        table.insert(self.currentUI["PrimeUI"], data)
        PrimeUIHandlerObject:Refresh(self.currentUI["Name"], self.currentUI["PrimeUI"])
        self.data = PrimeUIHandlerObject:GetData()
        self.treeviewBoxes[self.currentUI["Name"]].SourceLabel:MouseClick()
        return true
    end
end

function PrimeUIOptions:GetEffectWindow()
    if not(self.effectWindow) then self.effectWindow = ClassSpecificTools.HistoricalEffectOverview() end

    return self.effectWindow
end

function PrimeUIOptions:GetSkillWindow()
    if not(self.skillWindow) then self.skillWindow = ClassSpecificTools.SkillOverview() end

    return self.skillWindow
end

function PrimeUIOptions:GetIconWindow()
    if not(self.iconWindow) then self.iconWindow = ClassSpecificTools.IconOverview() end

    return self.iconWindow
end

function PrimeUIOptions:SkillOverview2()
    if not(self.skillCodesWindow) then self.skillCodesWindow = ClassSpecificTools.SkillOverview2() end

    return self.skillCodesWindow
end

function PrimeUIOptions:AllSkillOverview()
    if not(self.allSkillCodesWindow) then self.allSkillCodesWindow = AllSkillOverview() end

    return self.allSkillCodesWindow
end

function PrimeUIOptions:GetActionWindow()
    if not(self.actionCodeWindow) then self.actionCodeWindow = ActionWindow() end

    return self.actionCodeWindow
end

function PrimeUIOptions:GetKeywordWindow()
    if not(self.keywordWindow) then self.keywordWindow = PrimeUITextDropDown(parent, self.infoWindow) end

    return self.keywordWindow
end

function PrimeUIOptions:CreateGeneralPrimeUIOptions()
    -- PrimeUI Options treeview
    self.PrimeUIGeneralOptionsTreeviewInControl = Turbine.UI.TreeView()
    self.PrimeUIGeneralOptionsTreeviewInControl:SetParent(self.GeneralPrimeUISettingsControl)
    self.PrimeUIGeneralOptionsTreeviewInControl:SetSize(self.GeneralPrimeUISettingsControl:GetWidth() - 10, self.GeneralPrimeUISettingsControl:GetHeight())
    self.PrimeUIGeneralOptionsTreeviewInControl:SetIndentationWidth(0)

    self.PrimeUIGeneralOptionsScrollbarBackground = Turbine.UI.Control()
    self.PrimeUIGeneralOptionsScrollbarBackground:SetParent( self.GeneralPrimeUISettingsControl)
    self.PrimeUIGeneralOptionsScrollbarBackground:SetPosition( self.GeneralPrimeUISettingsControl:GetWidth() - 10, 0)
    self.PrimeUIGeneralOptionsScrollbarBackground:SetSize( 10,self.GeneralPrimeUISettingsControl:GetHeight())
    self.PrimeUIGeneralOptionsScrollbarBackground:SetBackColor(Turbine.UI.Color.Black)

    self.PrimeUIGeneralOptionsScrollbar = Turbine.UI.Lotro.ScrollBar()
    self.PrimeUIGeneralOptionsScrollbar:SetOrientation( Turbine.UI.Orientation.Vertical)
    self.PrimeUIGeneralOptionsScrollbar:SetParent( self.GeneralPrimeUISettingsControl)
    self.PrimeUIGeneralOptionsScrollbar:SetPosition( self.GeneralPrimeUISettingsControl:GetWidth() - 10, 0)
    self.PrimeUIGeneralOptionsScrollbar:SetSize( 10,self.GeneralPrimeUISettingsControl:GetHeight())
    self.PrimeUIGeneralOptionsScrollbar:SetBackColor(Turbine.UI.Color.Black)
    self.PrimeUIGeneralOptionsTreeviewInControl:SetVerticalScrollBar( self.PrimeUIGeneralOptionsScrollbar)

    self.PrimeUIGeneralOptionsTreeNodesInControl = self.PrimeUIGeneralOptionsTreeviewInControl:GetNodes()

    self.authorNode = PrimeUITools.PrimeUIOptions.HeaderNode(self.GeneralPrimeUISettingsControl:GetWidth() - 10, "")
    self.PrimeUIGeneralOptionsTreeNodesInControl:Add(self.authorNode)

    self.PrimeUIGeneralOptionsTreeNodesInControl:Add(PrimeUITools.PrimeUIOptions.HeaderNode(self.GeneralPrimeUISettingsControl:GetWidth() - 10, "Loading Parameters"))

    -- Class load
    self.classNode = PrimeUITools.PrimeUIOptions.HeaderNode(self.GeneralPrimeUISettingsControl:GetWidth() - 10, "> Load for specific classes", nil, Turbine.UI.Lotro.Font.BookAntiquaBold19, self.optionExpandBackgroundColour)

    self.childClassNode =  self.classNode:GetChildNodes()

    self.PrimeUIGeneralOptionsTreeNodesInControl:Add(self.classNode)

    self.classLoadNodes = {}

    self.classLoadNodes["All"] = PrimeUITools.PrimeUIOptions.BoolInput(self.GeneralPrimeUISettingsControl:GetWidth() - 10, "All", false, function(value)
        if self.currentUI and self.notChanging then
            if not(self.currentUI["ClassLoad"]) then self.currentUI["ClassLoad"] = {} end
            self.currentUI["ClassLoad"]["All"] = value
            PrimeUIHandlerObject:ChangeUIMetaData(self.currentUI)
        end
    end, self.minorOptionBackgroundColour)
    self.childClassNode:Add(self.classLoadNodes["All"])

    for key, _ in spairs(self.Classes, function(t, a, b) return a < b end) do
        self.classLoadNodes[key] = PrimeUITools.PrimeUIOptions.BoolInput(self.GeneralPrimeUISettingsControl:GetWidth() - 10, key, false, function(value)
            if self.currentUI and self.notChanging then
                if not(self.currentUI["ClassLoad"]) then self.currentUI["ClassLoad"] = {} end
                self.currentUI["ClassLoad"][key] = value
                PrimeUIHandlerObject:ChangeUIMetaData(self.currentUI)
            end
        end, self.minorOptionBackgroundColour)
        self.childClassNode:Add(self.classLoadNodes[key])
    end

    self.PrimeUIGeneralOptionsTreeNodesInControl:Add(PrimeUITools.PrimeUIOptions.HeaderNode(self.GeneralPrimeUISettingsControl:GetWidth() - 10, "Instances"))

    --Instance
    self.AnyInstanceToggle = PrimeUITools.PrimeUIOptions.BoolInput(self.GeneralPrimeUISettingsControl:GetWidth() - 10, "Only load in all instances", true, function(value)
        if self.currentUI and self.notChanging then
            self.currentUI["AnyInstance"] = value
            PrimeUIHandlerObject:ChangeUIMetaData(self.currentUI)
        end
    end)

    self.PrimeUIGeneralOptionsTreeNodesInControl:Add(self.AnyInstanceToggle)

    self.instanceNode = PrimeUITools.PrimeUIOptions.HeaderNode(self.GeneralPrimeUISettingsControl:GetWidth() - 10, "> Load for specific instances", nil, Turbine.UI.Lotro.Font.BookAntiquaBold19, self.optionExpandBackgroundColour)

    self.childInstanceNode =  self.instanceNode:GetChildNodes()

    self.PrimeUIGeneralOptionsTreeNodesInControl:Add(self.instanceNode)

    self.instanceLoadNodes = {}

    for _, key in spairs(InstanceController:GetDungeonNameTable(), function(t, a, b) return a < b end) do
        self.instanceLoadNodes[key] = PrimeUITools.PrimeUIOptions.BoolInput(self.GeneralPrimeUISettingsControl:GetWidth() - 10, key, false, function(value)
            if self.currentUI and self.notChanging then
                if not(self.currentUI["InstanceLoad"]) then self.currentUI["InstanceLoad"] = {} end
                self.currentUI["InstanceLoad"][key] = value
                PrimeUIHandlerObject:ChangeUIMetaData(self.currentUI)
            end
        end, self.minorOptionBackgroundColour)
        self.childInstanceNode:Add(self.instanceLoadNodes[key])
    end

    self.AllTierCheckbox = PrimeUITools.PrimeUIOptions.BoolInput(self.GeneralPrimeUISettingsControl:GetWidth() - 10, "All Tiers", false, function(value)
        if self.currentUI and self.notChanging then
            self.currentUI["AllTiers"] = value
            PrimeUIHandlerObject:ChangeUIMetaData(self.currentUI)
        end
    end)

    self.PrimeUIGeneralOptionsTreeNodesInControl:Add(self.AllTierCheckbox)

    self.instanceTierNode = PrimeUITools.PrimeUIOptions.HeaderNode(self.GeneralPrimeUISettingsControl:GetWidth() - 10, "> Load for specific tiers", nil, Turbine.UI.Lotro.Font.BookAntiquaBold19, self.optionExpandBackgroundColour)

    self.childInstanceTierNode =  self.instanceTierNode:GetChildNodes()

    self.PrimeUIGeneralOptionsTreeNodesInControl:Add(self.instanceTierNode)

    self.instanceTierNodes = {}

    for i = 1, 14 do
        self.instanceTierNodes[i] = PrimeUITools.PrimeUIOptions.BoolInput(self.GeneralPrimeUISettingsControl:GetWidth() - 10, i, false, function(value)
            if self.currentUI and self.notChanging then
                if not(self.currentUI["InstanceTier"]) then self.currentUI["InstanceTier"] = {} end
                self.currentUI["InstanceTier"][i] = value
                PrimeUIHandlerObject:ChangeUIMetaData(self.currentUI)
            end
        end, self.minorOptionBackgroundColour)
        self.childInstanceTierNode:Add(self.instanceTierNodes[i])
    end

    self.PrimeUIGeneralOptionsTreeNodesInControl:Add(self.instanceTierNode)

    -- Delvings
    self.AnyDelvingToggle = PrimeUITools.PrimeUIOptions.BoolInput(self.GeneralPrimeUISettingsControl:GetWidth() - 10, "Only load in all delvings", true, function(value)
        if self.currentUI and self.notChanging then
            self.currentUI["OnlyAllDelvings"] = value
            PrimeUIHandlerObject:ChangeUIMetaData(self.currentUI)
        end
    end)

    self.PrimeUIGeneralOptionsTreeNodesInControl:Add(self.AnyDelvingToggle)

    self.DelvingMenu = UI.DropDownMenuControl(self, 200, "Delving Dropdown Menu")
    for key, value in spairs(InstanceController:GetDelvingTable(), function(t, a, b) return t[a] < t[b] end) do
        --local menuItem = Turbine.UI.MenuItem( value )
        self.DelvingMenu:AddItem(value, 
        function()
            self.DelvingButton:SetText(value)
            self.currentUI["Delving"] = value
            PrimeUIHandlerObject:ChangeUIMetaData(self.currentUI)
            self.DelvingMenu:SetVisible(false)
        end)
    end


    self.DelvingButton = PrimeUITools.PrimeUIOptions.ButtonInput(self.GeneralPrimeUISettingsControl:GetWidth()- 10, "Delving:", function()
        if self.currentUI then
            self.DelvingMenu:ToggleVisible()
        end
    end)

    self.PrimeUIGeneralOptionsTreeNodesInControl:Add(self.DelvingButton)

    self.AllDelvingTierCheckbox = PrimeUITools.PrimeUIOptions.BoolInput(self.GeneralPrimeUISettingsControl:GetWidth() - 10, "All Delving Tiers", false, function(value)
        if self.currentUI and self.notChanging then
            self.currentUI["All_Delving_Tiers"] = value
            PrimeUIHandlerObject:ChangeUIMetaData(self.currentUI)
        end
    end)

    self.PrimeUIGeneralOptionsTreeNodesInControl:Add(self.AllDelvingTierCheckbox)

    self.DelvingTierMenu = UI.DropDownMenuControl(self, 200, "Delving Tier Menu Dropdown Menu")
    for i = 1, 14 do
        --local menuItem = Turbine.UI.MenuItem( value )
        self.DelvingTierMenu:AddItem(i, 
        function()
            self.DelvingTierButton:SetText(i)
            self.currentUI["Delving_Tier"] = tostring(i)
            PrimeUIHandlerObject:ChangeUIMetaData(self.currentUI)
            self.DelvingTierMenu:SetVisible(false)
        end)
    end

    self.DelvingTierButton = PrimeUITools.PrimeUIOptions.ButtonInput(self.GeneralPrimeUISettingsControl:GetWidth()- 10, "Delving Tier:", function()
        if self.currentUI then
            self.DelvingTierMenu:ToggleVisible()
        end
    end)

    self.PrimeUIGeneralOptionsTreeNodesInControl:Add(self.DelvingTierButton)

    -- Pvp
    self.PvPCheckbox = PrimeUITools.PrimeUIOptions.BoolInput(self.GeneralPrimeUISettingsControl:GetWidth() - 10, "Only load in PvP", false, function(value)
        if self.currentUI and self.notChanging then
            self.currentUI["OnlyPvP"] = value
            PrimeUIHandlerObject:ChangeUIMetaData(self.currentUI)
        end
    end)

    self.PrimeUIGeneralOptionsTreeNodesInControl:Add(self.PvPCheckbox)

    -- role
    self.roleNode = PrimeUITools.PrimeUIOptions.HeaderNode(self.GeneralPrimeUISettingsControl:GetWidth() - 10, "> Load for specific role(s)", nil, Turbine.UI.Lotro.Font.BookAntiquaBold19, self.optionExpandBackgroundColour)

    self.roleClassNode =  self.roleNode:GetChildNodes()

    self.PrimeUIGeneralOptionsTreeNodesInControl:Add(self.roleNode)

    self.roleLoadNodes = {}

    for key, _ in spairs(self.roles, function(t, a, b) return a < b end) do
        self.roleLoadNodes[key] = PrimeUITools.PrimeUIOptions.BoolInput(self.GeneralPrimeUISettingsControl:GetWidth() - 10, key, false, function(value)
            if self.currentUI and self.notChanging then
                if not(self.currentUI["RoleLoad"]) then self.currentUI["RoleLoad"] = {} end
                self.currentUI["RoleLoad"][key] = value
                PrimeUIHandlerObject:ChangeUIMetaData(self.currentUI)
            end
        end, self.minorOptionBackgroundColour)
        self.roleClassNode:Add(self.roleLoadNodes[key])
    end

    --Line
    self.lineNode = PrimeUITools.PrimeUIOptions.HeaderNode(self.GeneralPrimeUISettingsControl:GetWidth() - 10, "> Load for specific line(s)", nil, Turbine.UI.Lotro.Font.BookAntiquaBold19, self.optionExpandBackgroundColour)

    self.lineClassNode =  self.lineNode:GetChildNodes()

    self.PrimeUIGeneralOptionsTreeNodesInControl:Add(self.lineNode)

    self.lineLoadNodes = {}

    self.lineLoadNodes["All"] = PrimeUITools.PrimeUIOptions.BoolInput(self.GeneralPrimeUISettingsControl:GetWidth() - 10, "All", false, function(value)
        if self.currentUI and self.notChanging then
            if not(self.currentUI["LineLoad"]) then self.currentUI["LineLoad"] = {} end
            self.currentUI["LineLoad"]["All"] = value
            PrimeUIHandlerObject:ChangeUIMetaData(self.currentUI)
        end
    end, self.minorOptionBackgroundColour)
    self.lineClassNode:Add(self.lineLoadNodes["All"])

    self.lineLoadNodes["Blue"] = PrimeUITools.PrimeUIOptions.BoolInput(self.GeneralPrimeUISettingsControl:GetWidth() - 10, "Blue", false, function(value)
        if self.currentUI and self.notChanging then
            if not(self.currentUI["LineLoad"]) then self.currentUI["LineLoad"] = {} end
            self.currentUI["LineLoad"]["Blue"] = value
            PrimeUIHandlerObject:ChangeUIMetaData(self.currentUI)
        end
    end, self.minorOptionBackgroundColour)
    self.lineClassNode:Add(self.lineLoadNodes["Blue"])

    self.lineLoadNodes["Red"] = PrimeUITools.PrimeUIOptions.BoolInput(self.GeneralPrimeUISettingsControl:GetWidth() - 10, "Red", false, function(value)
        if self.currentUI and self.notChanging then
            if not(self.currentUI["LineLoad"]) then self.currentUI["LineLoad"] = {} end
            self.currentUI["LineLoad"]["Red"] = value
            PrimeUIHandlerObject:ChangeUIMetaData(self.currentUI)
        end
    end, self.minorOptionBackgroundColour)
    self.lineClassNode:Add(self.lineLoadNodes["Red"])

    self.lineLoadNodes["Yellow"] = PrimeUITools.PrimeUIOptions.BoolInput(self.GeneralPrimeUISettingsControl:GetWidth() - 10, "Yellow", false, function(value)
        if self.currentUI and self.notChanging then
            if not(self.currentUI["LineLoad"]) then self.currentUI["LineLoad"] = {} end
            self.currentUI["LineLoad"]["Yellow"] = value
            PrimeUIHandlerObject:ChangeUIMetaData(self.currentUI)
        end
    end, self.minorOptionBackgroundColour)
    self.lineClassNode:Add(self.lineLoadNodes["Yellow"])

    self.PrimeUIGeneralOptionsTreeNodesInControl:Add(PrimeUITools.PrimeUIOptions.HeaderNode(self.GeneralPrimeUISettingsControl:GetWidth() - 10, "Misc Settings"))

    -- Never load
    self.NeverLoadCheckbox = PrimeUITools.PrimeUIOptions.BoolInput(self.GeneralPrimeUISettingsControl:GetWidth() - 10, "Never Load", false, function(value)
        if self.currentUI and self.notChanging then
            self.currentUI["NeverLoad"] = value
            PrimeUIHandlerObject:ChangeUIMetaData(self.currentUI)
        end
    end)

    self.PrimeUIGeneralOptionsTreeNodesInControl:Add(self.NeverLoadCheckbox)

    -- Show in combat
    self.ICheckBox = PrimeUITools.PrimeUIOptions.BoolInput(self.GeneralPrimeUISettingsControl:GetWidth() - 10, "Show in combat", true, function(value)
        if self.currentUI and self.notChanging then
            self.currentUI["ICLoad"] = value
            PrimeUIHandlerObject:ChangeUIMetaData(self.currentUI)
        end
    end)

    self.PrimeUIGeneralOptionsTreeNodesInControl:Add(self.ICheckBox)


    -- Show out of combat
    self.OOCheckBox = PrimeUITools.PrimeUIOptions.BoolInput(self.GeneralPrimeUISettingsControl:GetWidth() - 10, "Show out of combat", true, function(value)
        if self.currentUI and self.notChanging then
            self.currentUI["OOCLoad"] =  value
            PrimeUIHandlerObject:ChangeUIMetaData(self.currentUI)
        end
    end)

    self.PrimeUIGeneralOptionsTreeNodesInControl:Add(self.OOCheckBox)

    -- Character load
    self.CharacterButton = PrimeUITools.PrimeUIOptions.BoolInput(self.GeneralPrimeUISettingsControl:GetWidth() - 10, "Load on all characters", true, function(value)
        if self.currentUI and self.notChanging then
            self.currentUI["CharLoad"] = not(value)
            PrimeUIHandlerObject:ChangeUIMetaData(self.currentUI)
        end
    end)

    self.PrimeUIGeneralOptionsTreeNodesInControl:Add(self.CharacterButton)

    self.characterNode = PrimeUITools.PrimeUIOptions.HeaderNode(self.GeneralPrimeUISettingsControl:GetWidth() - 10, "> Load for specific character(s)", nil, Turbine.UI.Lotro.Font.BookAntiquaBold19, self.optionExpandBackgroundColour)

    self.childCharacterNodes =  self.characterNode:GetChildNodes()

    self.PrimeUIGeneralOptionsTreeNodesInControl:Add(self.characterNode)

    self.characterLoadNodes = {}

    for key, _ in spairs(Profiles:GetPreferences(), function(t, a, b) return a < b end) do
        self.characterLoadNodes[key] = PrimeUITools.PrimeUIOptions.BoolInput(self.GeneralPrimeUISettingsControl:GetWidth() - 10, key, false, function(value)
            if self.currentUI and self.notChanging then
                if not(self.currentUI["CharacterLoad"]) then self.currentUI["CharacterLoad"] = {} end
                self.currentUI["CharacterLoad"][key] = value
                PrimeUIHandlerObject:ChangeUIMetaData(self.currentUI)
            end
        end, self.minorOptionBackgroundColour)
        self.childCharacterNodes:Add(self.characterLoadNodes[key])
    end

    self.PrimeUIGeneralOptionsTreeNodesInControl:Add(PrimeUITools.PrimeUIOptions.HeaderNode(self.GeneralPrimeUISettingsControl:GetWidth() - 10, "Advanced Settings"))

    -- Advanced mode toggle
    self.AdvancedCheckbox = PrimeUITools.PrimeUIOptions.BoolInput(self.GeneralPrimeUISettingsControl:GetWidth(), "Advanced mode", false, function(value)
        if self.currentUI and self.notChanging then
            local neverloadValue = self.currentUI["NeverLoad"]
            self.currentUI["AdvancedMode"] = value
            self.currentUI["NeverLoad"] = true
            PrimeUIHandlerObject:ChangeUIMetaData(self.currentUI)
            self.currentUI["NeverLoad"] = neverloadValue
            PrimeUIHandlerObject:ChangeUIMetaData(self.currentUI)
        end
    end)

    self.PrimeUIGeneralOptionsTreeNodesInControl:Add(self.AdvancedCheckbox)

    -- Anchor settings
    self.AnchorX = PrimeUITools.PrimeUIOptions.NumericalInput(self.GeneralPrimeUISettingsControl:GetWidth(), "Anchor X", 0, function(value)
        if self.currentUI and self.notChanging then
            local neverloadValue = self.currentUI["NeverLoad"]
            self.currentUI["Anchor_Advanced_X"] = value
            self.currentUI["NeverLoad"] = true
            PrimeUIHandlerObject:ChangeUIMetaData(self.currentUI)
            self.currentUI["NeverLoad"] = neverloadValue
            PrimeUIHandlerObject:ChangeUIMetaData(self.currentUI)
        end
    end)

    self.PrimeUIGeneralOptionsTreeNodesInControl:Add(self.AnchorX)

    self.AnchorY = PrimeUITools.PrimeUIOptions.NumericalInput(self.GeneralPrimeUISettingsControl:GetWidth(), "Anchor Y", 0, function(value)
        if self.currentUI and self.notChanging then
            local neverloadValue = self.currentUI["NeverLoad"]
            self.currentUI["Anchor_Advanced_Y"] = value
            self.currentUI["NeverLoad"] = true
            PrimeUIHandlerObject:ChangeUIMetaData(self.currentUI)
            self.currentUI["NeverLoad"] = neverloadValue
            PrimeUIHandlerObject:ChangeUIMetaData(self.currentUI)
        end
    end)

    self.PrimeUIGeneralOptionsTreeNodesInControl:Add(self.AnchorY)

    self.PrimeUINameChangeInput = PrimeUITools.PrimeUIOptions.StringButtonInputSmall(self.GeneralPrimeUISettingsControl:GetWidth(), "PrimeUI Name", "", function(value)
        if self.currentUI and self.notChanging then
            if PrimeUIHandlerObject:DoesNameExist(value) then
                ThrowException(string.format("Renaming Failed: Name (%s) already exists", tostring(value)))
            else
                self.currentUI["Name"] = value
                PrimeUIHandlerObject:ChangeUIMetaData(self.currentUI)
                ReloadPlugin(true)
            end
        end
    end)

    self.PrimeUIGeneralOptionsTreeNodesInControl:Add(self.PrimeUINameChangeInput)

    


end

function PrimeUIOptions:CreateLoadSubOptions(width, PrimeUIData, primeIndex)

    if PrimeUIData["PrimeUI"][primeIndex]["Load Parameters"] == nil then
        PrimeUIData["PrimeUI"][primeIndex]["Load Parameters"] = {}
    end

    local data = PrimeUIData["PrimeUI"][primeIndex]["Load Parameters"]

    if nil == data["Version"] then data["Version"] = PrimeUIHandlerObject.PRIMEUI_VERSION end
    if nil == data["InstanceLoad"] then data["InstanceLoad"] = {["All"] = true} end
    if nil == data["AnyInstance"] then data["AnyInstance"] = false end
    if nil == data["RoleLoad"] then data["RoleLoad"] = {["All"] = true} end
    if nil == data["ClassLoad"] then data["ClassLoad"] = {["All"] = true} end
    if nil == data["CharLoad"] then data["CharLoad"] = false end
    if nil == data["ZoneLoad"] then data["ZoneLoad"] = false end
    if nil == data["GroupLoad"] then data["GroupLoad"] = false end
    if nil == data["CharacterLoad"] then data["CharacterLoad"] = {} end
    if nil == data["LineLoad"] then data["LineLoad"] = {["All"] = true} end
    if nil == data["ICLoad"] then data["ICLoad"] = true end
    if nil == data["OOCLoad"] then data["OOCLoad"] = true end
    if nil == data["NeverLoad"] then data["NeverLoad"] = false end
    if nil == data["OnlyPvP"] then data["OnlyPvP"] = false end
    if nil == data["OnlyAllDelvings"] then data["OnlyAllDelvings"] = false end
    if nil == data["Delving"] then data["Delving"] = "All" end
    if nil == data["Delving_Tier"] then data["Delving_Tier"] = 1 end
    if nil == data["All_Delving_Tiers"] then data["All_Delving_Tiers"] = true end

    PrimeUIHandlerObject:UpdateData(data)

    self.ElementSubOptoinsTreeviewNodes:Add(PrimeUITools.PrimeUIOptions.HeaderNode(width - 10, "Loading Parameters"))

    -- Class load
    self.classNode = PrimeUITools.PrimeUIOptions.HeaderNode(width - 10, "> Load for specific classes", nil, Turbine.UI.Lotro.Font.BookAntiquaBold19, self.optionExpandBackgroundColour)

    self.childClassNode =  self.classNode:GetChildNodes()

    self.ElementSubOptoinsTreeviewNodes:Add(self.classNode)

    self.classLoadNodes = {}

    self.classLoadNodes["All"] = PrimeUITools.PrimeUIOptions.BoolInput(width - 10, "All", data["ClassLoad"]["All"], function(value)
        if data and self.notChanging then
            if not(data["ClassLoad"]) then data["ClassLoad"] = {} end
            data["ClassLoad"]["All"] = value
            PrimeUIHandlerObject:Refresh(PrimeUIData["Name"], PrimeUIData["PrimeUI"])
        end
    end, self.minorOptionBackgroundColour)
    self.childClassNode:Add(self.classLoadNodes["All"])

    for key, _ in spairs(self.Classes, function(t, a, b) return a < b end) do
        self.classLoadNodes[key] = PrimeUITools.PrimeUIOptions.BoolInput(width - 10, key, data["ClassLoad"][key], function(value)
            if data and self.notChanging then
                if not(data["ClassLoad"]) then data["ClassLoad"] = {} end
                data["ClassLoad"][key] = value
                PrimeUIHandlerObject:Refresh(PrimeUIData["Name"], PrimeUIData["PrimeUI"])
            end
        end, self.minorOptionBackgroundColour)
        self.childClassNode:Add(self.classLoadNodes[key])
    end

    self.ElementSubOptoinsTreeviewNodes:Add(PrimeUITools.PrimeUIOptions.HeaderNode(width - 10, "Instances"))

    --Instance
    self.AnyInstanceToggle = PrimeUITools.PrimeUIOptions.BoolInput(width - 10, "Only load in all instances", data["AnyInstance"], function(value)
        if data and self.notChanging then
            data["AnyInstance"] = value
            PrimeUIHandlerObject:Refresh(PrimeUIData["Name"], PrimeUIData["PrimeUI"])
        end
    end)

    self.ElementSubOptoinsTreeviewNodes:Add(self.AnyInstanceToggle)

    self.instanceNode = PrimeUITools.PrimeUIOptions.HeaderNode(width - 10, "> Load for specific instances", nil, Turbine.UI.Lotro.Font.BookAntiquaBold19, self.optionExpandBackgroundColour)

    self.childInstanceNode =  self.instanceNode:GetChildNodes()

    self.ElementSubOptoinsTreeviewNodes:Add(self.instanceNode)

    self.instanceLoadNodes = {}

    for _, key in spairs(InstanceController:GetDungeonNameTable(), function(t, a, b) return a < b end) do
        self.instanceLoadNodes[key] = PrimeUITools.PrimeUIOptions.BoolInput(width - 10, key, data["InstanceLoad"][key], function(value)
            if data and self.notChanging then
                if not(data["InstanceLoad"]) then data["InstanceLoad"] = {} end
                data["InstanceLoad"][key] = value
                PrimeUIHandlerObject:Refresh(PrimeUIData["Name"], PrimeUIData["PrimeUI"])
            end
        end, self.minorOptionBackgroundColour)
        self.childInstanceNode:Add(self.instanceLoadNodes[key])
    end

    self.AllTierCheckbox = PrimeUITools.PrimeUIOptions.BoolInput(width - 10, "All Tiers", data["AllTiers"], function(value)
        if data and self.notChanging then
            data["AllTiers"] = value
            PrimeUIHandlerObject:Refresh(PrimeUIData["Name"], PrimeUIData["PrimeUI"])
        end
    end)

    self.ElementSubOptoinsTreeviewNodes:Add(self.AllTierCheckbox)

    self.instanceTierNode = PrimeUITools.PrimeUIOptions.HeaderNode(width - 10, "> Load for specific tiers", nil, Turbine.UI.Lotro.Font.BookAntiquaBold19, self.optionExpandBackgroundColour)

    self.childInstanceTierNode =  self.instanceTierNode:GetChildNodes()

    self.ElementSubOptoinsTreeviewNodes:Add(self.instanceTierNode)

    self.instanceTierNodes = {}

    for i = 1, 14 do
        self.instanceTierNodes[i] = PrimeUITools.PrimeUIOptions.BoolInput(width - 10, i, data["InstanceTier"][i], function(value)
            if data and self.notChanging then
                if not(data["InstanceTier"]) then data["InstanceTier"] = {} end
                data["InstanceTier"][i] = value
                PrimeUIHandlerObject:Refresh(PrimeUIData["Name"], PrimeUIData["PrimeUI"])
            end
        end, self.minorOptionBackgroundColour)
        self.childInstanceTierNode:Add(self.instanceTierNodes[i])
    end

    self.ElementSubOptoinsTreeviewNodes:Add(self.instanceTierNode)

    -- Delvings
    self.AnyDelvingToggle = PrimeUITools.PrimeUIOptions.BoolInput(width - 10, "Only load in all delvings", data["OnlyAllDelvings"], function(value)
        if data and self.notChanging then
            data["OnlyAllDelvings"] = value
            PrimeUIHandlerObject:Refresh(PrimeUIData["Name"], PrimeUIData["PrimeUI"])
        end
    end)

    self.ElementSubOptoinsTreeviewNodes:Add(self.AnyDelvingToggle)

    --[[
    self.DelvingMenu = UI.DropDownMenuControl(self, 200, "Delving Dropdown Menu")
    for key, value in spairs(InstanceController:GetDelvingTable(), function(t, a, b) return t[a] < t[b] end) do
        --local menuItem = Turbine.UI.MenuItem( value )
        self.DelvingMenu:AddItem(value, 
        function()
            self.DelvingButton:SetText(value)
            data["Delving"] = value
            PrimeUIHandlerObject:Refresh(PrimeUIData["Name"], PrimeUIData["PrimeUI"])
            self.DelvingMenu:SetVisible(false)
        end)
    end


    self.DelvingButton = PrimeUITools.PrimeUIOptions.ButtonInput(width- 10, "Delving:", function()
        if data then
            self.DelvingMenu:ToggleVisible()
        end
    end)

    self.ElementSubOptoinsTreeviewNodes:Add(self.DelvingButton)

    self.AllDelvingTierCheckbox = PrimeUITools.PrimeUIOptions.BoolInput(width - 10, "All Delving Tiers", data["All_Delving_Tiers"], function(value)
        if data and self.notChanging then
            data["All_Delving_Tiers"] = value
            PrimeUIHandlerObject:Refresh(PrimeUIData["Name"], PrimeUIData["PrimeUI"])
        end
    end)

    self.ElementSubOptoinsTreeviewNodes:Add(self.AllDelvingTierCheckbox)

    self.DelvingTierMenu = UI.DropDownMenuControl(self, 200, "Delving Tier Menu Dropdown Menu")
    for i = 1, 14 do
        --local menuItem = Turbine.UI.MenuItem( value )
        self.DelvingTierMenu:AddItem(i, 
        function()
            self.DelvingTierButton:SetText(i)
            data["Delving_Tier"] = tostring(i)
            PrimeUIHandlerObject:Refresh(PrimeUIData["Name"], PrimeUIData["PrimeUI"])
            self.DelvingTierMenu:SetVisible(false)
        end)
    end

    self.DelvingTierButton = PrimeUITools.PrimeUIOptions.ButtonInput(width- 10, "Delving Tier:", function()
        if data then
            self.DelvingTierMenu:ToggleVisible()
        end
    end)

    self.ElementSubOptoinsTreeviewNodes:Add(self.DelvingTierButton)
    --]]

    -- Pvp
    self.PvPCheckbox = PrimeUITools.PrimeUIOptions.BoolInput(width - 10, "Only load in PvP", data["OnlyPvP"], function(value)
        if data and self.notChanging then
            data["OnlyPvP"] = value
            PrimeUIHandlerObject:Refresh(PrimeUIData["Name"], PrimeUIData["PrimeUI"])
        end
    end)

    self.ElementSubOptoinsTreeviewNodes:Add(self.PvPCheckbox)

    -- role
    self.roleNode = PrimeUITools.PrimeUIOptions.HeaderNode(width - 10, "> Load for specific role(s)", nil, Turbine.UI.Lotro.Font.BookAntiquaBold19, self.optionExpandBackgroundColour)

    self.roleClassNode =  self.roleNode:GetChildNodes()

    self.ElementSubOptoinsTreeviewNodes:Add(self.roleNode)

    self.roleLoadNodes = {}

    for key, _ in spairs(self.roles, function(t, a, b) return a < b end) do
        self.roleLoadNodes[key] = PrimeUITools.PrimeUIOptions.BoolInput(width - 10, key, data["RoleLoad"][key], function(value)
            if data and self.notChanging then
                if not(data["RoleLoad"]) then data["RoleLoad"] = {} end
                data["RoleLoad"][key] = value
                PrimeUIHandlerObject:Refresh(PrimeUIData["Name"], PrimeUIData["PrimeUI"])
            end
        end, self.minorOptionBackgroundColour)
        self.roleClassNode:Add(self.roleLoadNodes[key])
    end

    --Line
    self.lineNode = PrimeUITools.PrimeUIOptions.HeaderNode(width - 10, "> Load for specific line(s)", nil, Turbine.UI.Lotro.Font.BookAntiquaBold19, self.optionExpandBackgroundColour)

    self.lineClassNode =  self.lineNode:GetChildNodes()

    self.ElementSubOptoinsTreeviewNodes:Add(self.lineNode)

    self.lineLoadNodes = {}

    self.lineLoadNodes["All"] = PrimeUITools.PrimeUIOptions.BoolInput(width - 10, "All", data["LineLoad"]["All"], function(value)
        if data and self.notChanging then
            if not(data["LineLoad"]) then data["LineLoad"] = {} end
            data["LineLoad"]["All"] = value
            PrimeUIHandlerObject:Refresh(PrimeUIData["Name"], PrimeUIData["PrimeUI"])
        end
    end, self.minorOptionBackgroundColour)
    self.lineClassNode:Add(self.lineLoadNodes["All"])

    self.lineLoadNodes["Blue"] = PrimeUITools.PrimeUIOptions.BoolInput(width - 10, "Blue", data["LineLoad"]["Blue"], function(value)
        if data and self.notChanging then
            if not(data["LineLoad"]) then data["LineLoad"] = {} end
            data["LineLoad"]["Blue"] = value
            PrimeUIHandlerObject:Refresh(PrimeUIData["Name"], PrimeUIData["PrimeUI"])
        end
    end, self.minorOptionBackgroundColour)
    self.lineClassNode:Add(self.lineLoadNodes["Blue"])

    self.lineLoadNodes["Red"] = PrimeUITools.PrimeUIOptions.BoolInput(width - 10, "Red", data["LineLoad"]["Red"], function(value)
        if data and self.notChanging then
            if not(data["LineLoad"]) then data["LineLoad"] = {} end
            data["LineLoad"]["Red"] = value
            PrimeUIHandlerObject:Refresh(PrimeUIData["Name"], PrimeUIData["PrimeUI"])
        end
    end, self.minorOptionBackgroundColour)
    self.lineClassNode:Add(self.lineLoadNodes["Red"])

    self.lineLoadNodes["Yellow"] = PrimeUITools.PrimeUIOptions.BoolInput(width - 10, "Yellow", data["LineLoad"]["Yellow"], function(value)
        if data and self.notChanging then
            if not(data["LineLoad"]) then data["LineLoad"] = {} end
            data["LineLoad"]["Yellow"] = value
            PrimeUIHandlerObject:Refresh(PrimeUIData["Name"], PrimeUIData["PrimeUI"])
        end
    end, self.minorOptionBackgroundColour)
    self.lineClassNode:Add(self.lineLoadNodes["Yellow"])

    self.ElementSubOptoinsTreeviewNodes:Add(PrimeUITools.PrimeUIOptions.HeaderNode(width - 10, "Misc Settings"))

    -- Never load
    self.NeverLoadCheckbox = PrimeUITools.PrimeUIOptions.BoolInput(width - 10, "Never Load", data["NeverLoad"], function(value)
        if data and self.notChanging then
            data["NeverLoad"] = value
            PrimeUIHandlerObject:Refresh(PrimeUIData["Name"], PrimeUIData["PrimeUI"])
        end
    end)

    self.ElementSubOptoinsTreeviewNodes:Add(self.NeverLoadCheckbox)

    -- Show in combat
    self.ICheckBox = PrimeUITools.PrimeUIOptions.BoolInput(width - 10, "Show in combat", data["ICLoad"], function(value)
        if data and self.notChanging then
            data["ICLoad"] = value
            PrimeUIHandlerObject:Refresh(PrimeUIData["Name"], PrimeUIData["PrimeUI"])
        end
    end)

    self.ElementSubOptoinsTreeviewNodes:Add(self.ICheckBox)


    -- Show out of combat
    self.OOCheckBox = PrimeUITools.PrimeUIOptions.BoolInput(width - 10, "Show out of combat", data["OOCLoad"], function(value)
        if data and self.notChanging then
            data["OOCLoad"] =  value
            PrimeUIHandlerObject:Refresh(PrimeUIData["Name"], PrimeUIData["PrimeUI"])
        end
    end)

    self.ElementSubOptoinsTreeviewNodes:Add(self.OOCheckBox)

    -- Character load
    self.CharacterButton = PrimeUITools.PrimeUIOptions.BoolInput(width - 10, "Load on all characters", not data["CharLoad"], function(value)
        if data and self.notChanging then
            data["CharLoad"] = not(value)
            PrimeUIHandlerObject:Refresh(PrimeUIData["Name"], PrimeUIData["PrimeUI"])
        end
    end)

    self.ElementSubOptoinsTreeviewNodes:Add(self.CharacterButton)

    self.characterNode = PrimeUITools.PrimeUIOptions.HeaderNode(width - 10, "> Load for specific character(s)", nil, Turbine.UI.Lotro.Font.BookAntiquaBold19, self.optionExpandBackgroundColour)

    self.childCharacterNodes =  self.characterNode:GetChildNodes()

    self.ElementSubOptoinsTreeviewNodes:Add(self.characterNode)

    self.characterLoadNodes = {}

    for key, _ in spairs(Profiles:GetPreferences(), function(t, a, b) return a < b end) do
        self.characterLoadNodes[key] = PrimeUITools.PrimeUIOptions.BoolInput(width - 10, key, data["CharacterLoad"][key], function(value)
            if data and self.notChanging then
                if not(data["CharacterLoad"]) then data["CharacterLoad"] = {} end
                data["CharacterLoad"][key] = value
                PrimeUIHandlerObject:Refresh(PrimeUIData["Name"], PrimeUIData["PrimeUI"])
            end
        end, self.minorOptionBackgroundColour)
        self.childCharacterNodes:Add(self.characterLoadNodes[key])
    end
end

IOWindow = class(Turbine.UI.Lotro.Window)
function IOWindow:Constructor(options)
    Turbine.UI.Lotro.Window.Constructor(self)
    self:SetSize(800, 800)
    self:SetPosition(math.floor(Turbine.UI.Display.GetWidth() / 2 - (self:GetWidth() / 2)), math.floor(Turbine.UI.Display.GetHeight() / 2 - (self:GetHeight()/2)))
    self:SetVisible(false)
    self:SetText("PrimeUI")

    self.TextBox = Turbine.UI.Lotro.TextBox()
    self.TextBox:SetParent(self)
    self.TextBox:SetSize(780, 720)
    self.TextBox:SetFont(Turbine.UI.Lotro.Font.Arial12)
    --self.TextBox:SetMouseVisible(true)
    self.TextBox:SetPosition(190, 15)
    self.TextBox:SetPosition(10, 40)

    self.SelectButton = Turbine.UI.Lotro.Button()
	self.SelectButton:SetParent(self)
	self.SelectButton:SetSize(100, 20)
	self.SelectButton:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
	self.SelectButton:SetPosition(math.floor(self:GetWidth() / 2 - (100 / 2)), 760)
    self.SelectButton:SetText("Select All")

    self.SelectButton.Click = function()
        self.TextBox:Focus()
        self.TextBox:SelectAll()
    end

    self.ImportButton = Turbine.UI.Lotro.Button()
	self.ImportButton:SetParent(self)
	self.ImportButton:SetSize(100, 20)
	self.ImportButton:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
	self.ImportButton:SetPosition(math.floor(self:GetWidth() / 2 - (100 / 2)), 760)
    self.ImportButton:SetText("Import")

    self.options = options

    self.ImportButton.Click = function()
        local text = self.TextBox:GetText()
        local key, compressed, _ = string.match(text, "<(.*)>%((.*)%)<(.*)>$")
        local result, table
        if compressed then
            table = Compression:StringToTable(compressed)
            self.TextBox:SetText(table)
            if table then result = true end
        else
            result, table = pcall(unpickle, self.TextBox:GetText():gsub("@@", "\n"))
        end
        if result then
            if key == "PrimeUI" or not key then
                if self.options:Add(table) then
                    self:SetVisible(false)
                    ChatOutput("Imported PrimeUI: " .. table["Name"])
                else
                    ChatOutput("Failed to add PrimeUI")
                end
            elseif key == "PrimeUIElement" then
                if self.options:AddElement(table) then
                    self:SetVisible(false)
                    ChatOutput("Added Element to PrimeUI: " .. (table.NickName or table["Type"]))
                else
                    ChatOutput("Failed to add PrimeUIElement")
                end
            end
        else
            ChatOutput("Failed to add PrimeUI: Incorrect PrimeUI string!")
        end
    end
end

function IOWindow:View(data, type)
    self:SetVisible(true)
    self:SetZOrder(100)
    self.TextBox:SetText("")
    if data then
        local key = type or "PrimeUI"
        if false then
            self.TextBox:SetText(string.format("<%s>(%s)<%s>", key, pickle(data):gsub("\n", "@@"), key))
        else
            --TableToString(data, title, self.TextBox)
            --self.TextBox:SetText(pickle(data):gsub("\n", "@@"))
            --local norm = pickle(data):gsub("\n", "@@")
            self.TextBox:SetText(string.format("<%s>(%s)<%s>", key, Compression:TableToString(data), key))
            --self.TextBox:SetText(sTable)
            --local teststring = ".QJ\\;CbkLa>b:UbZ0SZf;QF`:Q:g9QIl/.9l/N6b:mf9.NYl5.7imOb0mN^0mOj0mOf0mP.00]fO.]fO.]fQ.]fS.]fR.]fU.]fY.]fP.]fP.SZ_:ABg<=f7.Q:d9QMl3^9l/^6bmO^0mPj0mQ20mQ60mQ>0:0fgmQV0;1El5.9l9>9l7N9l@>9l8N9l@^9l8>9lAN9l9.9l@N9lB>9lA.9lBN9lA^9lA>9lB.9lBN9lC^9lC.9lB^9lCN9lA^7I6RS[J4C\\G4S\\G`/0I4ShLT3`G09l?.6dmQb06RelI^7Y64kT62?cJdObFD_P^iWYmU60mNB0mNJ0;mgb.]gN.]gP.]gQ.]gS.]gU.R3dmV:0FDgQH4ElP>9l4>6fmRJ0mSZ0mSB0mX.0mWj0mPF0"
            --self.TextBox:SetText(compression:Decompress(Text2Bin(teststring)))
        end

        self.ImportButton:SetVisible(false)
        self.SelectButton:SetVisible(true)
    else
        self.ImportButton:SetVisible(true)
        self.SelectButton:SetVisible(false)
    end
end

CodeWindow = class(Turbine.UI.Lotro.Window)
function CodeWindow:Constructor(options)
    Turbine.UI.Lotro.Window.Constructor(self)
    self:SetSize(800, 800)
    self:SetPosition(math.floor(Turbine.UI.Display.GetWidth() / 2 - (self:GetWidth() / 2)), math.floor(Turbine.UI.Display.GetHeight() / 2 - (self:GetHeight()/2)))
    self:SetVisible(false)
    self:SetText("Edit Code")
    self:SetZOrder(99)

    self.TextBox = Turbine.UI.Lotro.TextBox()
    self.TextBox:SetParent(self)
    self.TextBox:SetSize(780, 720)
    self.TextBox:SetFont(Turbine.UI.Lotro.Font.Verdana16)
    --self.TextBox:SetMouseVisible(true)
    self.TextBox:SetPosition(190, 15)
    self.TextBox:SetPosition(10, 40)

    self.SaveButton = Turbine.UI.Lotro.Button()
	self.SaveButton:SetParent(self)
	self.SaveButton:SetSize(100, 20)
	self.SaveButton:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
	self.SaveButton:SetPosition(math.floor(self:GetWidth() / 2 - (100 / 2)), 760)
    self.SaveButton:SetText("Save")

    self.options = options

    self.SaveButton.Click = function()
        self.data.Code = self.TextBox:GetText()
        self.func()
        self:SetVisible(false)
    end
end

function CodeWindow:View(data, func)
    self:SetVisible(true)
    self:SetZOrder(100)
    self.data = data
    self.func = func
    self.TextBox:SetText(self.data.Code or "")
end

NewWindow = class(Turbine.UI.Lotro.Window)
function NewWindow:Constructor(options)
    Turbine.UI.Lotro.Window.Constructor(self)
    self:SetSize(300, 100)
    self:SetPosition(math.floor(Turbine.UI.Display.GetWidth() / 2 - (self:GetWidth() / 2)), math.floor(Turbine.UI.Display.GetHeight() / 2 - (self:GetHeight()/2)))
    self:SetVisible(false)
    self:SetText("Add")

    self.TextBox = Turbine.UI.Lotro.TextBox()
    self.TextBox:SetParent(self)
    self.TextBox:SetSize(280, 20)
    self.TextBox:SetFont(Turbine.UI.Lotro.Font.Arial12)
    self.TextBox:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.TextBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    self.TextBox:SetMouseVisible(false)
    self.TextBox:SetPosition(10, 40)

    self.ImportButton = Turbine.UI.Lotro.Button()
	self.ImportButton:SetParent(self)
	self.ImportButton:SetSize(100, 20)
	self.ImportButton:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
	self.ImportButton:SetPosition(math.floor(self:GetWidth() - (130)), 65)
    self.ImportButton:SetText("Add")

    self.ICheckBox = Turbine.UI.Lotro.CheckBox()
	self.ICheckBox:SetParent(self)
	self.ICheckBox:SetSize(100, 20)
	self.ICheckBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
	self.ICheckBox:SetPosition(30, 65)
    self.ICheckBox:SetText("Advanced")
    self.ICheckBox:SetChecked(false)

    self.options = options

    self.ImportButton.Click = function()
        if self.options:CreateNew(tostring(self.TextBox:GetText()), self.ICheckBox:IsChecked()) then
            self:SetVisible(false)
        else
            ChatOutput("Failed to make new PrimeUI: There is already a PrimeUI with that name!")
        end
    end
end

function NewWindow:View()
    self:SetVisible(true)
    self:SetZOrder(100)
    self.TextBox:SetText("")
end

InfoWindow = class(Turbine.UI.Window)
function InfoWindow:Constructor()
    Turbine.UI.Window.Constructor(self)
    self:SetSize(400, 100)
    self:SetVisible(false)
    self:SetMouseVisible(false)
    self:SetBackColor(Turbine.UI.Color(0, 0, 0))

    self.TextBox = Turbine.UI.Label()
    self.TextBox:SetParent(self)
    self.TextBox:SetSize(200, 20)
    self.TextBox:SetPosition(3, 3)
    self.TextBox:SetFont(Turbine.UI.Lotro.Font.Verdana16)
    self.TextBox:SetTextAlignment(Turbine.UI.ContentAlignment.TopLeft)
    --self.TextBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    self.TextBox:SetMouseVisible(false)
    self.TextBox:SetBackColor(Turbine.UI.Color(0.8, 0.125, 0.125, 0.125))
end

function InfoWindow:View(Text)
    self:SetVisible(true)
    local x, y = self:GetMousePosition()
    local oldX, oldY = self:GetPosition()
    self:SetPosition((x + oldX) - 200, y + oldY + 5)
    self:SetZOrder(100)
    self.TextBox:SetText(Text or "No info text available.")
    local length = Text and math.ceil(string.len(Text) / 70) + 1 or 1
    self:SetSize(400, length * 22)
    self.TextBox:SetSize(400 - 6, length * 22 - 6)
end