UIElementHeader = class(Turbine.UI.TreeNode)
function UIElementHeader:Constructor(width, name, nickname, removeFunction, moveFunction, nickNameFunction, updateFunction, outputFunction)
    Turbine.UI.TreeNode.Constructor(self)

    self.width = width
    self.height = 70
    self.borderWidth = 3

    self:SetSize(self.width, self.height)
    self:SetBackColor(Turbine.UI.Color(0.05,0,0.46))

    self.innerBox = Turbine.UI.Control()
    self.innerBox:SetParent(self)
    self.innerBox:SetSize(self.width - 2 * self.borderWidth, self.height - 2 * self.borderWidth)
    self.innerBox:SetPosition(self.borderWidth, self.borderWidth)
    self.innerBox:SetMouseVisible(false)
    self.innerBox:SetBackColor(Turbine.UI.Color(0.22,0.22,0.47))

    self.nameBox = Turbine.UI.Label()
    self.nameBox:SetParent(self)
    self.nameBox:SetSize(self.width - 2 * self.borderWidth, 30)
    self.nameBox:SetPosition(self.borderWidth, self.borderWidth)
    self.nameBox:SetMouseVisible(false)
    self.nameBox:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold24)
    self.nameBox:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.nameBox:SetOutlineColor(Turbine.UI.Color.Black)
    self.nameBox:SetTextAlignment(Turbine.UI.ContentAlignment.TopLeft)
    self.nameBox:SetText(name)

    self.nameTextBox = Turbine.UI.Lotro.TextBox()
    self.nameTextBox:SetParent(self)
    self.nameTextBox:SetSize(250, 20)
    self.nameTextBox:SetPosition(self.borderWidth, self.borderWidth + 40)
    self.nameTextBox:SetMouseVisible(false)
    self.nameTextBox:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold18)
    self.nameTextBox:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.nameTextBox:SetOutlineColor(Turbine.UI.Color.Black)
    self.nameTextBox:SetTextAlignment(Turbine.UI.ContentAlignment.TopLeft)
    self.nameTextBox:SetText(nickname or "Name")

    self.nameTextBox.TextChanged = function()
        nickNameFunction(tostring(self.nameTextBox:GetText()))
    end

    self.upButton = Turbine.UI.Lotro.Button()
	self.upButton:SetParent(self)
	self.upButton:SetSize(200, 20)
	self.upButton:SetPosition(self.width - 200, 25)
    self.upButton:SetText("Move Draw Order Up")

    self.upButton.Click = function()
        moveFunction(true)
    end

    self.downButton = Turbine.UI.Lotro.Button()
	self.downButton:SetParent(self)
	self.downButton:SetSize(200, 20)
	self.downButton:SetPosition(self.width - 200, 45)
    self.downButton:SetText("Move Draw Order Down")

    self.downButton.Click = function()
        moveFunction(false)
    end

    self.removeButton = Turbine.UI.Lotro.Button()
	self.removeButton:SetParent(self)
	self.removeButton:SetSize(60, 40)
	self.removeButton:SetPosition(self.width - 60 - self.borderWidth, self.borderWidth)
    self.removeButton:SetText("Delete")

    self.removeButton.Click = function()
        removeFunction()
    end

    self.updateButton = Turbine.UI.Lotro.Button()
	self.updateButton:SetParent(self)
	self.updateButton:SetSize(60, 40)
	self.updateButton:SetPosition(self.width - 200, self.borderWidth)
    self.updateButton:SetText("Update")

    self.updateButton.Click = function()
        updateFunction()
    end

    self.outputButton = Turbine.UI.Lotro.Button()
	self.outputButton:SetParent(self)
	self.outputButton:SetSize(80, 40)
	self.outputButton:SetPosition(self.width - 140, self.borderWidth)
    self.outputButton:SetText("Output")

    self.outputButton.Click = function()
        outputFunction()
    end
end

UIElementHeaderControl = class(Turbine.UI.Control)
function UIElementHeaderControl:Constructor(width, name, nickname, removeFunction, moveFunction, nickNameFunction, updateFunction, outputFunction)
    Turbine.UI.Control.Constructor(self)

    self.width = width
    self.borderWidth = 3
    self.height = 60 + 2 * self.borderWidth


    self:SetSize(self.width, self.height)
    self:SetBackColor(Turbine.UI.Color.Black)

    self.innerBox = Turbine.UI.Control()
    self.innerBox:SetParent(self)
    self.innerBox:SetMouseVisible(false)
    self.innerBox:SetBackColor(Turbine.UI.Color.SteelBlue)

    self.nameBox = Turbine.UI.Label()
    self.nameBox:SetParent(self)
    self.nameBox:SetMouseVisible(false)
    self.nameBox:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold22)
    self.nameBox:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.nameBox:SetOutlineColor(Turbine.UI.Color.Black)
    self.nameBox:SetTextAlignment(Turbine.UI.ContentAlignment.TopLeft)
    self.nameBox:SetText(name)

    self.nameTextBox = Turbine.UI.Lotro.TextBox()
    self.nameTextBox:SetParent(self)
    self.nameTextBox:SetMouseVisible(false)
    self.nameTextBox:SetFont(Turbine.UI.Lotro.Font.BookAntiqua16)
    self.nameTextBox:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.nameTextBox:SetOutlineColor(Turbine.UI.Color.Black)
    self.nameTextBox:SetTextAlignment(Turbine.UI.ContentAlignment.TopLeft)
    self.nameTextBox:SetText(nickname or "Name")

    self.nameTextBox.TextChanged = function()
        nickNameFunction(tostring(self.nameTextBox:GetText()))
    end

    self.optionsBoxesTreeview = Turbine.UI.TreeView()
    self.optionsBoxesTreeview:SetParent(self)
    self.optionsBoxesTreeview:SetSize(self.width, 20)
    self.optionsBoxesTreeview:SetPosition(0, 40)
    self.optionsBoxesTreeview:SetIndentationWidth(0)

    self.optionsBoxesTreeviewNodes = self.optionsBoxesTreeview:GetNodes()

    self.optionsListboxNode = PrimeUITools.PrimeUIOptions.OptionsHeader(self.optionsBoxesTreeview:GetWidth(), 4, true)

    self.optionsBoxesTreeviewNodes:Add(self.optionsListboxNode)

    self.upButton = PrimeUITools.PrimeUIOptions.OptionsListBoxButton(math.floor(self.optionsBoxesTreeview:GetWidth() / 4), 20, "Move Up", function()
        moveFunction(true)
    end)

    self.optionsListboxNode:AddItem(self.upButton)


    self.downButton = PrimeUITools.PrimeUIOptions.OptionsListBoxButton(math.floor(self.optionsBoxesTreeview:GetWidth() / 4), 20, "Move Down", function()
        moveFunction(false)
    end)
    self.optionsListboxNode:AddItem(self.downButton)

    self.removeButton = Turbine.UI.Lotro.Button()
	self.removeButton:SetParent(self)
    self.removeButton:SetText("Delete")

    self.removeButton.Click = function()
        removeFunction()
    end

    self.updateButton = PrimeUITools.PrimeUIOptions.OptionsListBoxButton(math.floor(self.optionsBoxesTreeview:GetWidth() / 4), 20, "Update", function()
        updateFunction()
    end)
    self.optionsListboxNode:AddItem(self.updateButton)

    self.outputButton = PrimeUITools.PrimeUIOptions.OptionsListBoxButton(math.floor(self.optionsBoxesTreeview:GetWidth() / 4), 20, "Output", function()
        outputFunction()
    end)
    self.optionsListboxNode:AddItem(self.outputButton)

    self.SizeChanged = function()
        self.width = self:GetWidth()
        self:Format()
    end

    self:Format()
end

function UIElementHeaderControl:Select()
    self.innerBox:SetBackColor(Turbine.UI.Color.SlateBlue)
end

function UIElementHeaderControl:Unselect()
    self.innerBox:SetBackColor(Turbine.UI.Color.SteelBlue)
end

function UIElementHeaderControl:Format()
    self.innerBox:SetSize(self.width - 2 * self.borderWidth, self.height - 2 * self.borderWidth)
    self.innerBox:SetPosition(self.borderWidth, self.borderWidth)

    self.nameBox:SetSize(self.width - 2 * self.borderWidth, 20)
    self.nameBox:SetPosition(self.borderWidth, self.borderWidth)

    self.nameTextBox:SetSize(150, 20)
    self.nameTextBox:SetPosition(self.borderWidth, self.borderWidth + 20)

    self.optionsBoxesTreeview:SetSize(self.width, 20)

    local buttonSize = math.floor(self.optionsBoxesTreeview:GetWidth() / 4)
    self.upButton:SetSize(buttonSize, 20)
    self.downButton:SetSize(buttonSize, 20)
    self.updateButton:SetSize(buttonSize, 20)
    self.outputButton:SetSize(buttonSize, 20)

    self.removeButton:SetSize(60, 20)
	self.removeButton:SetPosition(240, self.borderWidth)
end

function UIElementHeaderControl:Unload()
    self.optionsListboxNode:Unload()
    self.upButton = nil
    self.downButton = nil
    self.updateButton = nil
    self.outputButton = nil
    self.optionsBoxesTreeviewNodes:Clear()
    self.optionsBoxesTreeview:SetParent(nil)
    self.nameTextBox:SetParent(nil)
    self.nameBox:SetParent(nil)
    self.innerBox:SetParent(nil)
end
