AllSkillOverview = class(Turbine.UI.Window)
function AllSkillOverview:Constructor()
    Turbine.UI.Window.Constructor(self)
    self:SetSize(500, 400)
    self:SetPosition(300, 215)
    self:SetVisible(false)
    self:SetBackColor(Turbine.UI.Color(0, 0, 0))

    self.VisibleChanged = function()
        if self:IsVisible() then
            self:SetZOrder(100)
            local x, y = self:GetMousePosition()
            local oldX, oldY = self:GetPosition()
            self:SetPosition((x + oldX) - 250, y + oldY + 5)
        end
    end

    self.HistoricalEffectsWindowHeaderLabel = Turbine.UI.Label()
    self.HistoricalEffectsWindowHeaderLabel:SetParent(self)
    self.HistoricalEffectsWindowHeaderLabel:SetSize(500 - 2, 20 - 1)
    self.HistoricalEffectsWindowHeaderLabel:SetPosition(1, 1)
    --self.HistoricalEffectsWindowHeaderLabel:SetMouseVisible(false)
    --self.HistoricalEffectsWindowHeaderLabel:SetTextAlignment(Turbine.UI.ContentAlignment.LeftCenter)
    self.HistoricalEffectsWindowHeaderLabel:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    self.HistoricalEffectsWindowHeaderLabel:SetMultiline(true)
    self.HistoricalEffectsWindowHeaderLabel:SetText("Skill selection")

    
    self.Moving = false

    self.HistoricalEffectsWindowHeaderLabel.MouseDown = function(sender,args)
        self.MoveX = args.X
        self.MoveY = args.Y
        self.Moving = true
    end

    self.HistoricalEffectsWindowHeaderLabel.MouseUp = function()
        self.Moving = false
    end

    self.HistoricalEffectsWindowHeaderLabel.MouseMove = function(sender,args)
        if self.Moving then
            local newLeft = self:GetLeft() - (self.MoveX - args.X)
            local newTop = self:GetTop() - (self.MoveY - args.Y)
            self:SetPosition(newLeft,newTop)
        end
    end

    -- Close Button
    self.HistoricalEffectsCloseBackground = Turbine.UI.Control()
    self.HistoricalEffectsCloseBackground:SetParent(self)
    self.HistoricalEffectsCloseBackground:SetPosition(500 - 20, 0)
    self.HistoricalEffectsCloseBackground:SetSize(20, 20)
    self.HistoricalEffectsCloseBackground:SetMouseVisible(true)
    self.HistoricalEffectsCloseBackground:SetBackColor(Turbine.UI.Color(153/255, 0, 0))


    self.HistoricalEffectsCloseBackground.MouseClick = function()
        self:SetVisible(false)
    end

    self.HistoricalEffectsListBox = Turbine.UI.TreeView()
    self.HistoricalEffectsListBox:SetSize(500 - 2, 380 - 2)
    self.HistoricalEffectsListBox:SetPosition(1, 21)
    self.HistoricalEffectsListBox:SetParent(self)
    self.HistoricalEffectsListBox:SetMouseVisible(false)
    self.HistoricalEffectsListBox:SetBackColor(Turbine.UI.Color(0.250, 0.250, 0.250))
    --self.HistoricalEffectsListBox:SetOrientation( Turbine.UI.Orientation.Horizontal )
    --self.HistoricalEffectsListBox:SetMaxColumns(1)

    self.HistoricalEffectsListBoxScrollbar = Turbine.UI.Lotro.ScrollBar()
    self.HistoricalEffectsListBoxScrollbar:SetOrientation(Turbine.UI.Orientation.Vertical)
    self.HistoricalEffectsListBoxScrollbar:SetParent(self)
    self.HistoricalEffectsListBoxScrollbar:SetPosition(500 - 8, 21)
    self.HistoricalEffectsListBoxScrollbar:SetSize(8, 378)
    self.HistoricalEffectsListBox:SetVerticalScrollBar(self.HistoricalEffectsListBoxScrollbar)

    self.rootNodes = self.HistoricalEffectsListBox:GetNodes()

    self.filtering = false

    self.filterFunction = function(object)
        if self.filtering then 
            return not(string.find(string.lower(object.name), string.lower(self.filterKey)))
        else
            return false
        end
    end

    self.sortFunction = function(object1, object2)
        if object1.name >= object2.name then 
            return 1
        else
            return -1
        end
    end

    self.searchBox = Turbine.UI.Lotro.TextBox()
    self.searchBox:SetParent(self)
    self.searchBox:SetSize(250, 19)
    self.searchBox:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
    self.searchBox:SetPosition(250 - 20 - 1, 1)

    self.searchBox.TextChanged = function()
        self.filterKey = self.searchBox:GetText()
        if string.len(self.filterKey) > 0 then
            self.filtering = true
            self.HistoricalEffectsListBox:Refresh()
        else
            self.filtering = false
            self.HistoricalEffectsListBox:Refresh()
        end
    end

    self.HistoricalEffectsListBox:SetFilter(self.filterFunction)
    self.HistoricalEffectsListBox:SetSortMethod(self.sortFunction)


    if SkillEventHandler then
        local duplicates = {}
        local skillCodes = SkillEventHandler:GetSkillCodes()
        for class, classList in pairs(skillCodes) do
            for key, value in spairs(classList, function(t,a,b) return t[a][1] < t[b][1] end) do
                local node = MyTreeNode()
                node:SetSize(492,32)
                node.name = value[1]

                local HistoricalEffects = Turbine.UI.Control()
                HistoricalEffects:SetParent(node)
                HistoricalEffects:SetSize(492,32)
                HistoricalEffects:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
                --HistoricalEffects:SetBackground(value[4])
                HistoricalEffects:SetMouseVisible(true)

                HistoricalEffects.MouseEnter = function()
                    HistoricalEffects:SetBackColor(Turbine.UI.Color(0.5,0.5,0.5))
                end

                HistoricalEffects.MouseLeave = function()
                    HistoricalEffects:SetBackColor(nil)
                end

                local HistoricalEffectsIcon = Turbine.UI.Control()
                HistoricalEffectsIcon:SetSize(32,32)
                HistoricalEffectsIcon:SetParent(HistoricalEffects)
                HistoricalEffectsIcon:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
                HistoricalEffectsIcon:SetBackground(BackgroundHandler:GetBackground(value[2]))
                HistoricalEffectsIcon:SetMouseVisible(false)

                local HistoricalEffectsName = Turbine.UI.Label()
                HistoricalEffectsName:SetSize(492 - 32,32)
                HistoricalEffectsName:SetParent(HistoricalEffects)
                HistoricalEffectsName:SetPosition(32, 0)
                HistoricalEffectsName:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
                HistoricalEffectsName:SetTextAlignment(Turbine.UI.ContentAlignment.TopLeft)
                HistoricalEffectsName:SetFont(Turbine.UI.Lotro.Font.VerdanaBold16)
                HistoricalEffectsName:SetText(value[1])
                HistoricalEffectsName:SetMouseVisible(false)

                HistoricalEffects.MouseClick = function()
                    if self.icontext then
                        self.icontext:SetText(value[1])
                        self.skillCode:SetShortcut(Turbine.UI.Lotro.Shortcut(6, key))
                    end
                    self:SetVisible(false)

                end

                self.rootNodes:Add(node)


            end
        end
    end
end

function AllSkillOverview:Register(icontext, skillCode)
    self.icontext = icontext
    self.skillCode = skillCode
end